﻿function RGB(r, g, b) {
	return (0xff000000 | (r << 16) | (g << 8) | (b));
}

function RGBA(r, g, b, a) {
	return ((a << 24) | (r << 16) | (g << 8) | (b));
}

function on_colors_changed() {
	p.get_colors();
}

function on_font_changed() {
	p.get_font();
}

function on_selection_changed() {
	on_item_focus_change();
}

function on_playlist_switch() {
	on_item_focus_change();
}

function on_playback_new_track() {
	on_item_focus_change();
}

function on_playback_dynamic_info_track() {
	on_item_focus_change();
}

function on_playback_stop() {
	on_item_focus_change();
}

function on_item_focus_change() {
	p.item_focus_change();
}

function on_mouse_leave() {
	if (typeof b == "object") b.leave();
	if (typeof r == "object") r.leave();
	if (typeof s == "object") s.leave();
	if (typeof li == "object") li.leave();
	p.ttd();
}

function panel(name, features) {
	this.item_focus_change = function() {
		switch(this.selection_mode) {
			case 0:
				this.metadb = fb.GetSelection();
				break;
			case 1:
				this.metadb = fb.IsPlaying ? fb.GetNowPlaying() : fb.GetFocusItem();
				break;
			case 2:
				this.metadb = fb.GetFocusItem();
				break;
		}
		if (this.metadb && typeof on_metadb_changed == "function") on_metadb_changed();
	}
	
	this.get_colors = function() {
		if (this.dui) {
			this.textcolour = window.GetColorDUI(0);
			this.textcolour_hl = window.GetColorDUI(2);
			this.backcolour = window.GetColorDUI(1);
		} else {
			this.textcolour = window.GetColorCUI(0);
			this.textcolour_hl = window.GetColorCUI(0);
			this.backcolour = window.GetColorCUI(3);
		}
		window.Repaint();
	}
	
	this.get_font = function() {
		this.font = this.dui ? window.GetFontDUI(0) : window.GetFontCUI(0);
		this.font_name = this.font.Name;
		this.title_font = gdi.Font(this.font_name, 16, 1);
		this.normal_font = gdi.Font(this.font_name, 12);
		this.list_font = gdi.Font(this.font_name, 11);
		this.row_height = this.normal_font.Height;
		window.Repaint();
	}
	
	this.size = function() {
		this.w = window.Width;
		this.h = window.Height;
	}
	
	this.move = function(x, y) {
		this.mx = x;
		this.my = y;
	}
	
	this.rbtn_up = function(x, y) {
		var _menu = window.CreatePopupMenu();
		var _custom_background = window.CreatePopupMenu();
		var _metadb = window.CreatePopupMenu();
		var _sub1 = window.CreatePopupMenu();
		var _sub2 = window.CreatePopupMenu();
		var _sub3 = window.CreatePopupMenu();
		var _sub4 = window.CreatePopupMenu();
		var _sub5 = window.CreatePopupMenu();
		var idx;
		switch(true) {
			case this.check_feature("artreader") && a.trace(x, y):
				_menu.AppendMenuItem(MF_STRING, 1, "Refresh");
				_menu.AppendMenuSeparator();
				_menu.AppendMenuItem(MF_STRING, 2, "Front");
				_menu.AppendMenuItem(MF_STRING, 3, "Back");
				_menu.AppendMenuItem(MF_STRING, 4, "Disc");
				_menu.AppendMenuItem(MF_STRING, 5, "Icon");
				_menu.AppendMenuItem(MF_STRING, 6, "Artist");
				_menu.CheckMenuRadioItem(2, 6, a.id + 2);
				_menu.AppendMenuSeparator();
				_menu.AppendMenuItem(MF_STRING, 15, "Crop");
				_menu.AppendMenuItem(MF_STRING, 16, "Centre");
				_menu.AppendMenuItem(MF_STRING, 17, "Stretch");
				_menu.CheckMenuRadioItem(15, 17, a.type == "crop" ? 15: a.type == "centre" ? 16 : 17);
				_menu.AppendMenuSeparator();
				break;
			//case this.check_feature("cd") && c.trace(x, y):
				//_menu.AppendMenuItem(MF_STRING, 11, "Gloss effect");
				//_menu.CheckMenuItem(11, c.gloss);
				//_menu.AppendMenuItem(MF_STRING, 12, "Shadow effect");
				//_menu.CheckMenuItem(12, c.shadow);
				//_menu.AppendMenuSeparator();
				break;
			case this.check_feature("simple_text") && t.trace(x, y):
				_menu.AppendMenuItem(MF_STRING, 200, "Path to text file");
				_menu.AppendMenuSeparator();
				_menu.AppendMenuItem(MF_STRING, 201, "Fixed width font");
				_menu.CheckMenuItem(201, t.fixed);
				_menu.AppendMenuSeparator();
				break;
			case this.check_feature("lastfm_bio") && t.trace(x, y):
				_menu.AppendMenuItem(l.username.length > 0 && this.metadb ? MF_STRING : MF_GRAYED, 300, "Update");
				_menu.AppendMenuSeparator();
				for (i in t.lastfm_languages) {
					_sub1.AppendMenuItem(MF_STRING, 310 + parseInt(i), t.lastfm_languages[i]);
				}
				_sub1.CheckMenuRadioItem(310, 321, t.lastfm_current_language + 310);
				_sub1.AppendTo(_menu, MF_STRING, "Language");
				_menu.AppendMenuSeparator();
				_menu.AppendMenuItem(MF_STRING, 50, "Last.fm auto-correct");
				_menu.CheckMenuItem(50, l.auto_correct);
				_menu.AppendMenuItem(MF_STRING, 8, "Last.fm username...");
				_menu.AppendMenuSeparator();
				break;
			case this.check_feature("echonest") && li.trace(x, y):
				_menu.AppendMenuItem(MF_STRING, 500, "News");
				_menu.AppendMenuItem(MF_STRING, 501, "Reviews");
				_menu.AppendMenuItem(MF_STRING, 502, "Blogs");
				_menu.CheckMenuRadioItem(500, 502, li.echonest_type + 500);
				_menu.AppendMenuSeparator();
				break;
			case this.check_feature("autoplaylists") && li.trace(x, y):
				_menu.AppendMenuItem(MF_STRING, 600, "Change title...");
				_menu.AppendMenuSeparator();
				for (i = 1; i < 9; i++) {
					_sub1.AppendMenuItem(MF_STRING, i + 600, i);
				}
				_sub1.AppendTo(_menu, MF_STRING, "Save slot");
				_sub1.CheckMenuRadioItem(601, 608, li.autoplaylists_slot + 600)
				_menu.AppendMenuSeparator();
				_sub2.AppendMenuItem(MF_STRING, 610, "run query");
				_sub2.AppendMenuItem(MF_STRING, 611, "do nothing");
				_sub2.CheckMenuRadioItem(610, 611, li.autoplaylists_success ? 610 : 611);
				_sub2.AppendTo(_menu, MF_STRING, "On successful creation/edit");
				for (i = 0; i < li.autoplaylists_deleted_items.length; i++) {
					var temp = li.autoplaylists_deleted_items[i].split("¬");
					_sub3.AppendMenuItem(MF_STRING, i + 620, temp[0]);
				}
				if (li.autoplaylists_deleted_items.length > 0) _sub3.AppendTo(_menu, MF_STRING, "Restore");
				_menu.AppendMenuSeparator();
				_menu.AppendMenuItem(MF_STRING, 650, "Replace exisiting playlists with the same name");
				_menu.CheckMenuItem(650, li.autoplaylists_remove_duplicates);
				_menu.AppendMenuSeparator();
				break;
			case this.check_feature("musicbrainz") && li.trace(x, y):
				_menu.AppendMenuItem(MF_STRING, 700, "Releases");
				_menu.AppendMenuItem(MF_STRING, 701, "URLs");
				_menu.CheckMenuRadioItem(700, 701, li.musicbrainz_type == "releases" ? 700 : 701);
				_menu.AppendMenuSeparator();
				if (li.musicbrainz_type == "releases") {
					_menu.AppendMenuItem(MF_STRING, 702, "Include 'Live' releases");
					_menu.CheckMenuItem(702, li.musicbrainz_live);
					_menu.AppendMenuSeparator();
				}
				break;
			case this.check_feature("lastfm") && li.trace(x, y):
				_menu.AppendMenuItem(l.username.length > 0 && this.metadb ? MF_STRING : MF_GRAYED, 800, "Update");
				_menu.AppendMenuSeparator();
				for (i = 0; i < li.lastfm_types.length; i++) {
					_menu.AppendMenuItem(MF_STRING, 801 + i, li.lastfm_types[i]);
				}
				_menu.CheckMenuRadioItem(801, 805, li.lastfm_type + 801);
				_menu.AppendMenuSeparator();
				if (li.lastfm_type == 0) {
					_menu.AppendMenuItem(li.lastfm_button == "spotify" ? MF_STRING : MF_GRAYED, 810, "Pause playback when launching Spotify");
					_menu.CheckMenuItem(810, li.lastfm_pause);
					_menu.AppendMenuSeparator();
					_sub1.AppendMenuItem(MF_STRING, 811, "Spotify");
					_sub1.AppendMenuItem(MF_STRING, 812, "Autoplaylist");
					_sub1.CheckMenuRadioItem(811, 812, li.lastfm_button == "spotify" ? 811 : 812);
					_sub1.AppendTo(_menu, MF_STRING, "Buttons");
					_menu.AppendMenuSeparator();
				}
				_menu.AppendMenuItem(MF_STRING, 51, "Last.fm auto-correct");
				_menu.CheckMenuItem(51, l.auto_correct);
				_menu.AppendMenuItem(MF_STRING, 8, "Last.fm username...");
				_menu.AppendMenuSeparator();
				break;
			case this.check_feature("lastfm_charts") && li.trace(x, y):
				_menu.AppendMenuItem(l.username.length > 0 ? MF_STRING : MF_GRAYED, 1000, "Update");
				_menu.AppendMenuSeparator();
				for (i = 0; i < li.lastfm_charts_types.length; i++) {
					_menu.AppendMenuItem(MF_STRING, i + 1001, li.lastfm_charts_types[i].ucfirst());
				}
				_menu.CheckMenuRadioItem(1001, 1003, li.lastfm_charts_type + 1001);
				_menu.AppendMenuSeparator();
				for (i = 0; i < li.lastfm_charts_periods_display.length; i++) {
					_menu.AppendMenuItem(MF_STRING, i + 1004, li.lastfm_charts_periods_display[i]);
				}
				_menu.CheckMenuRadioItem(1004, 1009, li.lastfm_charts_period + 1004);
				_menu.AppendMenuSeparator();
				_menu.AppendMenuItem(MF_STRING, 1010, "Bar colour...");
				_menu.AppendMenuSeparator();
				_menu.AppendMenuItem(MF_STRING, 8, "Last.fm username...");
				_menu.AppendMenuSeparator();
				break;
			case this.check_feature("playcount_sync") && b.buttons.ps.trace(x, y):
				_sub1.AppendMenuItem(utils.CheckComponent("foo_customdb", true) && !ps.loved_working && !ps.playcount_working && this.metadb && l.username.length > 0 ? MF_STRING : MF_GRAYED, 1100, "from website");
				_sub1.AppendMenuItem(utils.CheckComponent("foo_customdb", true) && this.fso.FileExists(ps.sql_file) ? MF_STRING : MF_GRAYED, 1101, "from file");
				_sub1.AppendMenuSeparator();
				_sub1.AppendMenuItem(MF_STRING, 1102, "Show console");
				_sub1.CheckMenuItem(1102, ps.show_console);
				_sub1.AppendTo(_menu, MF_STRING, "Library import");
				_menu.AppendMenuSeparator();
				_sub2.AppendMenuItem(MF_STRING, 1103, "Only update tracks in library");
				_sub2.CheckMenuItem(1103, ps.library);
				_sub2.AppendMenuItem(MF_STRING, 52, "Last.fm auto-correct");
				_sub2.CheckMenuItem(52, l.auto_correct);
				_sub2.AppendTo(_menu, MF_STRING, "Auto-updates");
				_menu.AppendMenuSeparator();
				_sub3.AppendMenuItem(MF_STRING, 1104, "Off");
				_sub3.AppendMenuItem(MF_STRING, 1105, "On");
				_sub3.CheckMenuRadioItem(1104, 1105, ps.auto_love ? 1105 : 1104);
				_sub3.AppendMenuSeparator();
				_sub3.AppendMenuItem(ps.auto_love ? MF_STRING : MF_GRAYED, 1106, "Condition");
				_sub3.AppendTo(_menu, MF_STRING, "Automatically love tracks");
				_menu.AppendMenuSeparator();
				_sub4.AppendMenuItem(MF_STRING, 1107, "tango");
				_sub4.AppendMenuItem(MF_STRING, 1108, "silk");
				_sub4.CheckMenuRadioItem(1107, 1108, ps.icon == "tango" ? 1107 : 1108);
				_sub4.AppendTo(_menu, MF_STRING, "Icon");
				_menu.AppendMenuSeparator();
				_menu.AppendMenuItem(MF_STRING, 8, "Last.fm username...");
				_menu.AppendMenuSeparator();
				break;
			case this.check_feature("thumbs") && th.trace(x, y):
			case this.check_feature("images") && im.trace(x, y):
				if (im.mode == "last.fm") {
					_menu.AppendMenuItem(this.metadb ? MF_STRING : MF_GRAYED, 450, "Download artist art from Last.fm");
					_menu.AppendMenuSeparator();
					_sub3.AppendMenuItem(MF_STRING, 451, "Off");
					_sub3.AppendMenuItem(MF_STRING, 452, "Library tracks only");
					_sub3.AppendMenuItem(MF_STRING, 453, "All tracks");
					_sub3.CheckMenuRadioItem(451, 453, im.auto_download == "off" ? 451 : im.auto_download == "library" ? 452 : 453);
					_sub3.AppendTo(_menu, MF_STRING, "Automatic download");
					_sub4.AppendMenuItem(MF_STRING, 461, "1");
					_sub4.AppendMenuItem(MF_STRING, 463, "3");
					_sub4.AppendMenuItem(MF_STRING, 465, "5");
					_sub4.AppendMenuItem(MF_STRING, 470, "10");
					_sub4.AppendMenuItem(MF_STRING, 480, "20");
					_sub4.CheckMenuRadioItem(461, 480, im.limit + 460);
					_sub4.AppendTo(_menu, MF_STRING, "Limit");
				} else {
					_menu.AppendMenuItem(MF_STRING, 442, "Set custom folder...");
				}
				_menu.AppendMenuSeparator();
				_menu.AppendMenuItem(MF_STRING, 403, "Re-scan folder");
				_menu.AppendMenuSeparator();
				if (im.trace(x, y) && im.images.length > 0 && (!this.check_feature("thumbs") || th.mode != "grid")) {
					_menu.AppendMenuItem(MF_STRING, 400, "Open containing folder");
					_menu.AppendMenuItem(MF_STRING, 401, "Open image");
					_menu.AppendMenuItem(MF_STRING, 402, "Delete image");
					_menu.AppendMenuSeparator();
				}
				_sub1.AppendMenuItem(MF_STRING, 410, "Off");
				_sub1.AppendMenuItem(MF_STRING, 415, "5 seconds");
				_sub1.AppendMenuItem(MF_STRING, 420, "10 seconds");
				_sub1.AppendMenuItem(MF_STRING, 430, "20 seconds");
				_sub1.CheckMenuRadioItem(410, 430, im.cycle + 410);
				_sub1.AppendTo(_menu, MF_STRING, "Cycle");
				_menu.AppendMenuSeparator();
				_sub2.AppendMenuItem(MF_STRING, 440, "Last.fm artist art");
				_sub2.AppendMenuItem(MF_STRING, 441, "Custom folder");
				_sub2.CheckMenuRadioItem(440, 441, im.mode == "last.fm" ? 440 : 441);
				//_sub2.AppendTo(_menu, MF_STRING, "Image source");
				_menu.AppendMenuSeparator();
				if (this.check_feature("thumbs")) {
					_sub5.AppendMenuItem(MF_STRING, 1200, "Grid");
					_sub5.AppendMenuItem(MF_STRING, 1201, "Left");
					_sub5.AppendMenuItem(MF_STRING, 1202, "Bottom");
					_sub5.CheckMenuRadioItem(1200, 1202, th.mode == "grid" ? 1200 : th.mode == "left" ? 1201 : 1202);
					_sub5.AppendMenuSeparator();
					_sub5.AppendMenuItem(MF_STRING, 1275, "75px");
					_sub5.AppendMenuItem(MF_STRING, 1300, "100px");
					_sub5.AppendMenuItem(MF_STRING, 1350, "150px");
					_sub5.AppendMenuItem(MF_STRING, 1400, "200px");
					_sub5.AppendMenuItem(MF_STRING, 1450, "250px");
					_sub5.AppendMenuItem(MF_STRING, 1500, "300px");
					_sub5.CheckMenuRadioItem(1275, 1500, th.px + 1200);
					_sub5.AppendTo(_menu, MF_STRING, "Thumbs");
					_menu.AppendMenuSeparator();
				}
				break;
		}
		if (this.check_feature("remap")) {
			_menu.AppendMenuItem(MF_STRING, 7, "Artist field remapping...");
			_menu.AppendMenuSeparator();
		}
		if (this.check_feature("custom_background")) {
			if (!this.dui) _custom_background.AppendMenuItem(MF_STRING, 100, "None");
			_custom_background.AppendMenuItem(MF_STRING, 101, this.dui ? "Use default UI setting" : "Use columns UI setting");
			_custom_background.AppendMenuItem(MF_STRING, 102, "Splitter");
			_custom_background.AppendMenuItem(MF_STRING, 103, "Custom ");
			_custom_background.AppendMenuSeparator();
			_custom_background.AppendMenuItem(this.background_mode == 3 ? MF_STRING : MF_GRAYED, 104, "Set custom colour...");
			_custom_background.CheckMenuRadioItem(101, 103, this.background_mode + 100);
			_custom_background.AppendTo(_menu, MF_STRING, "Background");
			_menu.AppendMenuSeparator();
		}
		if (this.check_feature("metadb")) {
			_metadb.AppendMenuItem(MF_STRING, 900, "Use display preferences");
			_metadb.AppendMenuItem(MF_STRING, 901, "Prefer now playing");
			_metadb.AppendMenuItem(MF_STRING, 902, "Follow selected track");
			_metadb.CheckMenuRadioItem(900, 903, this.selection_mode + 900);
			_metadb.AppendTo(_menu, MF_STRING, "Selection mode");
			_menu.AppendMenuSeparator();
		}
		if (utils.IsKeyPressed(0x10)) _menu.AppendMenuItem(MF_STRING, 9, "Properties");
		_menu.AppendMenuItem(MF_STRING, 10, "Configure...");
		idx = _menu.TrackPopupMenu(x, y);
		switch(idx) {
			case 1:
				on_item_focus_change();
				break;
			case 2:
			case 3:
			case 4:
			case 5:
			case 6:
				a.id = idx - 2;
				window.SetProperty("artreader_id", a.id);
				on_item_focus_change();
				break;
			case 7:
				this.artist_tf = this.InputBox("The default is %artist%\n\nYou can use the full foobar2000 title formatting syntax here.", "Artist field remapping", this.artist_tf);
				if (this.artist_tf == "") this.artist_tf = "%artist%";
				window.SetProperty("artist_tf", this.artist_tf);
				on_item_focus_change();
				break;
			case 8:
				l.username = this.InputBox("Enter your Last.fm username", this.name, l.username);
				this.save(l.username, l.username_file);
				window.NotifyOthers("lastfm_update", 1);
				if (this.check_feature("lastfm_charts")) li.lastfm_charts_load();
				else {
					if (typeof li == "object") li.artist = "";
					if (typeof t == "object") t.artist = "";
					on_item_focus_change();
				}
				window.Repaint();
				break;
			case 9:
				window.ShowProperties();
				break;
			case 10:
				window.ShowConfigure();
				break;
			case 11:
				c.gloss = !c.gloss;
				window.SetProperty("cd_gloss", c.gloss);
				window.RepaintRect(c.x, c.y, c.w, c.h);
				break;
			case 12:
				c.shadow = !c.shadow;
				window.SetProperty("cd_shadow", c.shadow);
				window.RepaintRect(c.x, c.y, c.w, c.h);
				break;
			case 15:
			case 16:
			case 17:
				a.type = idx == 15 ? "crop" : idx == 16 ? "centre" : "stretch";
				window.SetProperty("artreader_image", a.type);
				window.RepaintRect(a.x, a.y, a.w, a.h);
				break;
			case 50:
			case 51:
			case 52:
				l.auto_correct = !l.auto_correct;
				window.SetProperty("lastfm_auto_correct", l.auto_correct);
				if (this.metadb) {
					if (idx == 50) t.get();
					if (idx == 51) li.get();
				}
				break;
			case 100:
			case 101:
			case 102:
			case 103:
				this.background_mode = idx - 100;
				window.SetProperty("background_mode", this.background_mode);
				window.Repaint();
				break;
			case 104:
				this.background_custom_colour = this.InputBox("Enter a custom colour for the background. Uses RGB. Example usage:\n\n234-211-74", this.name, this.background_custom_colour);
				window.SetProperty("background_custom_colour", this.background_custom_colour);
				window.Repaint();
				break;
			case 200:
				t.filename_tf = this.InputBox("Use title formatting to specify a path to your text file. eg: $directory_path(%path%)\\info.txt\n\nThis would open a file named \"info.txt\" in the same folder as the currently playing or selected file.", this.name, t.filename_tf);
				window.SetProperty("text_filename_tf", t.filename_tf);
				on_item_focus_change();
				break;
			case 201:
				t.fixed = !t.fixed;
				window.SetProperty("text_fixed_font", t.fixed);
				t.calc();
				window.RepaintRect(t.x, t.y, t.w, t.h);
				break;
			case 300:
				if (this.metadb) t.get();
				break;
				break;
			case 310:
			case 311:
			case 312:
			case 313:
			case 314:
			case 315:
			case 316:
			case 317:
			case 318:
			case 319:
			case 320:
			case 321:
				t.lastfm_current_language = idx - 310;
				window.SetProperty("lastfm_bio_lastfm_current_language", t.lastfm_current_language);
				if (this.metadb) t.get();
				break;
			case 400:
				this.explorer(im.files[im.index]);
				break;
			case 401:
				this.run(im.files[im.index]);
				break;
			case 402:
				im.delete_image();
				break;
			case 403:
				im.update();
				break;
			case 410:
			case 415:
			case 420:
			case 430:
				im.cycle = idx - 410;
				window.SetProperty("image_cycle", im.cycle);
				break;
			case 440:
			case 441:
				im.mode = idx == 440 ? "last.fm" : "custom";
				window.SetProperty("image_mode", im.mode);
				this.artist = "";
				im.folder = "";
				on_item_focus_change();
				break;
			case 442:
				im.custom_folder_tf = this.InputBox("Enter title formatting or an absolute path to a folder. You can specify multiple folders using | as a separator.", this.name, im.custom_folder_tf);
				window.SetProperty("image_custom_folder_tf", im.custom_folder_tf);
				im.folder = "";
				on_item_focus_change();
				break;
			case 450:
				im.download();
				break;
			case 451:
			case 452:
			case 453:
				im.auto_download = idx == 451 ? "off" : idx == 452 ? "library" : "all";
				window.SetProperty("image_auto_download", im.auto_download);
				break;
			case 461:
			case 463:
			case 465:
			case 470:
			case 480:
				im.limit = idx - 460;
				window.SetProperty("image_limit", im.limit);
				break;
			case 500:
			case 501:
			case 502:
				li.echonest_type = idx - 500;
				window.SetProperty("echonest_type", li.echonest_type);
				li.artist = "";
				on_item_focus_change();
				break;
			case 600:
				li.autoplaylists_title = this.InputBox("Enter a new title", this.name, li.autoplaylists_title);
				if (li.autoplaylists_title == "") li.autoplaylists_title = "Autoplaylists";
				window.SetProperty("autoplaylists_title", li.autoplaylists_title);
				window.Repaint();
				break;
			case 601:
			case 602:
			case 603:
			case 604:
			case 605:
			case 606:
			case 607:
			case 608:
				li.autoplaylists_slot = idx - 600;
				window.SetProperty("autoplaylists_slot", li.autoplaylists_slot);
				li.autoplaylists_file = this.settings_folder + "autoplaylists" + li.autoplaylists_slot;
				li.offset = 0;
				li.autoplaylists_load();
				break;
			case 610:
			case 611:
				li.autoplaylists_success = idx == 610 ? true : false;
				window.SetProperty("autoplaylists_success", li.autoplaylists_success);
				break;
			case 620:
			case 621:
			case 622:
			case 623:
			case 624:
			case 625:
			case 626:
			case 627:
				li.autoplaylists_arr.push(li.autoplaylists_deleted_items[idx - 620]);
				if (li.autoplaylists_arr.length > li.rows) li.offset = li.autoplaylists_arr.length - li.rows;
				li.autoplaylists_deleted_items.splice(idx - 620, 1);
				this.save(li.autoplaylists_arr.join("\n"), li.autoplaylists_file);
				window.NotifyOthers("autoplaylists", "update");
				li.autoplaylists_load();
				break;
			case 650:
				li.autoplaylists_remove_duplicates = !li.autoplaylists_remove_duplicates
				window.SetProperty("autoplaylists_remove_duplicates", li.autoplaylists_remove_duplicates);
				break;
			case 700:
			case 701:
				li.musicbrainz_type = idx == 700 ? "releases" : "URLs";
				window.SetProperty("musicbrainz_type", li.musicbrainz_type);
				li.artist = "";
				on_item_focus_change();
				break;
			case 702:
				li.musicbrainz_live = !li.musicbrainz_live;
				window.SetProperty("musicbrainz_live", li.musicbrainz_live);
				li.artist = "";
				on_item_focus_change();
				break;
			case 800:
				li.get();
				break;
			case 801:
			case 802:
			case 803:
			case 804:
			case 805:
				li.lastfm_type = idx - 801;
				window.SetProperty("lastfm_type", li.lastfm_type);
				li.artist = "";
				on_item_focus_change();
				break;
			case 810:
				li.lastfm_pause = !li.lastfm_pause;
				window.SetProperty("lastfm_pause", li.lastfm_pause);
				break;
			case 811:
			case 812:
				li.lastfm_button = idx == 811 ? "spotify" : "auto";
				window.SetProperty("lastfm_button", li.lastfm_button);
				window.RepaintRect(li.x, li.y, li.w, li.h);
				break;
			case 900:
			case 901:
			case 902:
				this.selection_mode = idx - 900;
				window.SetProperty("selection_mode", this.selection_mode);
				on_item_focus_change();
				break;
			case 1000:
				li.get();
				break;
			case 1001:
			case 1002:
			case 1003:
				li.lastfm_charts_type = idx - 1001;
				window.SetProperty("lastfm_charts_type", li.lastfm_charts_type);
				li.lastfm_charts_load();
				break;
			case 1004:
			case 1005:
			case 1006:
			case 1007:
			case 1008:
			case 1009:
				li.lastfm_charts_period = idx - 1004;
				window.SetProperty("lastfm_charts_period", li.lastfm_charts_period);
				li.lastfm_charts_load();
				break;
			case 1010:
				li.lastfm_charts_bar_colour = this.InputBox("Enter a custom colour for the bars. Uses RGB. Example usage:\n\n234-211-74", this.name, li.lastfm_charts_bar_colour);
				window.SetProperty("lastfm_charts_bar_colour", li.lastfm_charts_bar_colour);
				window.Repaint();
				break;
			case 1100:
				if (ps.show_console) fb.ShowConsole();
				ps.loved_page_errors = 0;
				ps.playcount_page_errors = 0;
				ps.errors = 0;
				ps.pages = 0;
				ps.r = 1;
				ps.sql = "BEGIN TRANSACTION;\n";
				ps.loved_working = true;
				ps.sync_loved(1);
				break;
			case 1101:
				ps.import_sql();
				break;
			case 1102:
				ps.show_console = !ps.show_console;
				window.SetProperty("playcount_sync_show_console", ps.show_console);
				break;
			case 1103:
				ps.library = !ps.library;
				window.SetProperty("playcount_sync_library", ps.library);
				break;
			case 1104:
			case 1105:
				ps.auto_love = idx == 1104 ? false : true;
				window.SetProperty("playcount_sync_auto_love", ps.auto_love);
				break;
			case 1106:
				ps.auto_love_tf = this.InputBox("The result of the title formatting set here must equal 1 for a track to be automatically loved.\n\nExample:\n\n$ifequal(%rating%,5,1,0)", this.name, ps.auto_love_tf);
				window.SetProperty("playcount_sync_auto_love_tf", ps.auto_love_tf);
				break;
			case 1107:
			case 1108:
				ps.icon = idx == 1107 ? "tango" : "silk";
				window.SetProperty("playcount_sync_icon", ps.icon);
				b.update();
				break;
			case 1200:
			case 1201:
			case 1202:
				th.mode = idx == 1200 ? "grid" : idx == 1201 ? "left" : "bottom";
				window.SetProperty("thumbs_mode", th.mode);
				th.calc();
				window.Repaint();
				break;
			case 1275:
			case 1300:
			case 1350:
			case 1400:
			case 1450:
			case 1500:
				th.px = idx - 1200;
				window.SetProperty("thumbs_px", th.px);
				th.calc();
				window.Repaint();
				break;
		}
		_menu.Dispose();
		_custom_background.Dispose();
		_metadb.Dispose();
		_sub1.Dispose();
		_sub2.Dispose();
		_sub3.Dispose();
		_sub4.Dispose();
		_sub5.Dispose();
	}
	
	this.features_init = function() {
		for (i = 0; i < this.features.length; i++) {
			switch(this.features[i]) {
				case "custom_background":
					this.background_mode = window.GetProperty("background_mode", 1);
					this.background_custom_colour = window.GetProperty("background_custom_colour", "255-0-0");
					break;
				case "metadb":
					this.selection_mode = window.GetProperty("selection_mode", 0);
					this.metadb = fb.GetFocusItem();
					break;
				case "themed_buttons":
					this.theme = window.CreateThemeManager("Button");
					break;
				case "remap":
					this.artist_tf = window.GetProperty("artist_tf", "%artist%");
			}
		}
	}
	
	this.eval = function(tf) {
		if (!this.metadb) return "";
		if (fb.IsPlaying && this.metadb.RawPath.indexOf("file://") != 0) {
			return fb.TitleFormat(tf).Eval();
		} else {
			return fb.TitleFormat(tf).EvalWithMetadb(this.metadb);
		}
	}
	
	this.read = function(filename) {
		return utils.ReadTextFile(filename);
	}
	
	this.save = function(t, f) {
		try {
			var ts = this.fso.OpenTextFile(f, 2, true, -1);
			ts.WriteLine(t);
			ts.close();
		} catch(err) {
		}
	}
	
	this.console = function(message) {
		fb.trace(this.name + ": " + message);
	}
	
	this.strip_tags = function(value) {
		try {
			this.doc.open();
			var div = this.doc.createElement("div");
			div.innerHTML = value.replace(/\n/g, "<br>");
			return div.innerText;
		} catch(err) {
			return "Error reading content.";
		}
	}
	
	this.addCommas = function(v) {
		var n = "";
		while(v.length > 3) {
			n = "," + v.substring(v.length - 3) + n;
			v = v.substring(0, v.length - 3);
		}
		return(v + n);
	}
	
	this.InputBox = function(prompt, title, value) {
		prompt = prompt.replace(/"/g, '" + Chr(34) + "');
		prompt = prompt.replace(/\n/g, '" + Chr(13) + "');
		title = title.replace(/"/g, '" + Chr(34) + "');
		value = value.replace(/"/g, '" + Chr(34) + "');
		var temp_value = this.vb.eval('InputBox' + '("' + prompt + '", "' + title + '", "' + value + '")');
		return typeof temp_value == "undefined" ? value : temp_value.trim();
	}
	
	this.MsgBox = function(prompt, buttons, title) {
		prompt = prompt.replace(/"/g, '" + Chr(34) + "');
		prompt = prompt.replace(/\n/g, '" + Chr(13) + "');
		title = title.replace(/"/g, '" + Chr(34) + "');
		return this.vb.eval('MsgBox' + '("' + prompt + '", "' + buttons + '", "' + title + '")');
	}
	
	this.check_feature = function(f) {
		for (i = 0; i < features.length; i++) {
			if (features[i] == f) return true;
		}
		return false;
	}
	
	this.browser = function(command) {
		try {
			this.WshShell.Run(command);
		} catch (err) {
			this.MsgBox("Unable to launch your default browser.", 0, this.name);
		}
	}
	
	this.explorer = function(path) {
		try {
			this.WshShell.Run("explorer /select," + path);
		} catch(err) {
		}
	}
	
	this.run = function(command) {
		try {
			this.WshShell.Run(command);
		} catch(err) {
		}
	}
	
	this.tt = function(t) {
		if (this.tooltip.Text != t) {
			this.tooltip.Text = t;
			this.tooltip.Activate();
		}
	}
	
	this.ttd = function() {
		this.tooltip.Text = "";
		this.tooltip.Deactivate();
	}
	
	this.draw_background = function(gr) {
		if (this.check_feature("custom_background")) {
			switch(this.background_mode) {
				case 0:
					col = null;
					break;
				case 1:
					col = this.backcolour;
					break;
				case 2:
					col = utils.GetSysColor(15);
					break;
				case 3:
					temp_col = this.background_custom_colour.split("-");
					col = RGB(temp_col[0], temp_col[1], temp_col[2]);
					break;
			}
			if (col) gr.FillSolidRect(0, 0, this.w, this.h, col);
		} else {
			gr.FillSolidRect(0, 0, this.w, this.h, this.backcolour);
		}
	}
	
	this.draw_image = function(gr, img, pos_x, pos_y, width, height, type, border, alpha) {
		if (!img) return;
		gr.SetInterpolationMode(6);
		switch(type) {
			case "crop":
			case "crop top":
				var sr = img.Width / img.Height;
				var dr = width / height;
				if (sr < dr) {
					var r = img.Width / width;
					var ch = height * r;
					var sy = type == "crop top" ? 0 : Math.round((img.Height - ch) / 2);
					var cw = img.Width;
					var sx = 0;
				} else {
					var r = img.Height / height;
					var cw = width * r;
					var sx = Math.round((img.Width - cw) / 2);
					var ch = img.Height;
					var sy = 0;
				}
				gr.DrawImage(img, pos_x, pos_y, width, height, sx, sy, cw, ch, 0, alpha || 255);
				if (border) gr.DrawRect(pos_x, pos_y, width - 1, height - 1, 1, border);
				break;
			case "stretch":
				gr.DrawImage(img, pos_x, pos_y, width, height, 0, 0, img.Width, img.Height, 0, alpha || 255);
				if (border) gr.DrawRect(pos_x, pos_y, width - 1, height - 1, 1, border);
				break;
			case "centre":
			default:
				var s = Math.min(width / img.Width, height / img.Height);
				var nw = Math.round(img.Width * s);
				var nh = Math.round(img.Height * s);
				pos_x += Math.round((width - nw) / 2);
				pos_y += Math.round((height - nh) / 2);
				gr.DrawImage(img, pos_x, pos_y, nw, nh, 0, 0, img.Width, img.Height, 0, alpha || 255);
				if (border) gr.DrawRect(pos_x, pos_y, nw - 1, nh - 1, 1, border);
				break;
		}
	}
	
	this.header = function(gr, text) {
		this.left_text(gr, text, this.title_font, this.textcolour_hl, 6, 6, this.w - 77, 24);
		gr.DrawLine(6, 29, this.w - 6, 29, 1, this.textcolour_hl);
	}
	
	this.centre_text = function(gr, text, font, colour, x, y, w, h) {
		gr.GdiDrawText(text, font, colour, x, y, w, h, DT_VCENTER | DT_CENTER | DT_WORDBREAK | DT_CALCRECT | DT_NOPREFIX);
	}
	
	this.left_text = function(gr, text, font, colour, x, y, w, h) {
		gr.GdiDrawText(text, font, colour, x, y, w, h, DT_VCENTER | DT_END_ELLIPSIS | DT_CALCRECT | DT_NOPREFIX);
	}
	
	this.right_text = function(gr, text, font, colour, x, y, w, h) {
		gr.GdiDrawText(text, font, colour, x, y, w, h, DT_VCENTER | DT_RIGHT | DT_END_ELLIPSIS | DT_CALCRECT | DT_NOPREFIX);
	}
	
	this.name = name;
	this.features = features;
	this.dui = window.InstanceType;
	this.script_path = fb.ProfilePath + "marc2003\\";
	this.images_path = this.script_path + "images\\";
	this.tooltip = window.CreateTooltip();
	this.tracking_mouse = false;
	this.w = 0;
	this.h = 0;
	this.mx = 0;
	this.my = 0;
	this.metadb = fb.GetFocusItem();
	this.WshShell = new ActiveXObject("WScript.Shell");
	this.fso = new ActiveXObject("Scripting.FileSystemObject");
	this.xmlDoc = new ActiveXObject("MSXML.DOMDocument");
	this.doc = new ActiveXObject("htmlfile");
	this.vb = new ActiveXObject("ScriptControl");
	this.vb.Language = "VBScript";
	this.settings_folder = fb.ProfilePath + "wsh_settings\\";
	if (!this.fso.FolderExists(this.settings_folder)) this.fso.CreateFolder(this.settings_folder);
	this.data_folder = fb.ProfilePath + "wsh_lastfm\\";
	if (!this.fso.FolderExists(this.data_folder)) this.fso.CreateFolder(this.data_folder);
	this.artist = "";
	this.artist_tf = "%artist%";
	this.features_init();
	this.get_colors();
	this.get_font();
}

function artreader(x, y, w, h) {
	this.metadb_changed = function() {
		if (!p.metadb) return;
		this.img && this.img.Dispose();
		this.img = utils.GetAlbumArtEmbedded(p.metadb.Rawpath, this.id);
		if (this.img) {
			this.path = p.metadb.Path;
			window.RepaintRect(this.x, this.y, this.w, this.h);
		} else {
			utils.GetAlbumArtAsync(window.ID, p.metadb, this.id);
		}
	}
	
	this.get_album_art_done = function(im, ip) {
		this.img = im;
		this.path = ip;
		window.RepaintRect(this.x, this.y, this.w, this.h);
	}
	
	this.trace = function(x, y) {
		return (x > this.x && x < this.x + this.w && y > this.y && y < this.y + this.h);
	}
	
	this.wheel = function(step) {
		if (!this.trace(p.mx, p.my)) return false;
		this.id -= step;
		if (this.id < 0) this.id = 4;
		if (this.id > 4) this.id = 0;
		window.SetProperty("artreader_id", this.id);
		this.metadb_changed();
		return true;
	}
	
	this.move = function(x, y) {
		if (this.trace(x, y)) {
			if (this.img) p.tt("Original size: " + this.img.Width +"x" + this.img.Height + "px");
			return true;
		} else {
			p.ttd();
			return false;
		}
	}
	
	this.lbtn_dblclk = function(x, y) {
		if (!this.trace(x, y)) return false;
		if (this.img) p.explorer(this.path);
		return true;
	}
	
	this.x = x;
	this.y = y;
	this.w = w;
	this.h = h;
	this.id = window.GetProperty("artreader_id", 0);
	this.img = null;
	this.img_path = null;
	this.type = window.GetProperty("artreader_image", "crop");
}

function buttons() {
	this.draw = function(gr) {
		for (i in this.buttons) {
			this.buttons[i].draw(gr);
		}
	}
	
	this.move = function(x, y) {
		this.tmp_btn = null;
		for (i in this.buttons) {
			if (this.buttons[i].trace(x, y)) this.tmp_btn = i;
		}
		if (this.btn == this.tmp_btn) return this.btn;
		if (this.tmp_btn) this.buttons[this.tmp_btn].state("hover");
		if (this.btn) this.buttons[this.btn].state("normal");
		this.btn = this.tmp_btn;
		return this.btn;
	}
	
	this.lbtn_up = function(x, y) {
		if (!this.btn) return false;
		this.buttons[this.btn].lbtn_up(x, y);
		return true;
	}
	
	this.leave = function() {
		if (this.btn) this.buttons[this.btn].state("normal");
		this.btn = null;
	}
	
	this.buttons = [];
	this.btn = null;
}

function button(x, y, w, h, img_src, func, tiptext, themed) {
	this.draw = function (gr) {
		if (this.themed) {
			p.theme.SetPartAndStateId(1, this.hover ? 2 : 0);
			p.theme.DrawThemeBackground(gr, this.x, this.y, this.w, this.h);
			this.img && p.draw_image(gr, this.hover ? this.img_hover : this.img, this.x + Math.round((this.w - this.img.width) / 2), this.y + Math.round((this.h - this.img.Height) / 2), this.img.width, this.img.Height, "centre");
		} else {
			this.img && p.draw_image(gr, this.hover ? this.img_hover : this.img, this.x, this.y, this.w, this.h, "centre");
		}
	}
	
	this.trace = function(x, y) {
		return (x > this.x && x < this.x + this.w && y > this.y && y < this.y + this.h);
	}
	
	this.lbtn_up = function () {
		this.func && this.func(x, y);
	}
	
	this.state = function(s) {
		if (s == "hover") {
			this.hover = true;
			p.tt(this.tiptext);
		} else {
			this.hover = false;
			p.ttd();
		}
		window.RepaintRect(this.x, this.y, this.w, this.h);
	}
	
	this.x = x;
	this.y = y;
	this.w = w;
	this.h = h;
	this.func = func;
	this.tiptext = tiptext;
	this.themed = themed;
	this.img_normal = img_src && img_src.normal ? gdi.Image(p.images_path + img_src.normal) : null;
	this.img_hover = img_src && img_src.hover ? gdi.Image(p.images_path + img_src.hover) : this.img_normal;
	this.img = this.img_normal;
	this.hover = false;
}

function cd(x, y, w, h) {
	this.draw = function(gr) {
		if (this.shadow) p.draw_image(gr, this.shadow_img, this.x, this.y, this.w, this.h, "centre");
		p.draw_image(gr, this.case_img, this.x, this.y, this.w, this.h, "centre");
		if (this.img) {
			this.ratio = Math.min(this.w / this.case_img.Width, this.h / this.case_img.Height)
			this.nx = Math.round((this.w - (this.cw - (this.rim / 2)) * this.ratio) / 2);
			this.ny = Math.round((this.h - (this.ch * this.ratio)) / 2);
			this.nw = this.cw * this.ratio;
			this.nh = this.ch * this.ratio;
			p.draw_image(gr, this.img, this.nx + this.x, this.ny + this.y, this.nw, this.nh, "crop");
		}
		p.draw_image(gr, this.semi_img, this.x, this.y, this.w, this.h, "centre");
		if (this.gloss) p.draw_image(gr, this.gloss_img, this.x, this.y, this.w, this.h, "centre");
	}
	
	this.metadb_changed = function() {
		if (!p.metadb) return;
		this.img && this.img.Dispose();
		this.img = utils.GetAlbumArtEmbedded(p.metadb.Rawpath, 0);
		if (this.img) {
			this.path = p.metadb.Path;
			window.RepaintRect(this.x, this.y, this.w, this.h);
		} else {
			utils.GetAlbumArtAsync(window.ID, p.metadb, 0);
		}
	}
	
	this.get_album_art_done = function(im, ip) {
		this.img = im;
		this.path = ip;
		window.RepaintRect(this.x, this.y, this.w, this.h);
	}
	
	this.trace = function(x, y) {
		return (x > this.x && x < this.x + this.w && y > this.y && y < this.y + this.h);
	}
	
	this.move = function(x, y) {
		if (this.trace(x, y)) {
			if (this.img) p.tt("Original size: " + this.img.Width +"x" + this.img.Height + "px");
			return true;
		} else {
			p.ttd();
			return false;
		}
	}
	
	this.lbtn_dblclk = function(x, y) {
		if (!this.trace(x, y)) return false;
		if (this.img) p.explorer(this.path);
		return true;
	}
	
	this.x = x;
	this.y = y;
	this.w = w;
	this.h = h;
	this.shadow_img = gdi.Image(p.images_path + "shadow.png");
	this.case_img = gdi.Image(p.images_path + "case.png");
	this.semi_img = gdi.Image(p.images_path + "semi.png");
	this.gloss_img = gdi.Image(p.images_path + "gloss.png");
	this.cw = 488;
	this.ch = 476;
	this.rim = 72;
	this.gloss = window.GetProperty("cd_gloss", true);
	this.shadow = window.GetProperty("cd_shadow", true);
	this.img = null;
	this.path = null;
}

function images(x, y, w, h) {
	this.playback_time = function(time) {
		if (this.mode == "last.fm" && time == 1 && this.files.length == 0 && p.metadb.RawPath == fb.GetNowPlaying().RawPath && ((this.auto_download == "library" && fb.IsMetadbInMediaLibrary(p.metadb)) || this.auto_download == "all")) this.download();
		if (this.cycle > 0 && this.images.length > 1 && time % this.cycle == 0) this.wheel(-1);
	}
	
	this.metadb_changed = function() {
		if (!p.metadb) return;
		switch(this.mode) {
			case "last.fm":
				p.temp_artist = p.eval(p.artist_tf);
				if (p.temp_artist == p.artist) return;
				p.artist = p.temp_artist;
				this.folder = p.eval(this.custom_folder_tf);
				//if (!p.fso.FolderExists(this.folder)) p.fso.CreateFolder(this.folder);
				break;
			case "custom":
				this.temp_folder = p.eval(this.custom_folder_tf);
				if (this.temp_folder == this.folder) return;
				this.folder = this.temp_folder;
				break;
		}
		this.update();
	}
	
	this.trace = function(x, y) {
		return (x > this.x && x < this.x + this.w && y > this.y && y < this.y + this.h);
	}
	
	this.wheel = function(step) {
		if (!p.metadb || this.images.length < 2 || !this.trace(p.mx, p.my) || (this.thumbs && th.mode == "grid" && !th.overlay)) return false;
		this.index -= step;
		if (this.index < 0) this.index = this.images.length - 1;
		if (this.index >= this.images.length) this.index = 0;
		window.RepaintRect(this.x, this.y, this.w, this.h);
		return true;
	}
	
	this.lbtn_dblclk = function(x, y) {
		if (!this.trace(x, y) || (this.thumbs && th.mode == "grid")) return false;
		p.run(this.files[this.index]);
		return true;
	}
	
	this.download = function() {
		window.Repaint();
		p.WshShell.Run('"' + p.script_path + 'art.exe" "' + p.artist + '" "' + this.folder + '" ' + this.limit, 0, true);
		this.update();
	}
	
	this.update = function() {
		this.index = 0;
		for (i = 0; i < this.images.length; i++) {
			try { this.images[i].Dispose(); } catch(err) {}
		}
		this.folders = this.folder.split("|");
		this.files = [];
		for (i = 0; i < this.folders.length; i++) {
			if (p.fso.FolderExists(this.folders[i])) this.files = this.files.concat(utils.Glob(this.folders[i] + "\\*.jpg").toArray(), utils.Glob(this.folders[i] + "\\*.jpeg").toArray(), utils.Glob(this.folders[i] + "\\*.png").toArray(), utils.Glob(this.folders[i] + "\\*.gif").toArray());
		}
		this.images = [];
		for (i = 0; i < this.files.length; i++) {
			this.images[i] = gdi.Image(this.files[i]);
		}
		if (this.thumbs) th.calc();
		window.Repaint();
	}
	
	this.delete_image = function() {
		try {
			p.fso.DeleteFile(this.files[this.index]);
			p.console(this.files[this.index] + " deleted ok!");
			this.update();
		} catch(err) {
			p.console("Could not delete " + this.files[this.index]);
		}
	}
	
	this.x = x;
	this.y = y;
	this.w = w;
	this.h = h;
	this.files = [];
	this.images = [];
	this.index = 0;
	this.folder = "";
	this.limit = window.GetProperty("image_limit", 5);
	this.cycle = window.GetProperty("image_cycle", 0);
	this.mode = window.GetProperty("image_mode", "last.fm");
	this.auto_download = window.GetProperty("image_auto_download", "library");
	this.custom_folder_tf = window.GetProperty("image_custom_folder_tf", "$directory_path(%path%)");
	this.thumbs = p.check_feature("thumbs");
}

function lastfm() {
	this.notify_data = function(name, data) {
		if (name == "lastfm_update" && data == 1) {
			this.username = p.read(this.username_file).trim();
			if (p.check_feature("lastfm_charts")) li.lastfm_charts_load();
			if (p.check_feature("playcount_sync")) {
				ps.loved_working = false;
				ps.playcount_working = false;
				b.update();
			}
			if (p.check_feature("lastfm")) {
				li.artist = "";
				on_item_focus_change();
			}
			if (p.check_feature("lastfm_bio")) {
				t.artist = "";
				on_item_focus_change();
			}
			window.Repaint();
		}
	}
	
	this.ws_url = function() {
		return "http://ws.audioscrobbler.com/2.0/?format=json&api_key=56d9e050cc2d6b36102c8b4a5fe6152d" + "&user=" + this.username + "&username=" + this.username + "&s=" + Math.random();
	}
	
	this.username_error = "Use the context menu to set your Last.fm username."
	this.url = "http://www.last.fm/";
	this.username_file = p.settings_folder + "username";
	this.username = p.read(this.username_file).trim();
	this.auto_correct = window.GetProperty("lastfm_auto_correct", true);
	this.user_agent = "foobar2000_wsh_panel_mod_lastfm_scripts_by_marc2003";
}

function list(x, y, w, h) {
	this.size = function() {
		this.but_x = this.x + Math.round((this.w - 15) / 2);
		this.row_height = p.check_feature("echonest") ? 90 : 20;
		this.rows = Math.floor((this.h - 30) / this.row_height)
		this.index = 0;
		this.offset = 0;
		if (this.type == "lastfm_charts") {
			this.sub = Math.round((this.w / 3) * 2);
			this.lastfm_charts_bar_x = this.w - this.sub + 30;
		}
		this.up_btn = new sb(this.but_x, this.y, 15, 15, this.up_img, "li.offset > 0", function() { li.wheel(1); });
		this.down_btn = new sb(this.but_x, this.y + this.h - 15, 15, 15, this.down_img, "li.offset < li.items - li.rows", function() { li.wheel(-1); });
	}
	
	this.draw = function(gr) {
		//gr.DrawRect(this.x, this.y, this.w, this.h, 1, p.textcolour_hl);
		switch(this.type) {
			case "lastfm_charts":
				for (i = 0; i < Math.min(this.items, this.rows); i++) {
					p.right_text(gr, this.ranks[i + this.offset] + ".", p.list_font, p.textcolour_hl, this.x, this.y + 15 + (i *20), 17, 20);
					var max_bar_width = (this.w - this.lastfm_charts_bar_x - 40) / this.playcounts[0];
					var bar_width = max_bar_width * this.playcounts[i + this.offset];
					var bar_colour = this.lastfm_charts_bar_colour.split("-");
					gr.FillSolidRect(this.lastfm_charts_bar_x + this.x, this.y + 16 + (i * 20), bar_width, 18, RGB(bar_colour[0], bar_colour[1], bar_colour[2]));
					p.left_text(gr, p.addCommas(this.playcounts[i + this.offset]), p.list_font, p.textcolour, this.x + 5 + this.lastfm_charts_bar_x + bar_width, this.y + 15 + (i * 20), 50, 20);
					p.left_text(gr, this.names[i + this.offset], p.list_font, p.textcolour, this.x + this.text_x, this.y + 15 + (i * 20), this.w - this.sub, 20);
				}
				break;
			case "lastfm":
				for (i = 0; i < Math.min(this.items, this.rows); i++) {
					if (this.lastfm_type == 0) p.draw_image(gr, this.lastfm_button == "spotify" ? this.lastfm_spotify_img : this.autoplaylist_img, this.x, this.y + 16 + (i * 20), 16, 16, "centre");
					if (this.lastfm_type == 3 || this.lastfm_type == 4) p.draw_image(gr, this.autoplaylist_img, this.x, this.y + 16 + (i * 20), 16, 16, "centre");
					p.left_text(gr, this.names[i + this.offset], p.list_font, p.textcolour, this.x + this.text_x, this.y + 15 + (i * 20), this.w - this.sub, 20);
				}
				break;
			case "musicbrainz":
				for (i = 0; i < Math.min(this.items, this.rows); i++) {
					if (this.musicbrainz_type == "URLs") p.draw_image(gr, this.musicbrainz_images[i + this.offset], this.x, this.y + 16 + (i * 20), 16, 16, "centre");
					if (this.musicbrainz_type == "releases") {
						p.draw_image(gr, this.autoplaylist_img, this.x, this.y + 16 + (i * 20), 16, 16, "centre");
						p.right_text(gr, this.dates[i + this.offset], p.list_font, p.textcolour_hl, this.x, this.y + 15 + (i * 20), this.w, 20);
					}
					p.left_text(gr, this.names[i + this.offset], p.list_font, p.textcolour, this.x + this.text_x, this.y + 15 + (i * 20), this.w - this.sub, 20);
				}
				break;
			case "autoplaylists":
				for (i = 0; i < Math.min(this.items, this.rows); i++) {
					p.left_text(gr, this.names[i + this.offset], p.list_font, p.textcolour, this.x, this.y + 15 + (i * 20), this.w - this.sub, 20);
					if (!this.autoplaylists_editing && this.autoplaylists_hover && this.index == i + this.offset) {
						p.draw_image(gr, this.autoplaylists_edit_img, this.x + this.w - 40, this.y + 16 + (i * 20), 16, 16, "centre");
						p.draw_image(gr, this.autoplaylists_del_img, this.x + this.w - 20, this.y + 16 + (i * 20), 16, 16, "centre");
					}
				}
				break;
			case "echonest":
				for (i = 0; i < Math.min(this.items, this.rows); i++) {
					p.left_text(gr, this.names[i + this.offset], p.title_font, p.textcolour_hl, this.x, this.y + 15 + (i * 90), this.w - 150, 24);
					p.right_text(gr, this.dates[i + this.offset], p.title_font, p.textcolour_hl, this.x, this.y + 15 + (i * 90), this.w, 24);
					gr.GdiDrawText(this.summaries[i + this.offset], p.normal_font, p.textcolour, this.x, this.y + 35 + (i * 90), this.w, p.row_height * 4, DT_WORDBREAK | DT_CALCRECT | DT_NOPREFIX);
				}
				break;
		}
		this.up_btn.draw(gr);
		this.down_btn.draw(gr);
	}
	
	this.metadb_changed = function() {
		p.artist = p.eval(p.artist_tf);
		if (this.artist == p.artist) return;
		this.artist = p.artist;
		this.folder = "image_custom_folder_tf";
		//if (!p.fso.FolderExists(this.folder)) p.fso.CreateFolder(this.folder);
		this.items = 0;
		this.offset = 0;
		this.index = 0;
		this.names = [];
		this.names_widths = [];
		this.urls = [];
		this.dates = [];
		this.queries = [];
		var temp_bmp = gdi.CreateImage(1, 1);
		var temp_gr = temp_bmp.GetGraphics();
		switch(this.type) {
			case "lastfm":
				this.text_x = 0;
				this.filename = this.folder + "\\" + this.lastfm_methods[this.lastfm_type] + ".json";
				if (p.fso.fileExists(this.filename)) {
					this.file = p.fso.Getfile(this.filename);
					this.text = p.read(this.filename);
					this.parsed_data = JSON.parse(this.text);
					switch(true) {
						case this.parsed_data.error > 0:
							p.console(this.text);
							break;
						case this.lastfm_type == 0 && typeof this.parsed_data.similarartists.artist == "object":
							this.text_x = 20;
							this.data = this.parsed_data.similarartists.artist;
							break;
						case this.lastfm_type == 1 && typeof this.parsed_data.toptags.tag == "object":
							this.data = this.parsed_data.toptags.tag;
							break;
						case this.lastfm_type == 2 && typeof this.parsed_data.topfans.user == "object":
							this.data = this.parsed_data.topfans.user;
							break;
						case this.lastfm_type == 3 && typeof this.parsed_data.topalbums.album == "object":
							this.text_x = 20;
							this.data = this.parsed_data.topalbums.album;
							break;
						case this.lastfm_type == 4 && typeof this.parsed_data.toptracks.track == "object":
							this.text_x = 20;
							this.data = this.parsed_data.toptracks.track;
							break;
					}
					this.items = this.data.length;
					for (i = 0; i < this.items; i++) {
						this.names[i] = this.data[i].name;
						this.urls[i] = this.data[i].url;
						this.names_widths[i] = temp_gr.CalcTextWidth(this.names[i], p.list_font);
						if (this.lastfm_type == 0) this.queries[i] = "artist HAS " + this.names[i];
						if (this.lastfm_type == 3) this.queries[i] = "album HAS " + this.names[i] + " OR title HAS " + this.names[i];
						if (this.lastfm_type == 4) this.queries[i] = "title HAS " + this.names[i];
					}
					if (Date.parse(Date()) - Date.parse(this.file.DateLastModified) > ONE_DAY) this.get()
				} else {
					this.get();
				}
				break;
			case "musicbrainz":
				this.filename = this.folder + "\\musicbrainz_" + this.musicbrainz_type + ".xml";
				var temp_arr = [];
				var temp_arr1 = [];
				if (p.fso.fileExists(this.filename)) {
					this.file = p.fso.Getfile(this.filename);
					this.text = p.read(this.filename);
					p.xmlDoc.async = false;
					p.xmlDoc.loadXML(this.text);
					switch(this.musicbrainz_type) {
						case "releases":
							this.musicbrainz_releases = p.xmlDoc.getElementsByTagName("metadata/release-group-list/release-group[@type='Album' or @type='EP' or @type='Single'" + (this.musicbrainz_live ? " or @type='Live']" : "]"));
							this.items = this.musicbrainz_releases.length;
							for (i = 0; i < this.items; i++) {
								try { var temp1 = this.musicbrainz_releases[i].selectSingleNode("title").text; } catch(err) { var temp1 = "??"; }
								try { var temp2 = this.musicbrainz_releases[i].selectSingleNode("first-release-date").text.substring(0,4); } catch(err) { var temp2 = "??"; }
								try { var temp3 = "http://musicbrainz.org/release-group/" + this.musicbrainz_releases[i].attributes[1].nodeValue; } catch(err) { var temp3 = "??"; }
								if (temp2 == "") temp_arr1.push(temp2 + "¬" + temp1 + "¬" + temp3);
								else temp_arr.push(temp2 + "¬" + temp1 + "¬" + temp3);
							}
							temp_arr.sort();
							temp_arr.reverse();
							temp_arr1.sort();
							temp_arr = temp_arr.concat(temp_arr1);
							for (i = 0; i < this.items; i++) {
								var temp = temp_arr[i].split("¬");
								this.dates[i] = temp[0];
								this.names[i] = temp[1];
								this.urls[i] = temp[2];
								this.names_widths[i] = temp_gr.CalcTextWidth(this.names[i], p.list_font);
								this.queries[i] = "album HAS " + this.names[i] + " OR title HAS " + this.names[i];
							}
							break;
						case "URLs":
							this.musicbrainz_images = [];
							this.musicbrainz_urls = p.xmlDoc.getElementsByTagName("metadata/artist/relation-list/relation");
							this.items = this.musicbrainz_urls.length;
							for (i = 0; i < this.items; i++) {
								try {
									this.urls[i] = this.musicbrainz_urls[i].selectSingleNode("target").text;
									switch(this.musicbrainz_urls[i].getAttribute("type")) {
										case "allmusic":
											this.musicbrainz_images[i] = this.musicbrainz_allmusic_img;
											break;
										case "official homepage":
											this.musicbrainz_images[i] = this.musicbrainz_home_img;
											break;
										case "social network":
											if (this.urls[i].indexOf("facebook") > -1) this.musicbrainz_images[i] = this.musicbrainz_facebook_img;
											if (this.urls[i].indexOf("last.fm") > -1) this.musicbrainz_images[i] = this.musicbrainz_lastfm_img;
											break;
										case "myspace":
											this.musicbrainz_images[i] = this.musicbrainz_myspace_img;
											break;
										case "youtube":
											this.musicbrainz_images[i] = this.musicbrainz_youtube_img;
											break;
										case "microblog":
											this.musicbrainz_images[i] = this.musicbrainz_twitter_img;
											break;
										case "BBC Music page":
											this.musicbrainz_images[i] = this.musicbrainz_bbc_img;
											break;
										case "soundcloud":
											this.musicbrainz_images[i] = this.musicbrainz_soundcloud_img;
											break
										case "discogs":
											this.musicbrainz_images[i] = this.musicbrainz_discogs_img;
											break;
										case "wikipedia":
											this.musicbrainz_images[i] = this.musicbrainz_wikipedia_img;
											break;
										case "IMDb":
											this.musicbrainz_images[i] = this.musicbrainz_imdb_img;
											break;
										default:
											this.musicbrainz_images[i] = this.musicbrainz_external_img;
											break;
									}
								} catch(err) {
									this.urls[i] = "";
								}
								this.names[i] = this.urls[i];
								this.names_widths[i] = temp_gr.CalcTextWidth(this.names[i], p.list_font);
							}
							break;
					}
				} else {
					this.get();
				}
				break;
			case "echonest":
				this.filename = this.folder + "\\echonest_" + this.echonest_types[this.echonest_type] + ".json";
				this.summaries = [];
				if (p.fso.fileExists(this.filename)) {
					this.file = p.fso.Getfile(this.filename);
					this.text = p.read(this.filename);
					this.parsed_data = JSON.parse(this.text);
					if (this.parsed_data.response.status.code == 0) {
						this.arr = this.parsed_data.response[this.echonest_types[this.echonest_type]];
						this.items = this.arr.length;
						for (i = 0; i < this.items; i++) {
							try {
								this.names[i] = this.arr[i].name && this.arr[i].name.trim().length > 0 ? p.strip_tags(this.arr[i].name) : "<no title>";
								this.urls[i] = this.arr[i].url.replace(/\\/g,"");
								this.temp_date = (this.arr[i].date_posted || this.arr[i].date_reviewed || this.arr[i].date_found).substring(0, 10);
								this.dates[i] = this.temp_date.substring(8,10) + "-" + this.temp_date.substring(5,7) + "-" + this.temp_date.substring(0,4);
								this.summaries[i] = p.strip_tags(this.arr[i].summary);
							} catch(err) {
								this.names[i] = "Could not read this article";
							}
						}
					}
					if (Date.parse(Date()) - Date.parse(this.file.DateLastModified) > ONE_DAY) this.get();
				} else {
					this.get();
				}
				break;
		}
		temp_bmp.ReleaseGraphics(temp_gr);
		temp_bmp.Dispose();
		temp_gr = null;
		temp_bmp = null;
		window.Repaint();
	}
	
	this.trace = function(x, y) {
		return (x > this.x && x < this.x + this.w && y > this.y && y < this.y + this.h);
	}
	
	this.wheel = function(step) {
		if (!this.trace(p.mx, p.my)) return false;
		if (this.items > this.rows) {
			this.offset -= step * (this.type == "echonest" ? 1 : 3);
			if (this.offset < 0) this.offset = 0;
			if (this.rows + this.offset > this.items) this.offset = this.items - this.rows;
			window.RepaintRect(this.x, this.y, this.w, this.h);
		}
		return true;
	}
	
	this.move = function(x, y) {
		this.index = Math.floor((y - this.y - 15) / this.row_height) + this.offset;
		this.in_range = this.index >= this.offset && this.index < this.offset + Math.min(this.rows, this.items);
		switch(true) {
			case !this.trace(x, y):
				window.SetCursor(IDC_ARROW);
				p.ttd();
				return false;
			case this.type == "autoplaylists" && this.autoplaylists_editing:
			case this.type == "lastfm" && l.username.length == 0:
				window.SetCursor(IDC_ARROW);
				p.ttd();
				break;
			case this.up_btn.trace(x, y):
			case this.down_btn.trace(x, y):
				window.SetCursor(IDC_HAND);
				break;
			case this.type == "musicbrainz" && this.musicbrainz_type == "releases" && this.in_range && x > this.x && x < this.x + 20:
			case this.type == "lastfm" && this.text_x == 20 && this.in_range && x > this.x && x < this.x + 20:
				window.SetCursor(IDC_HAND);
				switch(true) {
					case this.lastfm_type == 0 && this.lastfm_button == "spotify":
						p.tt('spotify:search:"' + this.names[this.index].replace(/\s+/g,"+") + '"');
						break;
					default:
						p.tt("Autoplaylist: " + this.queries[this.index]);
						break;
				}
				break;
			case this.type == "autoplaylists" && this.in_range:
				switch(true) {
					case x > this.x && x < this.x + Math.min(this.names_widths[this.index], this.w - this.sub):
						window.SetCursor(IDC_HAND);
						p.tt('Run "' + this.names[this.index] + '"');
						break;
					case x > this.x + this.w - 40 && x < this.x + this.w - 20:
						window.SetCursor(IDC_HAND);
						p.tt('Edit "' + this.names[this.index] + '"');
						break;
					case x > this.x + this.w - 20 && x < this.x + this.w:
						window.SetCursor(IDC_HAND);
						p.tt('Delete "' + this.names[this.index] + '"');
						break;
					default: 
						window.SetCursor(IDC_ARROW);
						this.leave();
						break;
				}
				this.autoplaylists_hover = true;
				window.RepaintRect(this.x + this.w - 40, this.y + 15, 40, Math.min(this.rows, this.items) * this.row_height);
				break;
			case this.type == "autoplaylists" && !this.in_range && this.autoplaylists_hover:
				window.SetCursor(IDC_ARROW);
				this.leave();
				break;
			case this.type == "echonest" && this.in_range:
			case this.in_range && x > this.x + this.text_x && x < this.x + this.text_x + Math.min(this.names_widths[this.index], this.w - this.sub):
				window.SetCursor(IDC_HAND);
				p.tt(this.urls[this.index]);
				break;
			default:
				window.SetCursor(IDC_ARROW);
				p.ttd();
				break;
		}
		return true;
	}
	
	this.lbtn_up = function(x, y) {
		if (!this.trace(x, y)) return false;
		switch(true) {
			case this.type == "autoplaylists" && this.autoplaylists_editing:
			case this.type == "lastfm" && l.username.length == 0:
			case this.up_btn.lbtn_up(x, y):
			case this.down_btn.lbtn_up(x, y):
				break;
			case this.type == "musicbrainz" && this.musicbrainz_type == "releases" && this.in_range && x > this.x && x < this.x + 20:
			case this.type == "lastfm" && this.text_x == 20 && this.in_range && x > this.x && x < this.x + 20:
				switch(true) {
					case this.lastfm_type == 0 && this.lastfm_button == "spotify":
						try { 
							p.WshShell.run('spotify:search:"' + names[index].replace(/\s+/g,"+") + '"');
							if (fb.IsPlaying && !fb.IsPaused && pause) fb.Pause();
						} catch(err) {
							p.MsgBox("Unable to launch Spotify.", 0, p.name);
						}
						break;
					default:
						fb.CreateAutoPlaylist(fb.PlaylistCount, this.names[this.index], this.queries[this.index]);
						fb.ActivePlaylist = fb.PlaylistCount - 1;
						break;
				}
				break;
			case this.type == "autoplaylists"&& this.in_range:
				switch(true) {
					case x > this.x && x < this.x + Math.min(this.names_widths[this.index], this.w - this.sub):
						this.autoplaylists_run(this.names[this.index], this.queries[this.index], this.sorts[this.index], this.forced[this.index]);
						break;
					case x > this.x + this.w - 40 && x < this.x + this.w - 20:
						this.autoplaylists_edit(x, y);
						break;
					case x > this.x + this.w - 20 && x < this.x + this.w:
						this.autoplaylists_delete();
						break
				}
				break;
			case this.type == "echonest" && this.in_range:
			case this.in_range && x > this.x + this.text_x && x < this.x + this.text_x + Math.min(this.names_widths[this.index], this.w - this.sub):
				p.browser(this.urls[this.index]);
				break;
		}
		return true;
	}
	
	this.leave = function() {
		p.ttd();
		this.autoplaylists_hover = false;
		window.RepaintRect(this.x, this.y, this.w, this.h)
	}
	
	this.get = function() {
		var fn = this.filename;
		var url = "";
		var user_agent = "";
		switch(this.type) {
			case "lastfm_charts":
				if (l.username.length == 0) return(p.console(l.username_error));
				url = l.ws_url() + "&method=user." + this.lastfm_charts_methods[this.lastfm_charts_type] + "&period=" + this.lastfm_charts_periods[this.lastfm_charts_period];
				user_agent = l.user_agent; 
				var func = function() {
					p.save(li.xmlhttp.responsetext, fn); 
					li.lastfm_charts_load();
				}
				break;
			case "lastfm":
				if (l.username.length == 0) return(p.console(l.username_error));
				url = l.ws_url() + "&method=" + this.lastfm_methods[this.lastfm_type] + "&artist=" + encodeURIComponent(p.artist) + "&autocorrect=" + (l.auto_correct ? 1 : 0);
				user_agent = l.user_agent;
				var func = function() {
					p.save(li.xmlhttp.responsetext, fn);
					li.artist = "";
					on_item_focus_change();
				}
				break;
			case "musicbrainz":
				user_agent = "foobar2000_wsh_panel_mod_musicbrainz +http://www.hydrogenaudio.org/forums/index.php?showuser=19379";
				var fn1 = this.folder + "\\MUSICBRAINZ_ARTISTID.txt";
				this.musicbrainz_id = p.eval("[%MUSICBRAINZ_ARTISTID%]");
				if (this.musicbrainz_id.length == 0) this.musicbrainz_id = p.read(fn1);
				if (this.musicbrainz_id.length == 0) {
					url = "http://www.musicbrainz.org/ws/2/artist/?query=artist:" + encodeURIComponent(p.artist.toLowerCase());
					var func = function() {
						var xml = li.xmlhttp.responseXML;
						var ids = xml.getElementsByTagName("metadata/artist-list/artist");
						for (i = 0; i < ids.length; i++) {
							if (p.artist.toLowerCase() == ids[i].firstChild.text.toLowerCase()) {
								var result = ids[i].selectSingleNode("@id").text;
								p.save(result, fn1);
								li.get();
								break;
							}
						}
					}
				} else {
					if (this.musicbrainz_type == "releases") url = "http://www.musicbrainz.org/ws/2/release-group?artist=" + this.musicbrainz_id + "&limit=100&offset=0";
					else url = "http://www.musicbrainz.org/ws/2/artist/" + this.musicbrainz_id + "?inc=url-rels";
					var func = function() {
						p.save(li.xmlhttp.responsetext, fn);
						li.artist = "";
						on_item_focus_change();
					}
				}
				break;
			case "echonest":
				url = "http://developer.echonest.com/api/v4/artist/" + this.echonest_types[this.echonest_type] + "/?name=" + encodeURIComponent(p.artist) + "&api_key=EKWS4ESQLKN3G2ZWV";
				var func = function() {
					p.save(li.xmlhttp.responsetext, fn);
					li.artist = "";
					on_item_focus_change();
				}
				break;
		}
		if (url.length == 0) return;
		this.xmlhttp.open("GET", url, true);
		if (user_agent.length > 0) this.xmlhttp.setRequestHeader('User-Agent', user_agent);
		this.xmlhttp.send();
		this.xmlhttp.onreadystatechange = function() {
			if (li.xmlhttp.readyState == 4) {
				if (li.xmlhttp.status == 200) {
					func();
				} else {
					p.console(li.xmlhttp.responsetext || "HTTP error: " + li.xmlhttp.status);
				}
			}
		}
	}
	
	this.init = function() {
		switch(true) {
			case p.check_feature("lastfm_charts"):
				this.lastfm_charts_load = function() {
					this.filename = this.folder + "\\" + l.username + "_" + this.lastfm_charts_types[this.lastfm_charts_type] + "_" + this.lastfm_charts_periods[this.lastfm_charts_period] + ".json";
					this.items = 0;
					this.offset = 0;
					this.index = 0;
					this.names = [];
					this.names_widths = [];
					this.urls = [];
					this.ranks = [];
					this.playcounts = [];
					var temp_bmp = gdi.CreateImage(1, 1);
					var temp_gr = temp_bmp.GetGraphics();
					if (p.fso.fileExists(this.filename)) {
						this.file = p.fso.Getfile(this.filename);
						this.text = p.read(this.filename);
						this.parsed_data = JSON.parse(this.text);
						switch(true) {
							case this.parsed_data.error == 6:
								p.console("Username not found.");
								break;
							case this.parsed_data.error > 0:
								p.console(this.text);
								break;
							default:
								this.data = this.parsed_data[this.lastfm_charts_methods[this.lastfm_charts_type].substring(3).toLowerCase()][this.lastfm_charts_types[this.lastfm_charts_type]];
								if (typeof this.data == "object") {
									this.items = this.data.length;
									for (i = 0; i < this.items; i++) {
										this.names[i] = this.lastfm_charts_type != 0 ? this.data[i].artist.name + " - " + this.data[i].name : this.data[i].name;
										this.ranks[i] = (i > 0 && this.data[i].playcount == this.data[i - 1].playcount) ? this.ranks[i - 1] : this.data[i]["@attr"].rank;
										this.urls[i] = this.data[i].url;
										this.names_widths[i] = temp_gr.CalcTextWidth(this.names[i], p.list_font);
										this.playcounts[i] = this.data[i].playcount;
									}
								}
						}
						if (Date.parse(Date()) - Date.parse(this.file.DateLastModified) > ONE_DAY) this.get()
					} else {
						this.get()
					}
					temp_bmp.ReleaseGraphics(temp_gr);
					temp_bmp.Dispose();
					temp_gr = null;
					temp_bmp = null;
					window.Repaint();
				}
				
				this.type = "lastfm_charts";
				this.text_x = 20;
				this.lastfm_charts_types = ["artist", "album", "track"];
				this.lastfm_charts_type = window.GetProperty("lastfm_charts_type", 0);
				this.lastfm_charts_methods = ["getTopArtists", "getTopAlbums", "getTopTracks"];
				this.lastfm_charts_periods_display = ["overall", "last 7 days", "1 month", "3 month", "6 month", "12 month"];
				this.lastfm_charts_periods = ["overall", "7day", "1month", "3month", "6month", "12month"];
				this.lastfm_charts_period = window.GetProperty("lastfm_charts_period", 0);
				this.lastfm_charts_bar_colour = window.GetProperty("lastfm_charts_bar_colour", "72-127-221");
				this.folder = p.data_folder + "charts";
				//if (!p.fso.FolderExists(this.folder)) p.fso.CreateFolder(this.folder);
				break;
			case p.check_feature("lastfm"):
				this.type = "lastfm";
				this.lastfm_methods = ["artist.getSimilar", "artist.getTopTags", "artist.getTopFans", "artist.getTopAlbums", "artist.getTopTracks"];
				this.lastfm_types = ["similar artists", "top tags", "top fans", "top albums", "top tracks"];
				this.lastfm_type = window.GetProperty("lastfm_type", 0);
				this.lastfm_button = window.GetProperty("lastfm_button", "spotify");
				this.lastfm_pause = window.GetProperty("lastfm_pause", true);
				this.lastfm_spotify_img = gdi.Image(p.images_path + "spotify.png");
				break;
			case p.check_feature("musicbrainz"):
				this.type = "musicbrainz";
				this.text_x = 20;
				this.musicbrainz_allmusic_img = gdi.Image(p.images_path + "allmusic_small.png");
				this.musicbrainz_external_img = gdi.Image(p.images_path + "external_small.png");
				this.musicbrainz_bbc_img = gdi.Image(p.images_path + "bbc_small.png");
				this.musicbrainz_facebook_img = gdi.Image(p.images_path + "facebook_small.png");
				this.musicbrainz_home_img = gdi.Image(p.images_path + "home_small.png");
				this.musicbrainz_lastfm_img = gdi.Image(p.images_path + "lastfm_small.png");
				this.musicbrainz_twitter_img = gdi.Image(p.images_path + "twitter_small.png");
				this.musicbrainz_soundcloud_img = gdi.Image(p.images_path + "soundcloud_small.png");
				this.musicbrainz_wikipedia_img = gdi.Image(p.images_path + "wikipedia_small.png");
				this.musicbrainz_discogs_img = gdi.Image(p.images_path + "discogs_small.png");
				this.musicbrainz_myspace_img = gdi.Image(p.images_path + "myspace_small.png");
				this.musicbrainz_youtube_img = gdi.Image(p.images_path + "youtube_small.png");
				this.musicbrainz_imdb_img = gdi.Image(p.images_path + "imdb_small.png");
				this.musicbrainz_live = window.GetProperty("musicbrainz_live", false);
				this.musicbrainz_type = window.GetProperty("musicbrainz_type", "releases");
				break;
			case p.check_feature("echonest"):
				this.type = "echonest";
				this.echonest_types = ["news", "reviews", "blogs"];
				this.echonest_type = window.GetProperty("echonest_type", 0);
				this.echonest_url = "http://the.echonest.com/";
				break;
			case p.check_feature("autoplaylists"):
				this.autoplaylists_add = function() {
					if (this.autoplaylists_editing) return;
					this.autoplaylists_editing = true;
					var new_name = p.InputBox("Enter a name for your autoplaylist", p.name, "");
					if (new_name == "") { this.autoplaylists_editing = false; return; }
					var new_query = p.InputBox("Enter your autoplaylist query", p.name, "");
					if (new_query == "") { this.autoplaylists_editing = false; return; }
					var new_sort = p.InputBox("Enter a sort pattern\n\n(optional)", p.name, "");
					var new_force = new_sort.length > 0 ? p.MsgBox("Force sort?", 4, p.name) : 7; 
					this.autoplaylists_arr.push(new_name + "¬" + new_query + "¬" + new_sort + "¬" + new_force)
					if (this.autoplaylists_arr.length > this.rows) this.offset = this.autoplaylists_arr.length - this.rows;
					p.save(this.autoplaylists_arr.join("\n"), this.autoplaylists_file);
					if (this.autoplaylists_success) this.autoplaylists_run(new_name, new_query, new_sort, new_force);
					window.NotifyOthers("autoplaylists", "update");
					this.autoplaylists_load();
					this.autoplaylists_editing = false;
				}
				
				this.autoplaylists_load = function() {
					this.items = 0;
					this.autoplaylists_arr = [];
					this.names = [];
					this.queries = [];
					this.sorts = [];
					this.names_widths = [];
					this.forced = [];
					try {
						this.autoplaylists = p.read(this.autoplaylists_file);
						this.autoplaylists_arr = this.autoplaylists.split(/\r?\n/g);
						this.items = this.autoplaylists_arr.length;
						var temp_bmp = gdi.CreateImage(1, 1);
						var temp_gr = temp_bmp.GetGraphics();
						for (i =0; i < this.items; i++) {
							var temp = this.autoplaylists_arr[i].split("¬");
							this.names[i] = temp[0];
							this.queries[i] = temp[1];
							this.sorts[i] = temp[2];
							this.forced[i] = temp[3];
							this.names_widths[i] = temp_gr.CalcTextWidth(this.names[i], p.list_font);
						}
						temp_bmp.ReleaseGraphics(temp_gr);
						temp_bmp.Dispose();
						temp_gr = null;
						temp_bmp = null;
					} catch(err) {
					}
					window.Repaint();
				}
				
				this.autoplaylists_run = function(n, q, s, f) {
					if (this.autoplaylists_remove_duplicates) {
						i = 0;
						while(i < fb.PlaylistCount) {
							if (fb.GetPlaylistName(i) == n) fb.RemovePlaylist(i);
							else i++;
						}
					}
					fb.CreateAutoPlaylist(fb.PlaylistCount, n, q, s, f == 6 ? true : false);
					fb.ActivePlaylist = fb.PlaylistCount - 1;
				}
				
				this.autoplaylists_edit = function(x, y) {
					var _menu = window.CreatePopupMenu();
					var i = this.index;
					_menu.AppendMenuItem(MF_STRING, 1, "Rename...");
					_menu.AppendMenuItem(MF_STRING, 2, "Edit query...");
					_menu.AppendMenuItem(MF_STRING, 3, "Edit sort pattern...");
					_menu.AppendMenuItem(MF_STRING, 4, "Force Sort");
					_menu.CheckMenuItem(4, this.forced[i] == 6 ? true : false);
					this.autoplaylists_editing = true;
					this.autoplaylists_hover = false;
					window.RepaintRect(this.x + this.w - 40, this.y + 15, 40, Math.min(this.rows, this.items) * this.row_height);
					idx = _menu.TrackPopupMenu(x, y);
					switch(idx) {
						case 0:
							this.autoplaylists_editing = false;
							return;
						case 1:
							var new_name = p.InputBox("Rename your autoplaylist", p.name, this.names[i]);
							if (new_name != "") this.names[i] = new_name;
							break;
						case 2:
							var new_query = p.InputBox("Enter your autoplaylist query", p.name, this.queries[i]);
							if (new_query != "") this.queries[i] = new_query;
							break;
						case 3:
							var new_sort = p.InputBox("Enter a sort pattern\n\n(optional)", p.name, this.sorts[i]);
							this.sorts[i] = new_sort;
							this.forced[i] = new_sort.length > 0 ? p.MsgBox("Force sort?", 4, p.name) : 7; 
							break;
						case 4:
							this.forced[i] = this.forced[i] == 6 ? 7 : 6;
							break;
					}
					_menu.Dispose();
					var temp = this.names[i] + "¬" + this.queries[i] + "¬" + this.sorts[i] + "¬" + this.forced[i];
					if (this.autoplaylists_arr[i] != temp) {
						this.autoplaylists_arr[i] = temp;
						p.save(this.autoplaylists_arr.join("\n"), this.autoplaylists_file);
						if (this.autoplaylists_success) this.autoplaylists_run(this.names[i], this.queries[i], this.sorts[i], this.forced[i]);
						window.NotifyOthers("autoplaylists", "update");
						this.autoplaylists_load();
					}
					this.autoplaylists_editing = false;
				}
				
				this.autoplaylists_delete = function() {
					if (this.offset > 1) this.offset--;
					this.autoplaylists_deleted_items.unshift(this.autoplaylists_arr[this.index]);
					this.autoplaylists_arr.splice(this.index, 1);
					p.save(this.autoplaylists_arr.join("\n"), this.autoplaylists_file);
					window.NotifyOthers("autoplaylists", "update");
					this.autoplaylists_load();
				}
				
				this.type = "autoplaylists";
				this.autoplaylists_del_img = gdi.Image(p.images_path + "cross.png");
				this.autoplaylists_edit_img = gdi.Image(p.images_path + "edit.png");
				this.autoplaylists_hover = false;
				this.autoplaylists_editing = false;
				this.autoplaylists_remove_duplicates = window.GetProperty("autoplaylists_remove_duplicates", true);
				this.autoplaylists_success = window.GetProperty("autoplaylists_success", true);
				this.autoplaylists_title = window.GetProperty("autoplaylists_title", "Autoplaylists");
				this.autoplaylists_slot = window.GetProperty("autoplaylists_slot", 1);
				this.autoplaylists_file = p.settings_folder + "autoplaylists" + this.autoplaylists_slot;
				this.autoplaylists_deleted_items = [];
		}
	}
	
	
	this.x = x;
	this.y = y;
	this.w = w;
	this.h = h;
	this.up_img = gdi.Image(p.images_path + "up.png");
	this.down_img = gdi.Image(p.images_path + "down.png");
	this.index = 0;
	this.offset = 0;
	this.items = 0;
	this.text = "";
	this.artist = "";
	this.text_x = 0;
	this.sub = 50;
	this.autoplaylist_img = gdi.Image(p.images_path + "search_small.png");
	this.xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
	this.init();
}

function playcount_sync(x, y) {
	this.playback_time = function() {
		this.time_elapsed++;
		if (this.time_elapsed == 3 && this.auto_love && fb.TitleFormat(this.auto_love_tf).Eval() == 1 && this.old_userloved == 0) {
			p.console("Automatically loving this track....");
			this.love_track();
		}
		if (this.time_elapsed == this.target_time) {
			if (!this.library || fb.IsMetadbInMediaLibrary(p.metadb)) this.sync_track();
			else p.console("Track not in library. Not updating");
		}
	}

	this.metadb_changed = function() {
		if (!p.metadb) return;
		this.artist = fb.TitleFormat("%artist%").EvalWithMetadb(p.metadb);
		this.track = fb.TitleFormat("%title%").EvalWithMetadb(p.metadb);
		this.old_userloved = fb.TitleFormat("%LASTFM_LOVED_DB%").EvalWithMetadb(p.metadb) == 1 ? 1 : 0;
		this.old_userplaycount = fb.TitleFormat("%LASTFM_PLAYCOUNT_DB%").EvalWithMetadb(p.metadb);
		this.command = "Last.fm " + (this.old_userloved == 1 ? "Unlove" : "Love") + " Track '" + this.track + "' by '" + this.artist + "'";
		this.crc32 = fb.TitleFormat("$crc32($lower(%artist%%title%))").EvalWithMetadb(p.metadb);
		b.update();
	}

	this.playback_new_track = function() {
		this.time_elapsed = 0;
		switch(true) {
			case fb.PlaybackLength == 0:
				this.target_time = 240;
				break;
			case fb.PlaybackLength >= 30:
				this.target_time = Math.min(Math.floor(fb.PlaybackLength / 2), 240);
				break;
			default:
				this.target_time = 5;
				break;
		}
		on_item_focus_change();
	}
	
	this.tf = function(value) {
		value = value.replace(/'/g, "''");
		value = value.replace(/,/g, "','");
		value = value.replace(/\//g, "'/'");
		value = value.replace(/\(/g, "'('");
		value = value.replace(/\)/g, "')'");
		value = value.replace(/\[/g, "'['");
		return (value.replace(/\]/g, "']'"));
	}
	
	this.love_track = function() {
		fb.RunContextCommandWithMetadb(this.command, p.metadb, 8);
		this.sync_track();
	}
	
	this.sync_track = function() {
		switch(true) {
			case this.loved_working || this.playcount_working:
				return;
			case !utils.CheckComponent("foo_customdb", true):
				p.console("Not contacting Last.fm. foo_customdb is missing.");
				return;
			default:
				p.console("Contacting Last.fm....");
				this.get(l.ws_url() + "&method=track.getinfo&artist=" + encodeURIComponent(this.artist) + "&track=" + encodeURIComponent(this.track) + "&autocorrect=" + (l.auto_correct ? 1 : 0), function() {
					ps.update_track(); 
				});
		}
	}
	
	this.get = function(url, func) {
		if (l.username.length == 0) {
			this.loved_working = false;
			this.playcount_working = false;
			p.console(l.username_error);
			return;
		}
		this.xmlhttp.open("GET", url, true);
		this.xmlhttp.setRequestHeader('User-Agent', l.user_agent);
		this.xmlhttp.send();
		this.xmlhttp.onreadystatechange = function() {
			if (ps.xmlhttp.readyState == 4) {
				if (ps.xmlhttp.status == 200) {
					func();
				} else {
					p.console(ps.xmlhttp.responsetext || "HTTP error: " + ps.xmlhttp.status);
				}
			}
		}
	}
	
	this.update_track = function() {
		this.parsed_data = JSON.parse(ps.xmlhttp.responsetext);
		if (this.parsed_data.error > 0) {
			if (this.parsed_data.error == 6) p.console("Artist / track not found.");
			else p.console(ps.xmlhttp.responsetext);
			return;
		}
		p.console("Last.fm responded 'OK'");
		this.userplaycount = this.parsed_data.track.userplaycount > 0 ? ++this.parsed_data.track.userplaycount : 1;
		this.userloved = this.parsed_data.track.userloved == 1 ? 1 : 0;
		if (fb.IsPlaying && this.time_elapsed >= this.target_time && fb.PlaybackLength > 29 && fb.PlaybackLength < 10800) {
			switch(true) {
				case this.userplaycount < this.old_userplaycount:
					p.console("Playcount returned from Last.fm is lower than current value. Not updating.");
					break;
				case this.old_userplaycount == this.userplaycount:
					p.console("No changes found. Not updating.");
					break;
				default:
					fb.RunContextCommandWithMetadb("Customdb Delete Playcount", p.metadb, 8);
					if (this.old_userloved == 1) fb.RunContextCommandWithMetadb("Customdb Love 0", p.metadb, 8);
					var attempt = 0;
					while(fb.TitleFormat("%LASTFM_PLAYCOUNT_DB%").EvalWithMetadb(p.metadb) != this.userplaycount && attempt <= 3) {
						var query1 = '\"INSERT INTO quicktag(url,subsong,fieldname,value) VALUES(\\"' + this.crc32 + '\\",\\"-1\\",\\"LASTFM_PLAYCOUNT_DB\\",\\"' + this.userplaycount + '\\")\";';
						p.WshShell.Run(p.fso.GetFile(p.script_path + "sqlite3.exe").ShortPath + " " + p.fso.GetFile(fb.ProfilePath + "customdb_sqlite.db").ShortPath + " " + query1, 0, true);
						attempt++;
					}
					fb.RunContextCommandWithMetadb("Customdb Refresh", p.metadb, 8);
					break;
			}
		}
		if (this.old_userloved != this.userloved) fb.RunContextCommandWithMetadb("Customdb Love " + this.userloved, p.metadb, 8);
	}
	
	this.sync_loved = function(page) {
		if (this.loved_working == false) return(p.console("Import aborted."));
		this.page = page;
		this.get(l.ws_url() + "&method=user.getlovedtracks&limit=200&page=" + this.page, function() {
			ps.update_loved();
		});
	}
	
	this.update_loved = function() {
		this.parsed_data = JSON.parse(ps.xmlhttp.responsetext);
		if (this.parsed_data.error > 0) {
			this.loved_working = false;
			fb.ShowPopupMessage("There is a problem with the Last.fm web services. Please try again later.\n\n" + ps.xmlhttp.responsetext, p.name);
			return;
		}
		if (this.page == 1) { try { this.pages = this.parsed_data.lovedtracks["@attr"].totalPages; } catch(err) {} }
		if (this.pages > 0 && ps.xmlhttp.responsetext.indexOf('{"lovedtracks":') == 0) {
			for (i = 0; i < this.parsed_data.lovedtracks.track.length; i++) {
				try {
					var data = [];
					data[0] = this.parsed_data.lovedtracks.track[i].artist.name;
					data[1] = this.parsed_data.lovedtracks.track[i].name;
					data[2] = 1;
					if (data.length == 3) {
						p.console(this.r + ": " + data[0] + " - " + data[1]);
						var url = fb.TitleFormat("$crc32($lower(" + this.tf(data[0]) + this.tf(data[1]) + "))").EvalWithMetadb(p.metadb);
						this.sql += 'INSERT OR REPLACE INTO quicktag(url,subsong,fieldname,value) VALUES("' + url + '","-1","LASTFM_LOVED_DB","' + data[2] + '");' + "\n";
						this.r++;
					}
				} catch(err) {
				p.console(err);
					this.errors++;
				}
			}
			p.console("Completed page " + this.page + " of " + this.pages + " (loved tracks)");
		} else {
			this.loved_page_errors++;
		}
		if (this.page < this.pages) {
			this.page++;
			this.sync_loved(this.page);
		} else {
			this.loved_working = false;
			this.playcount_working = true;
			this.pages = 0;
			this.r = 1;
			this.sync_playcount(1);
		}
	}
	
	this.sync_playcount = function(page) {
		if (this.playcount_working == false) return(p.console("Import aborted."));
		this.page = page;
		this.get(l.ws_url() + "&method=library.gettracks&limit=100&page=" + this.page, function() {
			ps.update_playcount();
		});
	}
	
	this.update_playcount = function() {
		this.parsed_data = JSON.parse(ps.xmlhttp.responsetext);
		if (this.parsed_data.error > 0) {
			this.playcount_working = false;
			fb.ShowPopupMessage("There is a problem with the Last.fm web services. Please try again later.\n\n" + ps.xmlhttp.responsetext, p.name);
			return;
		}
		if (this.page == 1) { try { this.pages = this.parsed_data.tracks["@attr"].totalPages; } catch(err) {} }
		if (this.pages > 0 && ps.xmlhttp.responsetext.indexOf('{"tracks":') == 0) {
			for (i = 0; i < this.parsed_data.tracks.track.length; i++) {
				try {
					var data = [];
					data[0] = this.parsed_data.tracks.track[i].artist.name;
					data[1] = this.parsed_data.tracks.track[i].name;
					data[2] = this.parsed_data.tracks.track[i].playcount;
					if (data[2] == 0) {
						this.page = this.pages;
						break;
					}
					if (data.length == 3) {
						p.console(this.r + ": " + data[0] + " - " + data[1] + " " + data[2]);
						var url = fb.TitleFormat("$crc32($lower(" + this.tf(data[0]) + this.tf(data[1]) + "))").EvalWithMetadb(p.metadb);
						this.sql += 'INSERT OR REPLACE INTO quicktag(url,subsong,fieldname,value) VALUES("' + url + '","-1","LASTFM_PLAYCOUNT_DB","' + data[2] + '");' + "\n";
						this.r++;
					}
				} catch(err) {
					this.errors++;
				}
			}
			p.console("Completed page " + this.page + " of " + this.pages + " (playcount)");
		} else {
			this.playcount_page_errors++;
		}
		if (this.page < this.pages) {
			this.page++;
			this.sync_playcount(this.page);
		} else {
			try {
				this.sql += "COMMIT;"
				ts = p.fso.OpenTextFile(this.sql_file, 2, true, 0);
				ts.WriteLine(this.sql);
				ts.close();
				this.import_sql();
			} catch(err) {
			}
			this.playcount_working = false;
			p.console("Loved track page errors: " + this.loved_page_errors + " (200 records are lost for every page that fails.)");
			p.console("Playcount page errors: " + this.playcount_page_errors + " (100 records are lost for every page that fails.)");
			p.console("Individual errors: " + this.errors);
		}
	}
	
	this.import_sql = function() {
		try {
			var cmd_file = p.fso.GetFile(p.script_path + "lastfm_sql.cmd").ShortPath;
			var db_file = p.fso.GetFile(fb.ProfilePath + "customdb_sqlite.db").ShortPath;
			p.run(cmd_file + " " + p.fso.GetFile(p.script_path + "sqlite3.exe").ShortPath + " " + db_file + " " + p.fso.GetFile(this.sql_file).ShortPath);
		} catch(err) {
		}
	}
	
	this.update_button = function() {
		var exclamation = this.icon == "tango" ? "exclamation.png" : "exclamation_small.png";
		var love = this.icon == "tango" ? "love.png" : "love_small.png";
		var love_h = this.icon == "tango" ? "love_h.png" : "love_h_small.png";
		this.size = this.icon == "tango" ? 32 : 20;
		switch(true) {
			case !p.metadb:
				this.n = exclamation;
				this.h = exclamation;
				this.tooltip = "No selection";
				this.func = null;
				break;
			case !utils.CheckComponent("foo_customdb", true):
				this.n = exclamation;
				this.h = exclamation;
				this.tooltip = "The foo_customdb component is not installed. Please refer to the readme.";
				this.func = null;
				break;
			case l.username.length == 0:
				this.n = exclamation;
				this.h = exclamation;
				this.tooltip = l.username_error;
				this.func = null;
				break;
			case !utils.CheckComponent("foo_softplaylists", true):
				this.n = exclamation;
				this.h = exclamation;
				this.tooltip = "The foo_softplaylists component is required to love tracks.";
				this.func = null;
				break;
			default:
				this.n = this.old_userloved == 1 ? love_h : love;
				this.h = this.old_userloved == 1 ? love : love_h;
				this.tooltip = this.command;
				this.func = function() { ps.love_track(); }
				break;
		}
	}
	
	this.x = x;
	this.y = y;
	this.loved_working = false;
	this.playcount_working = false;
	this.sql_file = p.data_folder + "lastfm.sql";
	this.page = 0;
	this.last_page = 0;
	this.auto_love = window.GetProperty("playcount_sync_auto_love", false);
	this.auto_love_tf = window.GetProperty("playcount_sync_auto_love_tf", "");
	this.icon = window.GetProperty("playcount_sync_icon", "tango");
	this.show_console = window.GetProperty("playcount_sync_show_console", true);
	this.library = window.GetProperty("playcount_sync_library", false);
	this.xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
	this.timer = window.SetInterval(function() {
		var temp = ps.page > 1 ? ps.page - 1 : 1;
		if (ps.loved_working && ps.page == ps.last_page) {
			ps.xmlhttp.abort();
			ps.sync_loved(temp);
		} else if (ps.playcount_working && ps.page == ps.last_page) {
			ps.xmlhttp.abort();
			ps.sync_playcount(temp);
		} else {
			ps.last_page = ps.page;
		}
	}, 15000);
}


function rating(x, y, bs) {
	this.draw = function(gr) {
		if (p.metadb) {
			for (i = 1; i < 6; i++) {
				this.img = i > (this.hover ? this.lrating : this.rating) ? this.off_img : this.on_img;
				p.draw_image(gr, this.img, this.x + this.bs * (i - 1), this.y, this.bs, this.bs, "centre");
			}
		}
	}
	
	this.metadb_changed = function() {
		if (!p.metadb) return;
		this.hover = false;
		this.rating = p.eval(this.rating_tf);
		this.tiptext = p.eval(this.tiptext_tf);
		if (this.rating == "?") this.rating = 0;
		this.lrating = this.rating;
		window.RepaintRect(this.x, this.y, this.w, this.bs);
	}
	
	this.trace = function(x, y) {
		return x > this.x - this.bs && x < this.x + (this.bs * 5) && y > this.y && y < this.y + this.bs;
	}
	
	this.move = function(x, y) {
		if (!this.trace(x, y)) {
			if (this.hover) this.leave();
			return false;
		}
		if (p.metadb) {
			if (x > this.x) p.tt(this.tiptext);
			this.hover = true;
			this.lrating = Math.ceil((x - this.x) / this.bs);
			window.RepaintRect(this.x, this.y, this.w, this.bs);
		}
		return true;
	}
	
	this.lbtn_up = function() {
		if (this.check) {
			if (this.lrating != this.rating && this.hover == 1) fb.RunContextCommandWithMetadb("Rating/" + (this.lrating == 0 ? "<not set>" : this.lrating), p.metadb);
		} else {
			p.MsgBox(this.error_text, 0, p.name);
			p.browser("http://www.foobar2000.org/components/view/foo_playcount");
		}
	}
	
	this.leave = function() {
		p.ttd();
		this.hover = false;
		window.RepaintRect(this.x, this.y, this.w, this.bs);
	}
	
	this.x = x;
	this.y = y;
	this.bs = bs;
	this.w = this.bs * 5;
	this.hover = false;
	this.rating = null;
	this.lrating = null;
	this.img = null;
	this.off_img = gdi.Image(p.images_path + "off.png");
	this.on_img = gdi.Image(p.images_path + "on.png");
	this.rating_tf = "%rating%";
	this.check = utils.CheckComponent("foo_playcount", true)
	this.error_text = "This script requires foo_playcount.";
	this.tiptext_tf = this.check ? 'Rate "%title%" by "%artist%"' : this.error_text;
}

function sb(x, y, w, h, img, isVisible, func) {
	this.x = x;
	this.y = y;
	this.w = w;
	this.h = h;
	this.img = img;
	this.isVisible = new Function("return (" + isVisible + ");");
	this.func = func;
	
	this.draw = function(gr) {
		if (this.isVisible()) p.draw_image(gr, this.img, this.x, this.y, this.w, this.h, "centre");
	}
	
	this.trace = function(x, y) {
		return(x > this.x && x < this.x + this.w && y > this.y && y < this.y + this.h && this.isVisible());
	}
	
	this.lbtn_up = function(x, y) {
		if (!this.trace(x, y)) return false;
		this.func && this.func(x, y);
		return true;
	}
}

function seekbar(x, y, w, h) {
	this.draw = function() {
		window.RepaintRect(0, this.y, p.w, this.h);
	}
	
	this.trace = function(x, y) {
		return (x > this.x && x < this.x + this.w && y > this.y && y < this.y + this.h);
	}
	
	this.move = function(x, y) {
		if (this.drag) this.draw();
		if (this.trace(x, y)) {
			if (fb.IsPlaying && fb.PlaybackLength > 0) {
				x -= this.x;
				this.drag_seek = x < 0 ? 0 : x > this.w ? 1 : x / this.w;
				if (!p.tracking_mouse) {
					p.tooltip.Activate();
					p.tooltip.TrackActivate = true;
					p.tracking_mouse = true;
				}
				if (x != this.old_x || y != this.old_y) {
					var t = fb.PlaybackLength * this.drag_seek;
					var h = Math.floor(t / 3600);
					var m = Math.floor((t -= h * 3600) / 60);
					var s = Math.floor(t -= m * 60);
					p.tooltip.Text = (h > 0 ? h + ":" + (m < 10 ? "0" + m : m) : m) + ":" + (s < 10 ? "0" + s : s);
					p.tooltip.TrackPosition(x, y - 20);
					this.old_x = x;
					this.old_y = y;
				}
			}
			return true;
		} else {
			this.leave();
			return false;
		}
	}
	
	this.lbtn_down = function(x, y) {
		if (!this.trace(x, y)) return false;
		if (fb.IsPlaying && fb.PlaybackLength > 0) this.drag = true;
		return true;
	}
	
	this.lbtn_up = function(x, y) {
		if (!this.trace(x, y)) return false;
		if (this.drag) {
			this.drag = false;
			fb.PlaybackTime = fb.PlaybackLength * this.drag_seek;
		}
		return true;
	}
	
	this.leave = function() {
		this.drag = false;
		p.tracking_mouse = false;
		p.tooltip.TrackActivate = false;
	}
	
	this.calc_pos = function() {
		this.pos = this.drag ? this.w * this.drag_seek : this.w * (fb.PlaybackTime / fb.PlaybackLength);
	}
	
	this.x = x;
	this.y = y;
	this.w = w;
	this.h = h;
	this.z = 0;
	this.pos = 0;
	this.drag = false;
	this.drag_seek = 0;
	this.old_x = 0;
	this.old_y = 0;
	this.timer = window.SetInterval(function() {
		s.z = s.z == 0 ? 1 : 0;
		if (!fb.IsPlaying || fb.IsPaused) return;
		s.draw();
	}, 150);
}

function text(x, y, w, h) {
	this.size = function() {
		this.rows = Math.floor((this.h - 30) / p.row_height);
		this.but_x = this.x + Math.round((this.w - 15) / 2);
		this.up_btn = new sb(this.but_x, this.y, 15, 15, this.up_img, "t.offset > 0", function() { t.wheel(1); });
		this.down_btn = new sb(this.but_x, this.y + this.h - 15, 15, 15, this.down_img, "t.offset < t.text_rows - t.rows", function() { t.wheel(-1); });
		this.calc();
	}
	
	this.draw = function(gr, colour) {
		gr.SetTextRenderingHint(5);
		for (i = 0; i < Math.min(this.rows, this.text_rows); i++) {
			gr.GdiDrawText(this.text_array[i + this.offset], this.fixed ? this.fixed_font : p.normal_font, colour || p.textcolour, this.x, 15 + this.y + (i * p.row_height), this.w, p.row_height, DT_CALCRECT | DT_NOPREFIX);
		}
		this.up_btn.draw(gr);
		this.down_btn.draw(gr);
		//gr.DrawRect(this.x, this.y, this.w, this.h, 1, p.textcolour);
	}
	
	this.metadb_changed = function() {
		if (!p.metadb) return;
		switch(this.type) {
			case "simple_text":
				this.temp_filename = p.eval(this.filename_tf);
				if (this.filename == this.temp_filename) return;
				this.text = "";
				this.filename = this.temp_filename;
				this.filenames = this.filename.split("|");
				for(i = 0; i < this.filenames.length; i++) {
					if (p.fso.fileExists(this.filenames[i])) {
						this.text = p.read(this.filenames[i]);
						this.text = this.text.replace(/\t/g, "    ");
						this.calc();
						break;
					}
				}
				window.Repaint();
				break;
			case "lastfm_bio":
				p.artist = p.eval(p.artist_tf);
				if (this.artist == p.artist) return;
				this.artist = p.artist;
				this.folder = "image_custom_folder_tf";
				//if (!p.fso.FolderExists(this.folder)) p.fso.CreateFolder(this.folder);
				this.filename = this.folder + "\\artist.getInfo.json";
				this.stats = "";
				this.text = "";
				this.url = l.url;
				if (p.fso.fileExists(this.filename)) {
					this.file = p.fso.Getfile(this.filename);
					this.text = p.read(this.filename);
					this.parsed_data = JSON.parse(this.text);
					switch(true) {
						case this.parsed_data.error == 6:
							this.text = "Artist not found.";
							break;
						case typeof this.parsed_data.artist == "object":
							this.stats = "Listeners: " + p.addCommas(this.parsed_data.artist.stats.listeners || "0") + ". Total plays: " + p.addCommas(this.parsed_data.artist.stats.playcount || "0") + ". Your plays: " + (p.addCommas(this.parsed_data.artist.stats.userplaycount || "0") + ".");
							this.url = this.parsed_data.artist.url;
							if (this.parsed_data.artist.bio.content.length == 0) {
								this.text = "This artist does not have a biography page on Last.fm.";
							} else {
								this.text = p.strip_tags(this.parsed_data.artist.bio.content);
								this.text = this.text.replace("\r\n\r\nUser-contributed text is available under the Creative Commons By-SA License and may also be available under the GNU FDL.", "");
							}
							break;
						default:
							this.text = "Unexpected Last.fm server error.";
							break;
					}
					if (Date.parse(Date()) - Date.parse(this.file.DateLastModified) > ONE_DAY) {
						this.get();
					}
				} else {
					this.get();
				}
				if (typeof b == "object") {
					b.buttons.but1.func = function() { p.browser(this.url); }
					b.buttons.but1.tiptext = this.url;
				}
				this.calc();
				window.Repaint();
				break;
		}
	}
	
	this.trace = function(x, y) {
		return (x > this.x && x < this.x + this.w && y > this.y && y < this.y + this.h);
	}
	
	this.wheel = function(step) {
		if (!this.trace(p.mx, p.my)) return false;
		if (this.text_rows > this.rows) {
			this.offset -= step * 3;
			if (this.offset < 0) this.offset = 0;
			if (this.offset + this.rows > this.text_rows) this.offset = this.text_rows - this.rows;
			window.RepaintRect(this.x, this.y, this.w, this.h);
		}
		return true;
	}
	
	this.move = function(x, y) {
		switch(true) {
			case !this.trace(x, y):
				window.SetCursor(IDC_ARROW);
				return false;
			case this.up_btn.trace(x, y):
			case this.down_btn.trace(x, y):
				window.SetCursor(IDC_HAND);
				return true;
			default:
				window.SetCursor(IDC_ARROW);
				return false;
		}
	}
	
	this.lbtn_up = function(x, y) {
		if (this.up_btn.lbtn_up(x, y)) return true;
		if (this.down_btn.lbtn_up(x, y)) return true;
		return false;
	}
	
	this.init = function() {
		if (p.check_feature("lastfm_bio")) {
			this.type = "lastfm_bio";
			this.lastfm_languages = ["English", "日本語", "Deutsch", "Español", "Français", "Italiano", "Polski", "Português", "Руccкий", "Türkçe", "Svenska", "简体中文"];
			this.lastfm_current_language = window.GetProperty("lastfm_bio_lastfm_current_language", 0);
			this.lastfm_language_codes = ["en", "jp", "de", "es", "fr", "it", "pl", "pt", "ru", "tr", "sv", "zh"];
		} else if (p.check_feature("simple_text")) {
			this.type = "simple_text";
			this.filename_tf = window.GetProperty("text_filename_tf", "$directory_path(%path%)\\info.txt");
			this.filename = "";
			this.fixed = window.GetProperty("text_fixed_font", false);
		}
	}
	
	this.get = function() {
		if (l.username.length == 0) return(p.console(l.username_error));
		var fn = this.filename;
		var url = l.ws_url() + "&lang=" + this.lastfm_language_codes[this.lastfm_current_language] + "&method=artist.getInfo&artist=" + encodeURIComponent(p.artist) + "&autocorrect=" + (l.auto_correct ? 1 : 0);
		var func = function() {
			p.save(t.xmlhttp.responsetext, fn); 
			t.artist = "";
			on_item_focus_change();
		}
		this.xmlhttp.open("GET", url, true);
		this.xmlhttp.setRequestHeader('User-Agent', l.user_agent);
		this.xmlhttp.send();
		this.xmlhttp.onreadystatechange = function() {
			if (t.xmlhttp.readyState == 4) {
				if (t.xmlhttp.status == 200) {
					func();
				} else {
					p.console(t.xmlhttp.responsetext || "HTTP error: " + t.xmlhttp.status);
				}
			}
		}
	}
	
	this.calc = function() {
		this.offset = 0;
		this.text_rows = 0;
		if (p.w == 0 || this.text.length == 0) return;
		var temp_bmp = gdi.CreateImage(1, 1);
		var temp_gr = temp_bmp.GetGraphics();
		var paragraphs = this.text.split("\n");
		this.text_array = [];
		for (i = 0; i < paragraphs.length; i++) {
			var lines = temp_gr.EstimateLineWrap(paragraphs[i], this.fixed ? this.fixed_font : p.normal_font, this.w).toArray();
			for (j = 0; j < lines.length; j +=2) {
				if (this.fixed) this.text_array.push(lines[j]);
				else this.text_array.push(lines[j].trim());
			}
		}
		this.text_rows = this.text_array.length;
		temp_bmp.ReleaseGraphics(temp_gr);
		temp_bmp.Dispose();
		temp_gr = null;
		temp_bmp = null;
	}
	
	this.x = x;
	this.y = y;
	this.w = w;
	this.h = h;
	this.text = "";
	this.artist = "";
	this.up_img = gdi.Image(p.images_path + "up.png");
	this.down_img = gdi.Image(p.images_path + "down.png");
	this.fixed = false;
	this.fixed_font = gdi.Font("Courier", 12);
	this.xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
	this.init();
	this.size();
}

function thumbs() {
	this.trace = function(x, y) {
		return (x > this.x && x < this.x + this.w && y > this.y && y < this.y + this.h);
	}
	
	this.draw = function(gr) {
		if (!this.img) return;
		switch(this.mode) {
			case "grid":
				p.draw_image(gr, this.img, this.x, -this.offset * this.px, this.img.Width, this.img.Height, "centre");
				if (this.overlay) gr.FillSolidRect(this.x, this.y, this.w, this.h, RGBA(0, 0, 0, 156));
				break;
			case "left":
				p.draw_image(gr, this.img, this.x, -this.offset * this.px, this.px, this.img.Height, "centre");
				break;
			case "bottom":
				p.draw_image(gr, this.img, -this.offset * this.px, this.y, this.img.Width, this.px, "centre");
				break;
		}
	}
	
	this.calc = function() {
		this.img && this.img.Dispose();
		this.img = null;
		if (!p.metadb || im.images.length == 0 || p.w < this.px || p.h < this.px) return(window.Repaint());
		this.offset = 0;
		switch(this.mode) {
			case "grid":
				this.overlay = false;
				this.x = 0;
				this.y = 0;
				this.w = p.w;
				this.h = p.h;
				this.rows = Math.ceil(this.h / this.px);
				this.columns = Math.floor(this.w / this.px);
				this.img_rows = Math.ceil(im.images.length / this.columns);
				im.x = 40;
				im.y = 40;
				im.w = this.w - 80;
				im.h = this.h - 80;
				this.img = gdi.CreateImage(Math.min(this.columns, im.images.length) * this.px, this.img_rows * this.px);
				var temp_gr = this.img.GetGraphics();
				temp_gr.SetInterpolationMode(6);
				var ci = 0;
				var row, col;
				for (row = 0; row < this.img_rows; row++) {
					for (col = 0; col < this.columns; col++) {
						p.draw_image(temp_gr, im.images[ci], col * this.px, row * this.px, this.px, this.px, "crop top");
						ci++;
					}
				}
				this.img.ReleaseGraphics(temp_gr);
				temp_gr = null;
				break;
			case "left":
				this.x = 0;
				this.y = 0;
				this.w = this.px;
				this.h = p.h;
				this.rows = Math.ceil(this.h / this.px);
				im.x = this.px;
				im.y = 0;
				im.w = p.w - this.px;
				im.h = p.h;
				this.img = gdi.CreateImage(this.px, this.px * im.images.length);
				var temp_gr = this.img.GetGraphics();
				temp_gr.SetInterpolationMode(6);
				for (i = 0; i < im.images.length; i++) {
					p.draw_image(temp_gr, im.images[i], 0, i * this.px, this.px, this.px, "crop top");
				}
				this.img.ReleaseGraphics(temp_gr);
				temp_gr = null;
				break;
			case "bottom":
				this.x = 0;
				this.y = p.h - this.px;
				this.w = p.w;
				this.h = this.px;
				this.columns = Math.ceil(this.w / this.px);
				im.x = 0;
				im.y = 0;
				im.w = p.w;
				im.h = p.h - this.px;
				this.img = gdi.CreateImage(this.px * im.images.length, this.px);
				var temp_gr = this.img.GetGraphics();
				temp_gr.SetInterpolationMode(6);
				for (i = 0; i < im.images.length; i++) {
					p.draw_image(temp_gr, im.images[i], i * this.px, 0, this.px, this.px, "crop top");
				}
				this.img.ReleaseGraphics(temp_gr);
				temp_gr = null;
				break;
		}
		
	}
	
	this.wheel = function(step) {
		switch(true) {
			case !this.trace(p.mx, p.my):
			case this.overlay:
				return false;
			case this.mode == "grid":
				this.offset -= step;
				if (this.offset < 0) this.offset = 0;
				if (this.offset > this.img_rows - this.rows) this.offset = this.img_rows - this.rows + 1;
				break;
			default:
				this.offset -= step;
				var temp = this.mode == "left" ? this.rows : this.columns;
				if (this.offset < 0) this.offset = 0;
				if (temp + this.offset > im.images.length) this.offset = im.images.length - temp + 1;
				break;
		}
		window.RepaintRect(this.x, this.y, this.w, this.h);
		return true;
	}
	
	this.move = function(x, y) {
		switch(true) {
			case !this.trace(x, y):
				window.SetCursor(IDC_ARROW);
				return false;
			case this.overlay:
				window.SetCursor(IDC_ARROW);
				return true;
			case this.mode == "grid":
				this.index = Math.floor((x - this.x) / this.px) + (Math.floor((y - this.y) / this.px) * this.columns) + (this.offset * this.columns);
				break;
			case this.mode == "left":
				this.index = Math.floor((y - this.y) / this.px) + this.offset;
				break;
			case this.mode == "bottom":
				this.index = Math.floor((x - this.x) / this.px) + this.offset;
				break;
		}
		window.SetCursor(this.index < im.images.length ? IDC_HAND : IDC_ARROW);
		return true;
	}
	
	this.lbtn_up = function(x, y) {
		switch(true) {
			case !this.trace(x, y):
				return false;
			case this.mode == "grid" && this.overlay && im.trace(x, y):
				this.overlay = false;
				window.Repaint();
				break;
			case this.mode == "grid" && this.index < im.images.length && !this.overlay:
				this.overlay = true;
				im.index = this.index;
				window.Repaint();
				break;
			case this.overlay:
				break;
			case this.index < im.images.length:
				im.index = this.index;
				window.Repaint();
		}
		return true;
	}
	
	this.lbtn_dblclk = function(x, y) {
		if (!this.trace(x, y) || this.mode == "grid") return false;
		if (this.index < im.images.length) p.run(im.files[this.index]);
		return true;
	}
	
	this.mode = window.GetProperty("thumbs_mode", "left");
	this.px = window.GetProperty("thumbs_px", 75);
	this.img = null;
}

String.prototype.trim = function() {
	return this.replace(/^\s+|\s+$/g,"");
}

String.prototype.ucfirst = function() {
	return this.charAt(0).toUpperCase() + this.substr(1);
}

if(typeof JSON!=='object'){JSON={};}
(function(){'use strict';function f(n){return n<10?'0'+n:n;}
if(typeof Date.prototype.toJSON!=='function'){Date.prototype.toJSON=function(key){return isFinite(this.valueOf())?this.getUTCFullYear()+'-'+
f(this.getUTCMonth()+1)+'-'+
f(this.getUTCDate())+'T'+
f(this.getUTCHours())+':'+
f(this.getUTCMinutes())+':'+
f(this.getUTCSeconds())+'Z':null;};String.prototype.toJSON=Number.prototype.toJSON=Boolean.prototype.toJSON=function(key){return this.valueOf();};}
var cx=/[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,escapable=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,gap,indent,meta={'\b':'\\b','\t':'\\t','\n':'\\n','\f':'\\f','\r':'\\r','"':'\\"','\\':'\\\\'},rep;function quote(string){escapable.lastIndex=0;return escapable.test(string)?'"'+string.replace(escapable,function(a){var c=meta[a];return typeof c==='string'?c:'\\u'+('0000'+a.charCodeAt(0).toString(16)).slice(-4);})+'"':'"'+string+'"';}
function str(key,holder){var i,k,v,length,mind=gap,partial,value=holder[key];if(value&&typeof value==='object'&&typeof value.toJSON==='function'){value=value.toJSON(key);}
if(typeof rep==='function'){value=rep.call(holder,key,value);}
switch(typeof value){case'string':return quote(value);case'number':return isFinite(value)?String(value):'null';case'boolean':case'null':return String(value);case'object':if(!value){return'null';}
gap+=indent;partial=[];if(Object.prototype.toString.apply(value)==='[object Array]'){length=value.length;for(i=0;i<length;i+=1){partial[i]=str(i,value)||'null';}
v=partial.length===0?'[]':gap?'[\n'+gap+partial.join(',\n'+gap)+'\n'+mind+']':'['+partial.join(',')+']';gap=mind;return v;}
if(rep&&typeof rep==='object'){length=rep.length;for(i=0;i<length;i+=1){if(typeof rep[i]==='string'){k=rep[i];v=str(k,value);if(v){partial.push(quote(k)+(gap?': ':':')+v);}}}}else{for(k in value){if(Object.prototype.hasOwnProperty.call(value,k)){v=str(k,value);if(v){partial.push(quote(k)+(gap?': ':':')+v);}}}}
v=partial.length===0?'{}':gap?'{\n'+gap+partial.join(',\n'+gap)+'\n'+mind+'}':'{'+partial.join(',')+'}';gap=mind;return v;}}
if(typeof JSON.stringify!=='function'){JSON.stringify=function(value,replacer,space){var i;gap='';indent='';if(typeof space==='number'){for(i=0;i<space;i+=1){indent+=' ';}}else if(typeof space==='string'){indent=space;}
rep=replacer;if(replacer&&typeof replacer!=='function'&&(typeof replacer!=='object'||typeof replacer.length!=='number')){throw new Error('JSON.stringify');}
return str('',{'':value});};}
if(typeof JSON.parse!=='function'){JSON.parse=function(text,reviver){var j;function walk(holder,key){var k,v,value=holder[key];if(value&&typeof value==='object'){for(k in value){if(Object.prototype.hasOwnProperty.call(value,k)){v=walk(value,k);if(v!==undefined){value[k]=v;}else{delete value[k];}}}}
return reviver.call(holder,key,value);}
text=String(text);cx.lastIndex=0;if(cx.test(text)){text=text.replace(cx,function(a){return'\\u'+
('0000'+a.charCodeAt(0).toString(16)).slice(-4);});}
if(/^[\],:{}\s]*$/.test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,'@').replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,']').replace(/(?:^|:|,)(?:\s*\[)+/g,''))){j=eval('('+text+')');return typeof reviver==='function'?walk({'':j},''):j;}
throw new SyntaxError('JSON.parse');};}}());

DT_LEFT = 0x00000000;
DT_CENTER = 0x00000001;
DT_RIGHT = 0x00000002;
DT_VCENTER = 0x00000004;
DT_WORDBREAK = 0x00000010;
DT_CALCRECT = 0x00000400;
DT_NOPREFIX = 0x00000800;
DT_END_ELLIPSIS = 0x00008000;

MF_GRAYED = 0x00000001;
MF_STRING = 0x00000000;

IDC_ARROW = 32512;
IDC_HAND = 32649;

ONE_DAY = 86400000;