cGroup = {
	show: window.GetProperty("*GROUP: Show Group Headers", true),
	default_collapsed_height: window.GetProperty("*GROUP: Total Rows COLLAPSED", 2),
	default_expanded_height: window.GetProperty("*GROUP: Total Rows EXPANDED", 3),
	collapsed_height: window.GetProperty("*GROUP: Total Rows COLLAPSED", 2),
	expanded_height: window.GetProperty("*GROUP: Total Rows EXPANDED", 3),
	default_count_minimum: window.GetProperty("*GROUP: Minimum number of rows in a group", 0),
	count_minimum: window.GetProperty("*GROUP: Minimum number of rows in a group", 0),
	extra_rows: window.GetProperty("*GROUP: Total of extra rows to add", 0),
	type: 0
}

columns = {
    rating: false,
    rating_x: 0,
    rating_w: 0,
    rating_drag: false,
    mood: false,
    mood_x: 0,
    mood_w: 0,
    mood_drag: false
}

cTrack = {
	height: window.GetProperty("CUSTOM Row Height", 28),
	parity: ((window.GetProperty("CUSTOM Row Height", 28) / 2) == Math.floor(window.GetProperty("CUSTOM Row Height", 28) / 2) ? 1 : 2)
}

cover = {
    show: window.GetProperty("*GROUP: Show Cover Art", true),
	column: false,
    draw_glass_reflect: false,
    keepaspectratio: true,
	load_timer: false,
	repaint_timer: false,
	items: Array(),
    margin: 6,
    w: 0,
	max_w: cGroup.default_collapsed_height > cGroup.default_expanded_height ? cGroup.default_collapsed_height * cTrack.height : cGroup.default_expanded_height * cTrack.height,
    h: 0,
	max_h: cGroup.default_collapsed_height > cGroup.default_expanded_height ? cGroup.default_collapsed_height * cTrack.height : cGroup.default_expanded_height * cTrack.height,
	previous_max_size: -1,
	resized: false
}

cList = {
	search_string: "",
	incsearch_font: gdi.Font("lucida console", 9, 0),
	incsearch_font_big: gdi.Font("lucida console", 20, 1),
	clear_incsearch_timer: false,
	incsearch_timer: false,
	repaint_timer: false
}

dragndrop = {
    enabled: window.GetProperty("CUSTOM dragndrop enabled", true),
    drag_id: -1,
    drop_id: -1,
    timerID: false,
    drag_in: false,
    drag_out: false
};

cTopbar = {
	height: window.GetProperty("CUSTOM Topbar Height", 55),
	locked: window.GetProperty("CUSTOM Lock Topbar", true)
}

cToolbar = {
	height: 22,
	locked: window.GetProperty("CUSTOM Lock Toolbar", true),
	autohide_timer: false
}

cScrollbar = {
	width: get_system_scrollbar_width(),
	ButtonType: {cursor: 0, up: 1, down: 2},
    timerID1: false,
    timerID2: false,
	timer_counter: 0
}

oScrollbar = function(themed) {
    this.themed = themed;
    if(themed) {
        this.theme = window.CreateThemeManager("scrollbar");
    } else {
        this.theme = false;
    }
    this.cursorScrollTimer = false;
    this.buttons = Array(null, null, null);

    this.draw = function(gr, x, y) {
        // draw background and buttons up & down
        if(this.themed) {
            try {
                this.theme.SetPartAndStateId(6, 1);
                this.theme.DrawThemeBackground(gr, this.x, this.y, this.w, this.h);
                gr.FillSolidRect(this.x - 1, this.y, 1, this.h, g_color_normal_bg);
                gr.FillSolidRect(this.x - 1, this.y, 1, this.h, RGBA(0,0,0,60));
            } catch(e) {
                gr.FillGradRect(this.x - 1, this.y, this.w + 1, this.h, 0, RGBA(0,0,0,40), RGBA(255,255,255,20),1.0);
                gr.FillSolidRect(this.x - 1, this.y, 1, this.h, g_color_normal_bg);
                gr.FillSolidRect(this.x - 1, this.y, 1, this.h, RGBA(0,0,0,60));
            }
        } else {
            gr.FillGradRect(this.x - 1, this.y, this.w + 1, this.h, 0, RGBA(0,0,0,40), RGBA(255,255,255,20),1.0);
            gr.FillSolidRect(this.x - 1, this.y, 1, this.h, g_color_normal_bg);
            gr.FillSolidRect(this.x - 1, this.y, 1, this.h, RGBA(0,0,0,60));
        }
        // draw up & down buttons
        this.buttons[cScrollbar.ButtonType.up].draw(gr, this.x, this.y, 255);
        this.buttons[cScrollbar.ButtonType.down].draw(gr, this.x, this.y + this.h - this.w, 255);
        
        // draw cursor
        this.buttons[cScrollbar.ButtonType.cursor].draw(gr, this.x, this.cursorPos, 255);
    }
          
	this.setCursor = function(totalRowVisible, totalRows, offset) {
        if(totalRows > 0 && totalRows > totalRowVisible && this.w > 2) {
            this.cursorWidth = this.w - 0;
            // calc cursor height
            this.cursorHeight = Math.round((totalRowVisible / totalRows) * this.area_h);
            if(this.cursorHeight < this.w - 2) this.cursorHeight = this.w - 2;
            // cursor pos
            var ratio = offset / (totalRows - totalRowVisible);
            this.cursorPos = this.area_y + Math.round((this.area_h - this.cursorHeight) * ratio);
            this.setCursorButton();
        }
	}
    
    this.setCursorButton = function() {
        // normal cursor Image
        this.cursorImage_normal = gdi.CreateImage(this.cursorWidth, this.cursorHeight);
        var gb = this.cursorImage_normal.GetGraphics();
        // Draw Themed Scrollbar (lg/col)
        try {
            this.theme.SetPartAndStateId(3, 1);
            this.theme.DrawThemeBackground(gb, 0, 0, this.cursorWidth, this.cursorHeight);
            if(this.cursorHeight >= 16) {
                this.theme.SetPartAndStateId(9, 1);
                this.theme.DrawThemeBackground(gb, 0, 0, this.cursorWidth, this.cursorHeight);
            }
        } catch(e) {
			gb.SetSmoothingMode(2);
            gb.FillRoundRect(2, 0, this.cursorWidth - 5, this.cursorHeight - 1, 1, 1, g_color_normal_txt & 0x77ffffff);
            gb.DrawRoundRect(2, 0, this.cursorWidth - 5, this.cursorHeight - 1, 1, 1, 1.0, RGBA(0,0,0,100));
			gb.SetSmoothingMode(0);
        };
        this.cursorImage_normal.ReleaseGraphics(gb);
        
        // hover cursor Image
        this.cursorImage_hover = gdi.CreateImage(this.cursorWidth, this.cursorHeight);
        gb = this.cursorImage_hover.GetGraphics();
        // Draw Themed Scrollbar (lg/col)
        try {
            this.theme.SetPartAndStateId(3, 2);
            this.theme.DrawThemeBackground(gb, 0, 0, this.cursorWidth, this.cursorHeight);
            if(this.cursorHeight >= 16) {
                this.theme.SetPartAndStateId(9, 1);
                this.theme.DrawThemeBackground(gb, 0, 0, this.cursorWidth, this.cursorHeight);
            }
        } catch(e) {
			gb.SetSmoothingMode(2);
            gb.FillRoundRect(2, 0, this.cursorWidth - 5, this.cursorHeight - 1, 1, 1, g_color_normal_txt & 0x99ffffff);
            gb.DrawRoundRect(2, 0, this.cursorWidth - 5, this.cursorHeight - 1, 1, 1, 1.0, RGBA(0,0,0,100));
			gb.SetSmoothingMode(0);
        };
        this.cursorImage_hover.ReleaseGraphics(gb);
		
        // down cursor Image
        this.cursorImage_down = gdi.CreateImage(this.cursorWidth, this.cursorHeight);
        gb = this.cursorImage_down.GetGraphics();
        // Draw Themed Scrollbar (lg/col)
        try {
            this.theme.SetPartAndStateId(3, 3);
            this.theme.DrawThemeBackground(gb, 0, 0, this.cursorWidth, this.cursorHeight);
            if(this.cursorHeight >= 16) {
                this.theme.SetPartAndStateId(9, 1);
                this.theme.DrawThemeBackground(gb, 0, 0, this.cursorWidth, this.cursorHeight);
            }
        } catch(e) {
			gb.SetSmoothingMode(2);
            gb.FillRoundRect(2, 0, this.cursorWidth - 5, this.cursorHeight - 1, 1, 1, g_color_selected_txt & 0x77ffffff);
            gb.DrawRoundRect(2, 0, this.cursorWidth - 5, this.cursorHeight - 1, 1, 1, 1.0, RGBA(0,0,0,100));
			gb.SetSmoothingMode(0);
        };
        this.cursorImage_down.ReleaseGraphics(gb);
		
        // create/refresh cursor Button in buttons array
        this.buttons[cScrollbar.ButtonType.cursor] = new button(this.cursorImage_normal, this.cursorImage_hover, this.cursorImage_down);
    }
    
    this.setButtons = function() {

        // normal scroll_up Image
        this.upImage_normal = gdi.CreateImage(this.w, this.w);
        var gb = this.upImage_normal.GetGraphics();
        // Draw Themed Scrollbar (lg/col)
        try {
            this.theme.SetPartAndStateId(1, 1);
            this.theme.DrawThemeBackground(gb, 0, 0, this.w, this.w);
        } catch(e) {
            gb.SetSmoothingMode(2);
            var mid_x = Math.round(this.w / 2);
            gb.DrawLine(mid_x - 5, 10, mid_x - 1, 05, 2.0, g_color_normal_txt & 0x44ffffff);
            gb.DrawLine(mid_x - 1, 06, mid_x + 2, 10, 2.0, g_color_normal_txt & 0x44ffffff);
        };
        this.upImage_normal.ReleaseGraphics(gb);

        // hover scroll_up Image
        this.upImage_hover = gdi.CreateImage(this.w, this.w);
        gb = this.upImage_hover.GetGraphics();
        // Draw Themed Scrollbar (lg/col)
        try {
            this.theme.SetPartAndStateId(1, 2);
            this.theme.DrawThemeBackground(gb, 0, 0, this.w, this.w);
        } catch(e) {
            gb.SetSmoothingMode(2);
            var mid_x = Math.round(this.w / 2);
            gb.DrawLine(mid_x - 5, 10, mid_x - 1, 05, 2.0, g_color_normal_txt & 0x88ffffff);
            gb.DrawLine(mid_x - 1, 06, mid_x + 2, 10, 2.0, g_color_normal_txt & 0x88ffffff);
        };
        this.upImage_hover.ReleaseGraphics(gb);

        // down scroll_up Image
        this.upImage_down = gdi.CreateImage(this.w, this.w);
        gb = this.upImage_down.GetGraphics();
        // Draw Themed Scrollbar (lg/col)
        try {
            this.theme.SetPartAndStateId(1, 3);
            this.theme.DrawThemeBackground(gb, 0, 0, this.w, this.w);
        } catch(e) {
            gb.SetSmoothingMode(2);
            var mid_x = Math.round(this.w / 2);
            gb.DrawLine(mid_x - 5, 10, mid_x - 1, 05, 2.0, g_color_normal_txt);
            gb.DrawLine(mid_x - 1, 06, mid_x + 2, 10, 2.0, g_color_normal_txt);
        };
        this.upImage_down.ReleaseGraphics(gb);

        // normal scroll_down Image
        this.downImage_normal = gdi.CreateImage(this.w, this.w);
        gb = this.downImage_normal.GetGraphics();
        // Draw Themed Scrollbar (lg/col)
        try {
            this.theme.SetPartAndStateId(1, 5);
            this.theme.DrawThemeBackground(gb, 0, 0, this.w, this.w);
        } catch(e) {
            gb.SetSmoothingMode(2);
            var mid_x = Math.round(this.w / 2);
            gb.DrawLine(mid_x - 5, this.w - 11, mid_x - 1, this.w - 06, 2.0, g_color_normal_txt & 0x44ffffff);
            gb.DrawLine(mid_x - 1, this.w - 07, mid_x + 2, this.w - 11, 2.0, g_color_normal_txt & 0x44ffffff);
        };
        this.downImage_normal.ReleaseGraphics(gb);

        // hover scroll_down Image
        this.downImage_hover = gdi.CreateImage(this.w, this.w);
        gb = this.downImage_hover.GetGraphics();
        // Draw Themed Scrollbar (lg/col)
        try {
            this.theme.SetPartAndStateId(1, 6);
            this.theme.DrawThemeBackground(gb, 0, 0, this.w, this.w);
        } catch(e) {
            gb.SetSmoothingMode(2);
            var mid_x = Math.round(this.w / 2);
            gb.DrawLine(mid_x - 5, this.w - 11, mid_x - 1, this.w - 06, 2.0, g_color_normal_txt & 0x88ffffff);
            gb.DrawLine(mid_x - 1, this.w - 07, mid_x + 2, this.w - 11, 2.0, g_color_normal_txt & 0x88ffffff);
        };
        this.downImage_hover.ReleaseGraphics(gb);

        // down scroll_down Image
        this.downImage_down = gdi.CreateImage(this.w, this.w);
        gb = this.downImage_down.GetGraphics();
        // Draw Themed Scrollbar (lg/col)
        try {
            this.theme.SetPartAndStateId(1, 7);
            this.theme.DrawThemeBackground(gb, 0, 0, this.w, this.w);
        } catch(e) {
            gb.SetSmoothingMode(2);
            var mid_x = Math.round(this.w / 2);
            gb.DrawLine(mid_x - 5, this.w - 11, mid_x - 1, this.w - 06, 2.0, g_color_normal_txt);
            gb.DrawLine(mid_x - 1, this.w - 07, mid_x + 2, this.w - 11, 2.0, g_color_normal_txt);
        };
        this.downImage_down.ReleaseGraphics(gb);

        for(i = 1; i < this.buttons.length; i++) {
            switch(i) {
            case cScrollbar.ButtonType.cursor:
                this.buttons[cScrollbar.ButtonType.cursor] = new button(this.cursorImage_normal, this.cursorImage_hover, this.cursorImage_down);
                break;
            case cScrollbar.ButtonType.up:
                this.buttons[cScrollbar.ButtonType.up] = new button(this.upImage_normal, this.upImage_hover, this.upImage_down);
                break;
            case cScrollbar.ButtonType.down:
                this.buttons[cScrollbar.ButtonType.down] = new button(this.downImage_normal, this.downImage_hover, this.downImage_down);
                break;
            };
        };
    };
    
    this.setSize = function(x, y, w, h) {
		this.x = x;
		this.y = y;
		this.w = w;
		this.h = h;
		// scrollbar area for the cursor (<=> scrollbar height minus up & down buttons height)
        this.area_y = y + w;
        this.area_h = h - (w * 2);
        this.setButtons();
    }
    
    this.setOffsetFromCursorPos = function() {
        // calc ratio of the scroll cursor to calc the equivalent item for the full playlist (with gh)
        var ratio = (this.cursorPos - this.area_y) / (this.area_h - this.cursorHeight);
        // calc idx of the item (of the full playlist with gh) to display at top of the panel list (visible)
        var newOffset = Math.round((g_list.totalRows - g_list.totalRowVisible) * ratio);
        return newOffset;
    }
   
    this.cursorCheck = function(event, x, y) {
        this.ishover = (x >= this.x && x <= this.x + this.w && y >= this.cursorPos && y <= (this.cursorPos + this.cursorHeight));

        switch(event) {
        case "down":
			this.buttons[0].checkstate(event, x, y);
            if(this.ishover) {
                this.cursorClickX = x;
                this.cursorClickY = y;
                this.cursorDrag = true;
                this.cursorDragDelta = y - this.cursorPos;
            }
            break;
        case "up":
			this.buttons[0].checkstate(event, x, y);
            if(this.cursorDrag) {
                g_list.offset = this.setOffsetFromCursorPos();
                g_list.setItems(false);
                g_list.Repaint();
            }
            this.cursorClickX = 0;
            this.cursorClickY = 0;
            this.cursorDrag = false;
            break;
        case "move":
			this.buttons[0].checkstate(event, x, y);
            if(this.cursorDrag) {
                this.cursorPos = y - this.cursorDragDelta;
                if(this.cursorPos + this.cursorHeight > this.area_y + this.area_h) {
                    this.cursorPos = (this.area_y + this.area_h) - this.cursorHeight;
                }
                if(this.cursorPos < this.area_y) {
                    this.cursorPos = this.area_y;
                }
                
                g_list.offset = this.setOffsetFromCursorPos();
                if(!g_mouse_wheel_timer) {
                    g_mouse_wheel_timer = window.SetTimeout(function() {
                        g_list.setItems(false);
                        g_list.Repaint();
                        g_mouse_wheel_timer && window.ClearTimeout(g_mouse_wheel_timer);
                        g_mouse_wheel_timer = false;
                    }, 30);
                }
            }
            break;
		case "leave":
			this.buttons[0].checkstate(event, x, y);
			break;
		default:
			//
        }
    }

	this.check = function(event, x, y) {
		this.hover = (x >= this.x && x <= this.x + this.w && y > this.area_y && y < this.area_y + this.area_h);

		// check cursor
		this.cursorCheck(event, x, y);
		
		// check other buttons
		for(var i = 1; i < this.buttons.length; i++) {
			switch(event) {
				case "dblclk":
					switch(i) {
						case 1: // up button
							if(this.buttons[i].checkstate(event, x, y) == ButtonStates.hover) {
								g_list.buttonclicked = true;
								this.buttons[i].checkstate("down", x, y);
								g_list.offset = g_list.offset > 0 ? g_list.offset - 1 : 0;
								g_list.setItems(false);
								g_scrollbar.setCursor(g_list.totalRowVisible, g_list.totalRows, g_list.offset);
								g_list.Repaint();
								if(!cScrollbar.timerID2) {
									cScrollbar.timerID2 = window.SetInterval(function() {
										cScrollbar.timer_counter++;
										if(cScrollbar.timer_counter > 7) {
											g_list.offset = g_list.offset > 0 ? g_list.offset - 1 : 0;
											g_list.setItems(false);
											g_scrollbar.setCursor(g_list.totalRowVisible, g_list.totalRows, g_list.offset);
											g_list.Repaint();
										}
									}, 60);
								}
							}
							break;
						case 2: // down button
							if(this.buttons[i].checkstate(event, x, y) == ButtonStates.hover) {
								g_list.buttonclicked = true;
								this.buttons[i].checkstate("down", x, y);
								g_list.offset = g_list.offset >= (g_list.totalRows - g_list.totalRowVisible) ? (g_list.totalRows - g_list.totalRowVisible) : g_list.offset + 1;
								g_list.setItems(false);
								g_scrollbar.setCursor(g_list.totalRowVisible, g_list.totalRows, g_list.offset);
								g_list.Repaint();
								if(!cScrollbar.timerID2) {
									cScrollbar.timerID2 = window.SetInterval(function() {
										cScrollbar.timer_counter++;
										if(cScrollbar.timer_counter > 7) {
											g_list.offset = g_list.offset >= (g_list.totalRows - g_list.totalRowVisible) ? (g_list.totalRows - g_list.totalRowVisible) : g_list.offset + 1;
											g_list.setItems(false);
											g_scrollbar.setCursor(g_list.totalRowVisible, g_list.totalRows, g_list.offset);
											g_list.Repaint();
										}
									}, 60);
								}
							}
							break;
					}
					break;
				case "down":
					switch(i) {
						case 1: // up button
							if(this.buttons[i].checkstate(event, x, y) == ButtonStates.down) {
								g_list.buttonclicked = true;
								cScrollbar.timer_counter = 0;
								g_list.offset = g_list.offset > 0 ? g_list.offset - 1 : 0;
								g_list.setItems(false);
								g_scrollbar.setCursor(g_list.totalRowVisible, g_list.totalRows, g_list.offset);
								g_list.Repaint();
								cScrollbar.timerID2 = window.SetInterval(function() {
									cScrollbar.timer_counter++;
									if(cScrollbar.timer_counter > 7) {
										g_list.offset = g_list.offset > 0 ? g_list.offset - 1 : 0;
										g_list.setItems(false);
										g_scrollbar.setCursor(g_list.totalRowVisible, g_list.totalRows, g_list.offset);
										g_list.Repaint();
									}
								}, 60);
							}
							break;
						case 2: // down button
							if(this.buttons[i].checkstate(event, x, y) == ButtonStates.down) {
								g_list.buttonclicked = true;
								cScrollbar.timer_counter = 0;
								g_list.offset = g_list.offset >= (g_list.totalRows - g_list.totalRowVisible) ? (g_list.totalRows - g_list.totalRowVisible) : g_list.offset + 1;
								g_list.setItems(false);
								g_scrollbar.setCursor(g_list.totalRowVisible, g_list.totalRows, g_list.offset);
								g_list.Repaint();
								cScrollbar.timerID2 = window.SetInterval(function() {
									cScrollbar.timer_counter++;
									if(cScrollbar.timer_counter > 7) {
										g_list.offset = g_list.offset >= (g_list.totalRows - g_list.totalRowVisible) ? (g_list.totalRows - g_list.totalRowVisible) : g_list.offset + 1;
										g_list.setItems(false);
										g_scrollbar.setCursor(g_list.totalRowVisible, g_list.totalRows, g_list.offset);
										g_list.Repaint();
									}
								}, 60);
							}
							break;
					}
					break;
				case "up":
					if(cScrollbar.timerID2) {
						window.ClearInterval(cScrollbar.timerID2);
						cScrollbar.timerID2 = false;
					}
					cScrollbar.timer_counter = 0;
					this.buttons[i].checkstate(event, x, y);
					break;
				default:
					this.buttons[i].checkstate(event, x, y);
			}
		}
	}

    this.Repaint = function() {
        window.RepaintRect(this.x, this.y, this.w, this.h);
    }
}


oTopbar = function() {
	this.visible = true;

	this.setButtons = function() {
		var gfx_font = gdi.Font("guifx v2 transports", 12, 0);
		
        // normal settings Image
        this.closeImage_normal = gdi.CreateImage(16, 16);
        var gb = this.closeImage_normal.GetGraphics();
        // Draw Themed Scrollbar (lg/col)
            var mid_x = Math.round(16 / 2);
			var mid_y = Math.round(16 / 2);
			gb.SetSmoothingMode(2);
			gb.FillEllipse(0, 0, 15, 15, g_color_normal_txt & 0x30ffffff);
			gb.SetSmoothingMode(0);
			gb.SetTextRenderingHint(3);
			gb.DrawString("x", gfx_font, g_color_normal_bg, mid_x - 5, mid_y - 6, 16, 16, lt_stringformat);
        this.closeImage_normal.ReleaseGraphics(gb);

        // hover settings Image
        this.closeImage_hover = gdi.CreateImage(16, 16);
        gb = this.closeImage_hover.GetGraphics();
        // Draw Themed Scrollbar (lg/col)
            var mid_x = Math.round(16 / 2);
			var mid_y = Math.round(16 / 2);
			gb.SetSmoothingMode(2);
			gb.DrawEllipse(0, 0, 15, 15, 1.0, g_color_normal_txt & 0x44ffffff);
			gb.SetSmoothingMode(0);
			gb.SetTextRenderingHint(3);
			gb.DrawString("x", gfx_font, g_color_normal_txt & 0x44ffffff, mid_x - 5, mid_y - 6, 16, 16, lt_stringformat);
        this.closeImage_hover.ReleaseGraphics(gb);

        // down settings Image
        this.closeImage_down = gdi.CreateImage(16, 16);
        gb = this.closeImage_down.GetGraphics();
        // Draw Themed Scrollbar (lg/col)
            var mid_x = Math.round(16 / 2);
			var mid_y = Math.round(16 / 2);
			gb.SetSmoothingMode(2);
			gb.DrawEllipse(0, 0, 15, 15, 1.0, g_color_normal_txt & 0x77ffffff);
			gb.SetSmoothingMode(0);
			gb.SetTextRenderingHint(3);
			gb.DrawString("x", gfx_font, g_color_normal_txt & 0x77ffffff, mid_x - 5, mid_y - 6, 16, 16, lt_stringformat);
        this.closeImage_down.ReleaseGraphics(gb);

        this.button = new button(this.closeImage_normal, this.closeImage_hover, this.closeImage_down);
    };
	
	this.setSize = function(x, y, w, h) {
		this.x = x;
		this.y = y;
		this.w = w;
		this.h = h;
		this.visible = (h > 0);
		this.setButtons();
	}
	
	this.calc_playlist_duration = function() {
		var tmp_metadb;
		var tf = fb.TitleFormat("$if(%length%,%length_seconds_fp%,0)");
		var seconds = 0;
		for(var i = 0; i < g_list.count; i++) {
			tmp_metadb = g_list.handleList.Item(i);
			seconds += Math.abs(tf.EvalWithMetadb(tmp_metadb));
		}
		return seconds;
	}
	
	this.draw = function(gr) {
		if(this.visible) {
			// bg
			gr.FillSolidRect(this.x, this.y, this.w, this.h, g_color_normal_bg);
			gr.FillGradRect(this.x, this.y, this.w, 25, 90, RGBA(0,0,0,25), RGBA(0,0,0,0), 1.0);
			// playlist info
			var playlist_name = plman.GetPlaylistName(g_list.playlist);
			var playlist_total = plman.PlaylistItemCount(g_list.playlist);
			gr.SetTextRenderingHint(3);
			gr.DrawString(playlist_name, gdi.Font("segoe ui", 18, 1), g_color_normal_txt & 0xbbffffff, 11, 4, this.w - 30, 32, lt_stringformat);
			if(playlist_total > 0 && g_total_duration_text.length == 0) {
				var seconds = this.calc_playlist_duration();
				if(seconds > 0) {
					g_total_duration_text = "";
				} else {
					g_total_duration_text = formatPlaylistTotalDurationText(seconds);
				}
			}
			gr.SetTextRenderingHint(5);
			if(g_total_duration_text.length > 0) {
				gr.DrawString(playlist_total > 0 ? (playlist_total + (playlist_total > 1 ? " songs, " : " song, ") + g_total_duration_text) : "empty playlist", gdi.Font("segoe ui", 13, 0), g_color_normal_txt & 0x77ffffff, 11, 30, this.w - 30, 32, lt_stringformat);
			} else {
				gr.DrawString(playlist_total > 0 ? (playlist_total + (playlist_total > 1 ? " streams " : " stream ")) : "empty playlist", gdi.Font("segoe ui", 13, 0), g_color_normal_txt & 0x77ffffff, 11, 30, this.w - 30, 32, lt_stringformat);
			}
			
			// draw close button
			this.button.draw(gr, this.x + this.w - 20, this.y + 6, 255);
			
			// top thin line
            gr.FillSolidRect(0, 0, ww, 1, RGBA(0, 0, 0, 50));
            gr.FillSolidRect(0, 1, ww, 1, RGBA(0, 0, 0, 15));
		} else {
			// top thin line
			gr.FillSolidRect(0, 0, ww, 1, g_syscolor_button_bg);
            gr.FillSolidRect(0, 0, ww, 1, g_syscolor_button_txt & 0x25ffffff);
		}
	}

    this.buttonCheck = function(event, x, y) {
		var state = this.button.checkstate(event, x, y);

		switch(event) {
        case "up":
			if(state == ButtonStates.hover) {
				// action
				cTopbar.locked = false;
				window.SetProperty("CUSTOM Lock Topbar", cTopbar.locked);
				on_size();
				window.Repaint();
			}
            break;
        }
		return state;
    }
	
    this.check = function(event, x, y) {
        this.is_hover = (x > this.x && x < this.x + this.w && y > this.y && y < this.y + this.h);
		
		// check close button or topbar if button not hover
		if(this.buttonCheck(event, x, y) != ButtonStates.hover) {
			switch(event) {
				case "up":
					break;
			}
		}
    }
	
	this.Repaint = function() {
		window.RepaintRect(this.x, this.y, this.w, this.h);
	}
}


oColumn = function(label, tf, percent, ref, align) {
	this.label = label;
	this.tf = tf;
    this.percent = percent;
	this.ref = ref;
	this.align = Math.round(align);
	this.DT_align = (this.align == 0 ? DT_LEFT : (this.align == 2 ? DT_RIGHT : DT_CENTER));
    this.w = Math.round(g_toolbar.w * percent / 100000);
    this.min_w = 25;
	this.click = false;
	this.resize_direction = 0;
    
	this.draw_empty = function(gr, x, y, id) {
	
		if(properties.themed) {
			var color_bg = g_syscolor_button_bg;
		} else {
			var color_bg = g_color_normal_bg;
		}
		
        switch(true) {
            case (this.w > 0 && this.x >= 0 && this.x < 2): // first column
				gr.FillGradRect(this.x, this.y, this.w, g_toolbar.h + 0-1, 90, RGBA(0,0,0,120), RGBA(0,0,0,30), 0.7);
				gr.DrawRect(this.x - 1, this.y, this.w - 1 + 2, g_toolbar.h-1, 1.0, color_bg);
				gr.DrawRect(this.x - 1, this.y, this.w - 1 + 2, g_toolbar.h-1, 1.0, RGBA(0,0,0,120));
                break;
            case (this.w > 0 && this.x + this.w > g_toolbar.w - 5): // last column
                if(!g_toolbar.click) {
                    var gap = g_toolbar.w - (this.x + 1 + this.w);
                } else {
                    var gap = 0;
                }
                this.w = this.w + gap;
				gr.FillGradRect(this.x + 1, this.y, this.w - 1, g_toolbar.h + 0-1, 90, RGBA(0,0,0,120), RGBA(0,0,0,30), 0.7);
				gr.DrawRect(this.x + 1 - 1, this.y, this.w - 2 + 2, g_toolbar.h-1, 1.0, color_bg);
				gr.DrawRect(this.x + 1 - 1, this.y, this.w - 2 + 2, g_toolbar.h-1, 1.0, RGBA(0,0,0,120));
                break;
            default: // other columns
				gr.FillGradRect(this.x + 1, this.y, this.w - 1, g_toolbar.h + 0-1, 90, RGBA(0,0,0,120), RGBA(0,0,0,30), 0.7);
				gr.DrawRect(this.x + 1 - 1, this.y, this.w - 2 + 2, g_toolbar.h-1, 1.0, color_bg);
				gr.DrawRect(this.x + 1 - 1, this.y, this.w - 2 + 2, g_toolbar.h-1, 1.0, RGBA(0,0,0,120));
                break;
        }
	}
	
    this.draw = function(gr, x, y, id) {
        var alpha = 255; // default
        if(this.click) {
            this.x = x - this.clickX;
            this.y = y;
            alpha = 200;
        } else {
            this.x = x;
            this.y = y;
        }
        this.id = id;

        // column header cell background	
        var Xoff7 = 0;
        var Yoff7 = 0;
        if(this.click) {
            Xoff7 = 3;
            Yoff7 = 4;
            gr.FillGradRect(this.x + Xoff7, this.y + Yoff7, this.w + 1, g_toolbar.h-1, 90, RGBA(110,110,110,100), RGBA(150,150,150,100), 0.5);
        }
		
		if(properties.themed) {
			var color_bg = g_syscolor_button_bg;
			var color_txt = g_syscolor_button_txt;
		} else {
			var color_bg = g_color_normal_bg;
			var color_txt = g_color_normal_txt;
		}

        switch(true) {
            case (this.w > 0 && this.x >= 0 && this.x < 2): // first column
				gr.FillSolidRect(this.x + Xoff7, this.y + Yoff7, this.w, g_toolbar.h-1, color_bg & RGBA(255,255,255,alpha));
                gr.FillGradRect(this.x + Xoff7, this.y + Yoff7 + 1, this.w, g_toolbar.h - 1-1, 90, RGBA(0,0,0,30), RGBA(255,255,255,30), 1.0);
				if(this.click) {
					gr.FillSolidRect(this.x + Xoff7, this.y + Yoff7 + 0, this.w, 1, RGBA(0,0,0,50));
				} else {
					gr.FillSolidRect(this.x + Xoff7, this.y + Yoff7 + 0, this.w, 1, RGBA(255,255,255,60));
				}
				if(this.click) gr.DrawRect(this.x + Xoff7 - 1, this.y + Yoff7, this.w + 1, g_toolbar.h - 1-1, 1.0, blendColors(color_txt, color_bg, 0.5));
				if(!this.click) gr.FillSolidRect(this.x + Xoff7, this.y + Yoff7, this.w, g_toolbar.h-2, RGBA(255,255,255,30));
				if(this.rightClicked) {
					gr.FillSolidRect(this.x + Xoff7, this.y + Yoff7, this.w, g_toolbar.h - 1, color_txt & 0x25ffffff);
					gr.DrawRect(this.x + Xoff7, this.y + Yoff7, this.w, g_toolbar.h - 1, 1.0, blendColors(color_txt, color_bg, 0.3));
				}
                break;
            case (this.w > 0 && this.x + this.w > g_toolbar.w - 5): // last column
                if(!g_toolbar.click) {
                    var gap = g_toolbar.w - (this.x + 1 + this.w);
                } else {
                    var gap = 0;
                }
                this.w = this.w + gap;
				gr.FillSolidRect(this.x + 1 + Xoff7, this.y + Yoff7, this.w - 1, g_toolbar.h-1, color_bg & RGBA(255,255,255,alpha));
                gr.FillGradRect(this.x + 1 + Xoff7, this.y + Yoff7 + 1, this.w - 1, g_toolbar.h - 1-1, 90, RGBA(0,0,0,30), RGBA(255,255,255,30), 1.0);
				if(this.click) {
					gr.FillSolidRect(this.x + 1 + Xoff7, this.y + Yoff7 + 0, this.w - 1, 1, RGBA(0,0,0,50));
				} else {
					gr.FillSolidRect(this.x + 1 + Xoff7, this.y + Yoff7 + 0, this.w - 1, 1, RGBA(255,255,255,60));
				}
				if(this.click) gr.DrawRect(this.x + Xoff7, this.y + Yoff7, this.w - 0, g_toolbar.h - 1-1, 1.0, blendColors(color_txt, color_bg, 0.5));
				if(!this.click) gr.FillSolidRect(this.x + Xoff7, this.y + Yoff7, this.w, g_toolbar.h-2, RGBA(255,255,255,30));
				if(this.rightClicked) {
					gr.FillSolidRect(this.x + Xoff7, this.y + Yoff7, this.w, g_toolbar.h - 1, color_txt & 0x25ffffff);
					gr.DrawRect(this.x + Xoff7, this.y + Yoff7, this.w, g_toolbar.h - 1, 1.0, blendColors(color_txt, color_bg, 0.3));
				}
                break;
            default: // other columns
				gr.FillSolidRect(this.x + 1 + Xoff7, this.y + Yoff7, this.w - 1, g_toolbar.h-1, color_bg & RGBA(255,255,255,alpha));
                gr.FillGradRect(this.x + 1 + Xoff7, this.y + Yoff7 + 1, this.w - 1, g_toolbar.h - 1-1, 90, RGBA(0,0,0,30), RGBA(255,255,255,30), 1.0);
				if(this.click) {
					gr.FillSolidRect(this.x + 1 + Xoff7, this.y + Yoff7 + 0, this.w - 1, 1, RGBA(0,0,0,50));
				} else {
					gr.FillSolidRect(this.x + 1 + Xoff7, this.y + Yoff7 + 0, this.w - 1, 1, RGBA(255,255,255,60));
				}
				if(this.click) gr.DrawRect(this.x + Xoff7, this.y + Yoff7, this.w - 0, g_toolbar.h - 1-1, 1.0, blendColors(color_txt, color_bg, 0.5));
				if(!this.click) gr.FillSolidRect(this.x + Xoff7, this.y + Yoff7, this.w, g_toolbar.h-2, RGBA(255,255,255,30));
				if(this.rightClicked) {
					gr.FillSolidRect(this.x + Xoff7, this.y + Yoff7, this.w, g_toolbar.h - 1, color_txt & 0x25ffffff);
					gr.DrawRect(this.x + Xoff7, this.y + Yoff7, this.w, g_toolbar.h - 1, 1.0, blendColors(color_txt, color_bg, 0.3));
				}
                break;
        }

        
        // draw label in cell
		try {
			gr.gdiDrawText(this.label, gdi.Font("Arial", 11, 1), color_bg, this.x + 7 + Xoff7, this.y + 1 + Yoff7, this.w - 12, g_toolbar.h, this.DT_align | DT_CALCRECT | DT_VCENTER | DT_END_ELLIPSIS);
			gr.gdiDrawText(this.label, gdi.Font("Arial", 11, 1), color_txt, this.x + 7 + Xoff7, this.y + Yoff7, this.w - 12, g_toolbar.h, this.DT_align | DT_CALCRECT | DT_VCENTER | DT_END_ELLIPSIS);
		} catch(e) {}
        
        if(this.drag) {
            gr.FillSolidRect(this.x + this.w - 1, this.y, 2, g_toolbar.h-1, RGB(255,0,0));
        }
    }
    
    this.check = function(x, y, event, column_idx) {
        this.is_hover = (this.w > 0 && x > this.x && x < this.x + this.w && y > g_toolbar.y && y < g_toolbar.y + g_toolbar.h);
        this.border_hover = (this.w > 0 && x < g_toolbar.w - 10 && x > this.x + this.w - 4 && x < this.x + this.w + 4 && y > g_toolbar.y && y < g_toolbar.y + g_toolbar.h);
	   
        switch(event) {
            case "down":
				if(this.border_hover) {
					if(!g_toolbar.click) {
						this.drag = true;
						g_toolbar.drag = true;
						window.Repaint();
					}
				} else if(this.is_hover && this.ref != "cover") {
					if(!g_toolbar.drag) {
						this.click = true;
						this.clickX = x - this.x;
						g_toolbar.click = true;
						g_toolbar.targetId = this.id;
						if(!g_toolbar.repaint_timer) {
							g_toolbar.repaint_timer = window.SetTimeout(function () {
								window.ClearTimeout(g_toolbar.repaint_timer);
								g_toolbar.repaint_timer = false;
								if(g_toolbar.click) window.SetCursor(IDC_SIZEALL);
								window.Repaint();
							}, 100);
						}
					}
				}
                break;
            case "up":
                if(this.drag) {
                    this.drag = false;
                    for(var k=0; k < g_toolbar.columns.length; k++) {
                        g_toolbar.columns[k].percent = Math.round(g_toolbar.columns[k].w * 100000 / g_toolbar.w);
                        window.SetProperty("SYSTEM.Toolbar.col"+k.toString(), g_toolbar.columns[k].label + ";" + g_toolbar.columns[k].tf + ";" + g_toolbar.columns[k].percent + ";" + g_toolbar.columns[k].ref + ";" + g_toolbar.columns[k].align);
                        g_toolbar.columns[k].w = Math.round(g_toolbar.w * g_toolbar.columns[k].percent / 100000);
                    }
                    window.Repaint();
                } else if(this.click){
                    this.click = false;
                    for(var k=0; k < g_toolbar.columns.length; k++) {
                        window.SetProperty("SYSTEM.Toolbar.col"+k.toString(), g_toolbar.columns[k].label + ";" + g_toolbar.columns[k].tf + ";" + g_toolbar.columns[k].percent + ";" + g_toolbar.columns[k].ref + ";" + g_toolbar.columns[k].align);
                    }
                    window.Repaint();
                }
				this.resize_direction = 0;
                break;
            case "move":
                if(this.border_hover) {
                    if(!g_toolbar.click) {
                        g_toolbar.onBorder = true;
                        window.SetCursor(IDC_SIZEWE);
                    }
                } else {
					g_toolbar.onBorder = false;
				}
                if(this.drag) {
                    var offset = (x == mouse_x) ? 0 : x - mouse_x;
                    if(offset > 0) {
						if(g_toolbar.onBorder || this.resize_direction > 0) {
							// look for nested colums visible (w>0)
							var nextId = 1;
							for(var k = this.id + 1; k < g_toolbar.columns.length - 1; k++) {
								if(g_toolbar.columns[k].w > 0) {
									break;
								} else {
									nextId++;
								}
							}
							if(g_toolbar.columns[this.id+nextId].w > g_toolbar.columns[this.id+nextId].min_w) { // if right column resizable
								if(g_toolbar.columns[this.id+nextId].w - offset < g_toolbar.columns[this.id+nextId].min_w) {
									var new_offset = g_toolbar.columns[this.id+nextId].min_w - g_toolbar.columns[this.id+nextId].w;
									offset = new_offset;
								}
								this.w += offset;
								g_toolbar.columns[this.id+nextId].w -= offset;
							}
							if(g_toolbar.onBorder) this.resize_direction = 1;
						} else if(!g_toolbar.onBorder) {
							this.resize_direction = 0;
						}
                    } else if(offset < 0) {
						if(g_toolbar.onBorder || this.resize_direction < 0) {
							// look for nested colums visible (w>0)
							var nextId = 1;
							for(var k = this.id+1; k < g_toolbar.columns.length - 1; k++) {
								if(g_toolbar.columns[k].w>0) {
									break;
								} else {
									nextId++;
								}
							}
							if(this.w > g_toolbar.columns[this.id+nextId].min_w) { // if column resizable
								if(this.w + offset < g_toolbar.columns[this.id+nextId].min_w) {
									var new_offset = g_toolbar.columns[this.id+nextId].min_w - this.w;
									offset = new_offset;
								}
								this.w += offset;
								g_toolbar.columns[this.id+nextId].w -= offset;
							}
							if(g_toolbar.onBorder) this.resize_direction = -1;
						} else if(!g_toolbar.onBorder) {
							this.resize_direction = 0;
						}
                    }
                    if(!g_toolbar.repaint_timer) {
                        g_toolbar.repaint_timer = window.SetTimeout(function () {
                            window.ClearTimeout(g_toolbar.repaint_timer);
                            g_toolbar.repaint_timer = false;
							window.Repaint();

                        }, 40);
                    }
                } else if(this.click) {
                    var offset = (x == mouse_x) ? 0 : x - mouse_x;
                    if(offset > 0) {
                        for(var k = g_toolbar.targetId; k < g_toolbar.columns.length - 1; k++) {
                            if(x > g_toolbar.columns[g_toolbar.targetId+1].x) {
                                var tmp_col = g_toolbar.columns[g_toolbar.targetId+1];
                                g_toolbar.columns[g_toolbar.targetId+1] = g_toolbar.columns[g_toolbar.targetId];
                                g_toolbar.columns[g_toolbar.targetId] = tmp_col;
                                g_toolbar.targetId += 1;
                            }
                        }
                    } else if(offset < 0) {
                        var nbcolumns = g_toolbar.targetId;
                        for(var k = g_toolbar.targetId-1; k >= 0; k--) {
                            if(x < g_toolbar.columns[k].x + g_toolbar.columns[k].w && g_toolbar.columns[k].ref != "cover") { // cover column can't be swapped!
                                var tmp_col = g_toolbar.columns[k];
                                g_toolbar.columns[k] = g_toolbar.columns[g_toolbar.targetId];
                                g_toolbar.columns[g_toolbar.targetId] = tmp_col;
                                g_toolbar.targetId = k;
                            }
                        }
                    }
                    if(!g_toolbar.repaint_timer) {
                        g_toolbar.repaint_timer = window.SetTimeout(function () {
                            window.ClearTimeout(g_toolbar.repaint_timer);
                            g_toolbar.repaint_timer = false;
                            window.Repaint();
                        }, 40);
                    }
                }
                break;
            case "right":
                if(this.is_hover) {
					this.rightClicked = true;
					window.Repaint();
                    if(!g_toolbar.repaint_timer) {
                        g_toolbar.repaint_timer = window.SetTimeout(function () {
                            g_toolbar.repaint_timer && window.ClearTimeout(g_toolbar.repaint_timer);
                            g_toolbar.repaint_timer = false;
							g_toolbar.context_menu(x, y, column_idx);
                        }, 25);
                    }
                }
                break;
        }
    }
}


oToolbar = function() {
	this.columns = Array();
	this.drag = false;
	this.click = false;
	this.onBorder = false;
	this.targetId = -1;
	this.repaint_timer = false;
	this.resize_cover_timer = false;
	this.check_saved_event = null;
	this.check_saved_x = 0;
	this.check_saved_y = 0; 
	this.visible = true;
	this.TF_updated = false;
	
    this.setButtons = function() {
		var gfx_font = gdi.Font("guifx v2 transports", 15, 0);
	
		if(properties.themed) {
			var color_txt = g_syscolor_button_txt;
		} else {
			var color_txt = g_color_normal_txt;
		}
		
        // normal settings Image
        this.settingsImage_normal = gdi.CreateImage(cScrollbar.width, this.h);
        var gb = this.settingsImage_normal.GetGraphics();
        // Draw Themed Scrollbar (lg/col)
            var mid_x = Math.round(cScrollbar.width / 2);
			var mid_y = Math.round(this.h / 2);
			gb.FillSolidRect(mid_x - 5, mid_y - 2, 9, 1, color_txt & 0x44ffffff);
			gb.FillSolidRect(mid_x - 4, mid_y - 1, 7, 1, color_txt & 0x44ffffff);
			gb.FillSolidRect(mid_x - 3, mid_y - 0, 5, 1, color_txt & 0x44ffffff);
			gb.FillSolidRect(mid_x - 2, mid_y + 1, 3, 1, color_txt & 0x44ffffff);
			gb.FillSolidRect(mid_x - 1, mid_y + 2, 1, 1, color_txt & 0x44ffffff);
        this.settingsImage_normal.ReleaseGraphics(gb);

        // hover settings Image
        this.settingsImage_hover = gdi.CreateImage(cScrollbar.width, this.h);
        gb = this.settingsImage_hover.GetGraphics();
        // Draw Themed Scrollbar (lg/col)
            var mid_x = Math.round(cScrollbar.width / 2);
			var mid_y = Math.round(this.h / 2);
			gb.FillSolidRect(mid_x - 5, mid_y - 2, 9, 1, color_txt & 0x88ffffff);
			gb.FillSolidRect(mid_x - 4, mid_y - 1, 7, 1, color_txt & 0x88ffffff);
			gb.FillSolidRect(mid_x - 3, mid_y - 0, 5, 1, color_txt & 0x88ffffff);
			gb.FillSolidRect(mid_x - 2, mid_y + 1, 3, 1, color_txt & 0x88ffffff);
			gb.FillSolidRect(mid_x - 1, mid_y + 2, 1, 1, color_txt & 0x88ffffff);
        this.settingsImage_hover.ReleaseGraphics(gb);

        // down settings Image
        this.settingsImage_down = gdi.CreateImage(cScrollbar.width, this.h);
        gb = this.settingsImage_down.GetGraphics();
        // Draw Themed Scrollbar (lg/col)
            var mid_x = Math.round(cScrollbar.width / 2);
			var mid_y = Math.round(this.h / 2);
			gb.FillSolidRect(mid_x - 5, mid_y - 2, 9, 1, color_txt);
			gb.FillSolidRect(mid_x - 4, mid_y - 1, 7, 1, color_txt);
			gb.FillSolidRect(mid_x - 3, mid_y - 0, 5, 1, color_txt);
			gb.FillSolidRect(mid_x - 2, mid_y + 1, 3, 1, color_txt);
			gb.FillSolidRect(mid_x - 1, mid_y + 2, 1, 1, color_txt);
        this.settingsImage_down.ReleaseGraphics(gb);

        this.button = new button(this.settingsImage_normal, this.settingsImage_hover, this.settingsImage_down);
    };
	
	this.setSize = function(x, y, w, h) {
		this.x = x;
		this.y = y;
		this.w = w;
		this.h = h;
		this.visible = (h > 1);
		this.setButtons();
	}
	
	this.setColumns = function() {
		var tmp, fields;
		var coverColumnIndex = 0;
		this.columns.splice(0, this.columns.length);
		this.total_cols = window.GetProperty("SYSTEM.Toolbar.total columns", 0);
		if(this.total_cols == 0) {
			// INIT
			this.total_cols = 14;
			window.SetProperty("SYSTEM.Toolbar.total columns", this.total_cols);
			for(var i=0; i < this.total_cols; i++) {
				switch(i) {
					case 0:
						tmp = "Cover;;0;cover;0";
						break;
					case 1:
						tmp = "Icon;;4000;icon;0";
						break;
					case 2:
						tmp = "Index;;0;index;1";
						break;
					case 3:
						tmp = "#;$if2($num(%tracknumber%,1)'.','-');5000;tracknumber;2";					
						break;
					case 4:
						tmp = "Title;$if2(%title%,%filename_ext%);36500;title;0";
						break;
					case 5:
						tmp = "Year;$if(%date%,$year($replace(%date%,/,-,.,-)),'-');0;date;2";
						break;
					case 6:
						tmp = "Artist;$if(%length%,%artist%,'Stream');33000;artist;0";
						break;
					case 7:
						tmp = "Album;$if2(%album%,$if(%length%,'-','Web radios'));0;album;0";
						break;
					case 8:
						tmp = "Genre;$if2(%genre%,'Other');0;genre;0";
						break;
					case 9:
						tmp = "Mood;$if(%mood%,1,0);5500;mood;1";
						break;
					case 10:
						tmp = "Rating;$if2(%rating%,0);10000;rating;0";
						break;
					case 11:
						tmp = "Plays;$if2(%play_counter%,$if2(%play_count%,0));0;playcount;2";
						break;
					case 12:
						tmp = "Bitrate;$if(%__bitrate_dynamic%,$if(%el_isplaying%,%__bitrate_dynamic%'K',$if($stricmp($left(%codec_profile%,3),'VBR'),%codec_profile%,%__bitrate%'K')),$if($stricmp($left(%codec_profile%,3),'VBR'),%codec_profile%,%__bitrate%'K'));0;bitrate;1";
						break;
					case 13:
						tmp = "Time;$if2(%length%,' 0:00');5900;duration;2";
						break;
					}
					// create column object + linked properties
					fields = tmp.split(";");
					window.SetProperty("SYSTEM.Toolbar.col" + i.toString(), tmp);
					g_toolbar.columns.push(new oColumn(fields[0],fields[1],fields[2],fields[3],fields[4]));
			}
		} else {
			// LECTURE
			for(var i=0; i < this.total_cols; i++) {
				tmp = window.GetProperty("SYSTEM.Toolbar.col" + i.toString(), "?;;0;?;0");
				fields = tmp.split(";");
				this.columns.push(new oColumn(fields[0],fields[1],fields[2],fields[3],fields[4]));
				if(fields[3] == "cover") coverColumnIndex = i;
			}
		}
	}

    this.set = function(gr) {
        var posX = 0;
        for(var i=0; i < this.columns.length; i++) {		
            this.columns[i].x = posX;
            if(this.columns[i].w > 0) {
                if(cGroup.collapsed_height == 0) {
                    // DRAW thin vertical line cols separator in playlist area
                    gr.DrawLine(posX + this.columns[i].w, this.y + this.h, posX + this.columns[i].w, g_list.h, 1.0, g_color_normal_txt & 0x05ffffff);
                }
            }
            if(this.columns[i].click && this.click) {
                gr.FillSolidRect(posX, this.y + this.h, this.columns[i].w + 1, g_list.h, g_color_normal_txt & 0x10ffffff);
            }
            if(this.columns[i].drag && this.drag) {
                gr.FillSolidRect(posX + this.columns[i].w - 1, this.y + this.h, 2, g_list.h, g_color_normal_txt & 0x10ffffff);
            }
            posX += this.columns[i].w;
        }
    }
	
    this.draw = function(gr) {
	
		if(properties.themed) {
			var color_bg = g_syscolor_button_bg;
		} else {
			var color_bg = g_color_normal_bg;
		}
	
		if(this.visible) {
			// bg
			gr.FillSolidRect(this.x, this.y, this.w + cScrollbar.width, this.h-0, color_bg);
			//gr.FillSolidRect(this.x, this.y + this.h + 1-2, this.w + cScrollbar.width, 1, color_bg);
			gr.FillGradRect(this.x, this.y, this.w + cScrollbar.width, this.h + 1-1, 90, RGBA(0,0,0,15), RGBA(0,0,0,60), 1.0);
			// last column for vscrollbar width
			gr.FillSolidRect(this.x + this.w, this.y, cScrollbar.width, g_toolbar.h-1, color_bg);
			gr.FillGradRect(this.x + this.w, this.y + 1, cScrollbar.width, g_toolbar.h - 1-1, 90, RGBA(0,0,0,30), RGBA(255,255,255,30), 1.0);
			gr.FillSolidRect(this.x + this.w, this.y, cScrollbar.width, 1, RGBA(255,255,255,60));
			gr.FillSolidRect(this.x + this.w, this.y, cScrollbar.width, g_toolbar.h-2, RGBA(255,255,255,30));
			// draw columns
			var posX = 0;
			//var total_columns_width = 0;
			for(var i=0; i < this.columns.length; i++) {
				// on last columns to draw, check if its width has to be fixed to fill the whole toolbar (to avoid a gap at the end of the columns that may happened!)
				if(i == this.columns.length - 1) {
					if( (posX + 1 + this.columns[i].w) < this.w) {
						this.columns[i].w = this.w - posX;
					}
				}
				if(this.columns[i].percent > 0) {
					if(!this.columns[i].click) {
						this.columns[i].draw(gr, posX, this.y, i);
					} else {
						this.columns[i].draw_empty(gr, posX, this.y, i);
					}
					posX += this.columns[i].w;
				}
			}
			// draw moved item after all the other ones (to have it always in foreground while moving it
			if(this.click) {
				this.columns[this.targetId].draw(gr, mouse_x, this.y, this.targetId);
			}
			// draw settings button
			this.button.draw(gr, this.x + this.w, this.y, 255);

		} else {
			gr.FillSolidRect(this.x, this.y, this.w + cScrollbar.width, 1, color_bg);
			gr.FillSolidRect(this.x, this.y, this.w + cScrollbar.width, 1, RGBA(0,0,0,70));
		}

    }
	
    this.buttonCheck = function(event, x, y) {
		var state = this.button.checkstate(event, x, y);
		switch(event) {
        case "up":
			if(state == ButtonStates.hover) {
				this.settings_menu(x, y);
			}
            break;
        }
		return state;
    }
	
    this.check = function(event, x, y) {
        this.is_hover = (x > this.x && x < this.x + this.w && y > this.y && y < this.y + this.h);
		
		// check settings button + toolbar if button not hover
		if(this.buttonCheck(event, x, y) != ButtonStates.hover) {
			switch(event) {
				case "up":
					this.click = false;
					for(var i=0; i < this.columns.length; i++) {
						if(this.columns[i].w != 0) {
							this.columns[i].check(x, y, event, i);
						}
					}
					break;
				case "dblclk":
					if(this.is_hover) g_list.showNowPlaying();
					break;
				default:
					for(var i=0; i < this.columns.length; i++) {
						if(this.columns[i].w != 0) {
							this.columns[i].check(x, y, event, i);
						}
					}
			}
		}
    }
	
	this.context_menu = function(x, y, column_index) {
		var idx;
		var _menu = window.CreatePopupMenu();
		var _this = window.CreatePopupMenu();
		var _groups = window.CreatePopupMenu();
		var _collapsed_height = window.CreatePopupMenu();
		var _expanded_height = window.CreatePopupMenu();
		var _columns = window.CreatePopupMenu();
		
		// edit clicked column
		_this.AppendTo(_menu, MF_STRING, "Edit this column...");
		_this.AppendMenuItem(MF_STRING, 20, "Name");
		if(this.columns[column_index].ref != "cover") {
			_this.AppendMenuItem(MF_STRING, 21, "Pattern");
			_this.AppendMenuSeparator();
			_this.AppendMenuItem(MF_STRING, 30, "Alignment Left");
			_this.AppendMenuItem(MF_STRING, 31, "Alignment Center");
			_this.AppendMenuItem(MF_STRING, 32, "Alignment Right");
			_this.CheckMenuRadioItem(30, 32, this.columns[column_index].align + 30);
		}
		_menu.AppendMenuSeparator();
		_menu.AppendMenuItem(MF_STRING, 1, "Lock Toolbar");
		_menu.CheckMenuItem(1, cToolbar.locked ? 1 : 0);
		_menu.AppendMenuItem(fb.IsPlaying ? MF_STRING : MF_GRAYED | MF_DISABLED, 2, "Show Now Playing");
		//_menu.AppendMenuItem(plman.IsPlaybackQueueActive() ? MF_STRING : MF_GRAYED | MF_DISABLED, 3, "Show Queue Playlist");
		_menu.AppendMenuItem(MF_STRING, 3, "Show Queue Playlist");
		//_menu.AppendMenuItem(((cover.show || cover.column) && g_list.count > 0) ? MF_STRING : MF_DISABLED | MF_GRAYED, 4, "Refresh Covers");
		_menu.AppendMenuSeparator();
		_groups.AppendTo(_menu, MF_STRING, "Groups");
		_groups.AppendMenuItem(MF_STRING, 40, "Enable");
		if(cGroup.collapsed_height > 0) {
			_groups.CheckMenuItem(40, cGroup.collapsed_height > 0 ? 1 : 0);
			_groups.AppendMenuItem(MF_STRING, 41, "Show Cover");
			_groups.CheckMenuItem(41, cover.show ? 1 : 0);
			_groups.AppendMenuSeparator();
			_collapsed_height.AppendTo(_groups, cGroup.collapsed_height > 0 ? MF_STRING : MF_GRAYED | MF_DISABLED, "Collapsed Height");
			_collapsed_height.AppendMenuItem(MF_STRING, 51, "1 row (no cover)");
			_collapsed_height.AppendMenuItem(MF_STRING, 52, "2 rows");
			_collapsed_height.AppendMenuItem(MF_STRING, 53, "3 rows");
			_collapsed_height.AppendMenuItem(MF_STRING, 54, "4 rows");
			_collapsed_height.CheckMenuRadioItem(51, 54, cGroup.default_collapsed_height + 50);
			_expanded_height.AppendTo(_groups, cGroup.collapsed_height > 0 ? MF_STRING : MF_GRAYED | MF_DISABLED, "Expanded Height");
			_expanded_height.AppendMenuItem(MF_STRING, 56, "1 row (no cover)");
			_expanded_height.AppendMenuItem(MF_STRING, 57, "2 rows");
			_expanded_height.AppendMenuItem(MF_STRING, 58, "3 rows");
			_expanded_height.AppendMenuItem(MF_STRING, 59, "4 rows");
			_expanded_height.CheckMenuRadioItem(56, 59, cGroup.default_expanded_height + 55);
			_groups.AppendMenuItem(cGroup.collapsed_height > 0 ? MF_STRING : MF_GRAYED | MF_DISABLED, 70, "Auto-Collapse");
			_groups.CheckMenuItem(70, properties.autocollapse ? 1 : 0);
			_groups.AppendMenuItem(g_list.totalRows > 0 && !properties.autocollapse && properties.showgroupheaders ? MF_STRING  : MF_GRAYED | MF_DISABLED, 80, "Collapse All");
			_groups.AppendMenuItem(g_list.totalRows > 0 && !properties.autocollapse && properties.showgroupheaders ? MF_STRING  : MF_GRAYED | MF_DISABLED, 90, "Expand All");
		}
		
		var columnMenuIdx = 100;
		_menu.AppendMenuSeparator();
		_columns.AppendTo(_menu, MF_STRING, "Columns");

		// list all columns
		//_columns.AppendMenuSeparator();
		for(var i=0; i < this.columns.length; i++) {
			if(i == column_index) {
				_columns.AppendMenuItem(MF_STRING, columnMenuIdx + i, "["+this.columns[i].label+"]");
			} else {
				_columns.AppendMenuItem(MF_STRING, columnMenuIdx + i, this.columns[i].label);
			}
			_columns.CheckMenuItem(columnMenuIdx + i, this.columns[i].w > 0 ? 1 : 0);
		}
		
		if(utils.IsKeyPressed(VK_SHIFT)) {
			_menu.AppendMenuSeparator();
			_menu.AppendMenuItem(MF_STRING, 980, "Properties");
			_menu.AppendMenuItem(MF_STRING, 990, "Configure ...");
		}
		idx = _menu.TrackPopupMenu(x, y);
		
		switch(true) {
			case (idx==1):
				// Lock Toolbar
				cToolbar.locked = !cToolbar.locked;
				window.SetProperty("CUSTOM Lock Toolbar", cToolbar.locked);
				break;
			case (idx==2):
				// Show now playing
				g_list.showNowPlaying();
				break;
			case (idx==3):
				ShowPlaylistQueue(0);
				break;
			case (idx==4):
				g_image_cache = new image_cache;
				CollectGarbage();
				g_list.Repaint();
				break;
			case (idx==20):
				var label = this.columns[column_index].label;
				var new_label = InputBox("Enter new name: ", "Update name of column ["+label+"]", label);
				if(new_label=="") new_label = label;
				if(new_label) {
					var tmp = window.GetProperty("SYSTEM.Toolbar.col" + column_index.toString(), "?;;0;?;0");
					var fields = tmp.split(";");
					tmp = new_label+";"+fields[1]+";"+fields[2]+";"+fields[3]+";"+fields[4];
					window.SetProperty("SYSTEM.Toolbar.col" + column_index.toString(), tmp);
					this.setColumns();
					window.Repaint();
				}
				break;
			case (idx==21):
				var label = this.columns[column_index].label;
				var tf = this.columns[column_index].tf;
				var new_tf = InputBox("Enter new pattern: ", "Update pattern for column ["+label+"]", tf);
				if(new_tf=="") new_tf = tf;
				if(new_tf) {
					this.TF_updated = true; // reset to false in oList.draw when items draw is done
					var tmp = window.GetProperty("SYSTEM.Toolbar.col" + column_index.toString(), "?;;0;?;0");
					var fields = tmp.split(";");
					tmp = fields[0]+";"+new_tf+";"+fields[2]+";"+fields[3]+";"+fields[4];
					window.SetProperty("SYSTEM.Toolbar.col" + column_index.toString(), tmp);
					this.setColumns();
					g_list.Repaint();
				}
				break;
			case (idx>=30 && idx <=32):
				var tmp = window.GetProperty("SYSTEM.Toolbar.col" + column_index.toString(), "?;;0;?;0");
				var fields = tmp.split(";");
				tmp = tmp.substr(0, tmp.length - 1) + (idx - 30).toString();
				window.SetProperty("SYSTEM.Toolbar.col" + column_index.toString(), tmp);
				this.setColumns();
				window.Repaint();
				break;
			case (idx==40):
				if(cGroup.collapsed_height > 0) {
					cGroup.collapsed_height = 0;
					cGroup.expanded_height = 0;
					properties.showgroupheaders = false;
					window.SetProperty("*GROUP: Show Group Headers", properties.showgroupheaders);
					// disable autocollapse when there is no group!
					properties.autocollapse = false;
					window.SetProperty("SYSTEM.Auto-Collapse", properties.autocollapse);
				} else {
					cGroup.collapsed_height = cGroup.default_collapsed_height;
					cGroup.expanded_height = cGroup.default_expanded_height;
					properties.showgroupheaders = true;
					window.SetProperty("*GROUP: Show Group Headers", properties.showgroupheaders);
				}
				// refresh playlist
				g_list.updateHandleList(plman.ActivePlaylist);
				g_list.setItems(true);
				g_scrollbar.setCursor(g_list.totalRowVisible, g_list.totalRows, g_list.offset);
				g_list.Repaint();
				break;
			case (idx==41):
				cover.show = !cover.show;
				window.SetProperty("*GROUP: Show Cover Art", cover.show);
				g_list.setItems(false);
				g_scrollbar.setCursor(g_list.totalRowVisible, g_list.totalRows, g_list.offset);
				g_list.Repaint();
				break;
			case (idx>=51 && idx <=54):
				window.SetProperty("*GROUP: Total Rows COLLAPSED", idx - 50);
				cGroup.default_collapsed_height = window.GetProperty("*GROUP: Total Rows COLLAPSED", 2);
				cGroup.collapsed_height = cGroup.default_collapsed_height;
				// update max_w et max_h for cover loading and repaint in cache image handle functions
				cover.max_w = cGroup.default_collapsed_height > cGroup.default_expanded_height ? cGroup.default_collapsed_height * cTrack.height : cGroup.default_expanded_height * cTrack.height;
				cover.max_h = cGroup.default_collapsed_height > cGroup.default_expanded_height ? cGroup.default_collapsed_height * cTrack.height : cGroup.default_expanded_height * cTrack.height;
				// refresh playlist
				g_image_cache = new image_cache;
				CollectGarbage();
				g_list.updateHandleList(plman.ActivePlaylist);
				g_list.setItems(true);
				g_scrollbar.setCursor(g_list.totalRowVisible, g_list.totalRows, g_list.offset);
				g_list.Repaint();
				break;
			case (idx>=56 && idx <=59):
				window.SetProperty("*GROUP: Total Rows EXPANDED", idx - 55);
				cGroup.default_expanded_height = window.GetProperty("*GROUP: Total Rows EXPANDED", 3);
				cGroup.expanded_height = cGroup.default_expanded_height;
				// update max_w et max_h for cover loading and repaint in cache image handle functions
				cover.max_w = cGroup.default_collapsed_height > cGroup.default_expanded_height ? cGroup.default_collapsed_height * cTrack.height : cGroup.default_expanded_height * cTrack.height;
				cover.max_h = cGroup.default_collapsed_height > cGroup.default_expanded_height ? cGroup.default_collapsed_height * cTrack.height : cGroup.default_expanded_height * cTrack.height;
				// refresh playlist
				g_image_cache = new image_cache;
				CollectGarbage();
				g_list.updateHandleList(plman.ActivePlaylist);
				g_list.setItems(true);
				g_scrollbar.setCursor(g_list.totalRowVisible, g_list.totalRows, g_list.offset);
				g_list.Repaint();
				break;
			case (idx==70):
				properties.autocollapse = !properties.autocollapse;
				window.SetProperty("SYSTEM.Auto-Collapse", properties.autocollapse);
				g_list.updateHandleList(plman.ActivePlaylist);
				g_list.setItems(true);
				g_scrollbar.setCursor(g_list.totalRowVisible, g_list.totalRows, g_list.offset);
				g_list.Repaint();
				break;
			case (idx==80):
				for(var i = 0; i < g_list.groups.length; i++) {
					g_list.groups[i].collapsed = true;
					g_list.groups[i].totalPreviousRows = i * cGroup.collapsed_height;
				}
				g_list.totalRows = g_list.groups.length * cGroup.collapsed_height;
				//
				g_list.setItems(true);
				g_scrollbar.setCursor(g_list.totalRowVisible, g_list.totalRows, g_list.offset);
				g_list.Repaint();
				break;
			case (idx==90):
				g_list.totalRows = 0;
				for(var i = 0; i < g_list.groups.length; i++) {
					g_list.groups[i].collapsed = false;
					g_list.groups[i].totalPreviousRows = g_list.totalRows;
					g_list.totalRows += cGroup.default_expanded_height + g_list.groups[i].count + g_list.groups[i].rowsToAdd;
				}
				//
				g_list.setItems(true);
				g_scrollbar.setCursor(g_list.totalRowVisible, g_list.totalRows, g_list.offset);
				g_list.Repaint();
				break;
			case (idx>=100 && idx<=200):
				// all size changes are in percent / ww
				if(this.columns[idx-100].percent == 0) {
					var newColumnSize = 8000;
					this.columns[idx-100].percent = newColumnSize;
					var totalColsToResizeDown = 0;
					var last_idx = 0;
					for(var k=0; k < this.columns.length; k++) {
						if(k != idx - 100 && this.columns[k].percent > newColumnSize) {
							totalColsToResizeDown++;
							last_idx = k;
						}
					}
					var minus_value = Math.floor(newColumnSize / totalColsToResizeDown);
					var reste = newColumnSize - (minus_value * totalColsToResizeDown);
					for(var k=0; k < this.columns.length; k++) {
						if(k != idx - 100 && this.columns[k].percent > newColumnSize) {
							this.columns[k].percent = Math.round(this.columns[k].percent) - minus_value;
							if(reste > 0 && k == last_idx) {
								this.columns[k].percent = Math.round(this.columns[k].percent) - reste;
							}
						}
						window.SetProperty("SYSTEM.Toolbar.col"+(k).toString(), this.columns[k].label + ";" + this.columns[k].tf + ";" + this.columns[k].percent + ";" + this.columns[k].ref + ";" + this.columns[k].align);
						this.columns[k].w = Math.round(this.w * this.columns[k].percent / 100000);
					}
				} else {
					// check if it's not the last column visible, otherwise, we coundn't hide it!
					var nbvis = 0;
					for(var k=0; k < this.columns.length; k++) {
						if(this.columns[k].percent > 0) {
							nbvis++;
						}
					}
					if(nbvis > 1) {
						var RemovedColumnSize = Math.round(this.columns[idx-100].percent);
						this.columns[idx-100].percent = 0;
						var totalColsToResizeUp = 0;
						var last_idx = 0;
						for(var k=0; k < this.columns.length; k++) {
							if(k != idx - 100 && this.columns[k].percent > 0) {
								totalColsToResizeUp++;
								last_idx = k;
							}
						}
						var add_value = Math.floor(RemovedColumnSize / totalColsToResizeUp);
						var reste = RemovedColumnSize - (minus_value * totalColsToResizeUp);
						for(var k=0; k < this.columns.length; k++) {
							if(k != idx - 100 && this.columns[k].percent > 0) {
								this.columns[k].percent = Math.round(this.columns[k].percent) + add_value;
								if(reste > 0 && k == last_idx) {
									this.columns[k].percent = Math.round(this.columns[k].percent) + reste;
								}
							}
							window.SetProperty("SYSTEM.Toolbar.col"+(k).toString(), this.columns[k].label + ";" + this.columns[k].tf + ";" + this.columns[k].percent + ";" + this.columns[k].ref + ";" + this.columns[k].align);
							this.columns[k].w = Math.round(this.w * this.columns[k].percent / 100000);
						}
					}
				}
				// set minimum rows / cover column size
				if(idx == 100) { // cover column added or removed
					if(g_toolbar.columns[0].w > 0) {
						cover.column = true;
						cGroup.count_minimum = Math.ceil( (g_toolbar.columns[0].w) / cTrack.height);
						if(cGroup.count_minimum < cGroup.default_count_minimum) cGroup.count_minimum = cGroup.default_count_minimum;
					} else {
						cover.column = false;
						cGroup.count_minimum = cGroup.default_count_minimum;
					}
					cover.previous_max_size = g_toolbar.columns[0].w;
					g_image_cache = new image_cache;
					CollectGarbage();
					update_playlist();
				}
				break;
			case (idx==980):
				window.ShowProperties();
				break;
			case (idx==990):
				window.ShowConfigure();
				break;
			default:
		};
		_menu.Dispose();
		//
		this.columns[column_index].rightClicked = false;
		window.Repaint();
		return true;
	}
	
	this.settings_menu = function(x, y) {
		var idx;
		var _menu = window.CreatePopupMenu();

		//_menu.AppendMenuItem(MF_STRING, 1, "Lock Toolbar");
		//_menu.CheckMenuItem(1, cToolbar.locked ? 1 : 0);
		//_menu.AppendMenuItem(fb.IsPlaying ? MF_STRING : MF_GRAYED | MF_DISABLED, 2, "Show Now Playing");
		_menu.AppendMenuItem(((cover.show || cover.column) && g_list.count > 0) ? MF_STRING : MF_DISABLED | MF_GRAYED, 4, "Refresh Covers");
		_menu.AppendMenuItem(MF_STRING, 5, "Toggle Playlist Header");
		_menu.AppendMenuItem(MF_STRING, 6, "Toggle Scrollbar");
		_menu.AppendMenuItem(MF_STRING, 7, "Toggle Themed Style");
		_menu.AppendMenuItem(MF_STRING, 8, "Toggle Wallpaper");
		if(utils.IsKeyPressed(VK_SHIFT)) {
			_menu.AppendMenuSeparator();
			_menu.AppendMenuItem(MF_STRING, 980, "Properties");
			_menu.AppendMenuItem(MF_STRING, 990, "Configure ...");
		}
		idx = _menu.TrackPopupMenu(x, y);
		
		switch(true) {
			case (idx==1):
				// Lock Toolbar
				cToolbar.locked = !cToolbar.locked;
				window.SetProperty("CUSTOM Lock Toolbar", cToolbar.locked);
				break;
			case (idx==2):
				// Show now playing
				g_list.showNowPlaying();
				break;
			case (idx==3):
				//ShowPlaylistQueue(0);
				break;
			case (idx==4):
				g_image_cache = new image_cache;
				CollectGarbage();
				g_list.Repaint();
				break;
			case (idx==5):
				// Lock Topbar
				cTopbar.locked = !cTopbar.locked;
				window.SetProperty("CUSTOM Lock Topbar", cTopbar.locked);
				on_size();
				window.Repaint();
				break;
			case (idx==6):
				properties.showscrollbar = !properties.showscrollbar;
				window.SetProperty("CUSTOM Show Scrollbar", properties.showscrollbar);
				g_list.Repaint();
				break;
			case (idx==7):
				properties.themed = !properties.themed;
				window.SetProperty("CUSTOM Use Themed Style", properties.themed);
				g_scrollbar = new oScrollbar(properties.themed);
				// set Size of scrollbar
				g_scrollbar.setSize(ww - cScrollbar.width, g_topbar.h + this.h, cScrollbar.width, wh - g_topbar.h - this.h);
				g_scrollbar.setCursor(g_list.totalRowVisible, g_list.totalRows, g_list.offset);
				window.Repaint();
				break;
			case (idx==8):
				properties.showwallpaper = !properties.showwallpaper;
				window.SetProperty("CUSTOM Show Wallpaper", properties.showwallpaper);
				// set wallpaper
				if(fb.IsPlaying) {
					g_wallpaper_img = setWallpaperImg(properties.wallpaperpath, fb.GetNowPlaying());
				} else {
					g_wallpaper_img = setWallpaperImg(properties.wallpaperpath, null);
				}
				g_list.Repaint();
				break;
			case (idx==980):
				window.ShowProperties();
				break;
			case (idx==990):
				window.ShowConfigure();
				break;
			default:
		};
		_menu.Dispose();
		return true;
	}
}

oGroup = function(index, start, count, total_time_length, focusedTrackId) {
	this.index = index;
	this.start = start;
	this.count = count;
	this.total_time_length = total_time_length;
	this.total_group_duration_txt = formatPlaylistTotalDurationText(total_time_length);

	if(count < cGroup.count_minimum) {
		this.rowsToAdd = cGroup.count_minimum - count;
	} else {
		this.rowsToAdd = 0;
	}
	// Add extra rows to the total rows of the group
	this.rowsToAdd += cGroup.extra_rows;

	if(properties.autocollapse) {
		if(focusedTrackId >= this.start && focusedTrackId < this.start + this.count) { // focused track is in this group!
			this.collapsed = false;
			// save in globals the current group id of the focused track (used for autocollapse option)
			g_group_id_focused = this.index;
		} else {
			this.collapsed = true;
		}
	} else {
		this.collapsed = false;
	}
	
	this.totalPreviousRows = 0;

	this.collapse = function() {
		this.collapse = true;
	}

	this.expand = function() {
		this.collapse = false;
	}
};

oItem = function (playlist, row_index, type, handle, track_index, group_index, track_index_in_group, heightInRow, groupRowDelta, obj, empty_row_index) {
    // type 1 = group
    // type 0 = track
    this.type = type;
    this.playlist = playlist;
    this.row_index = row_index;
    this.metadb = handle;
    this.track_index = track_index;
    this.track_index_in_group = track_index_in_group;
    this.group_index = group_index;
    this.heightInRow = heightInRow;
    this.groupRowDelta = groupRowDelta;
    this.obj = obj;
    this.empty_row_index = empty_row_index;
    //
    this.tracktype = TrackType(this.metadb.rawpath.substring(0, 4));
    this.l_rating = 0;
    this.l_mood = 0;

    this.setGroupMeta = function () {
        if (this.type == 1) {
            if (this.metadb) {
                var a_fields = tf_album_meta.EvalWithMetadb(this.metadb).split("^^");
                this.albumartist = a_fields[0];
                this.album = a_fields[1];
                this.genre = a_fields[2];
                this.date = a_fields[3];
            }
        }
    }
    this.setGroupMeta();

    this.drawRowContents = function (gr) {
        // Draw columns content
        var cx, cw;
		var patterns = "";

        // if current playlist is a quicksearch result playlist, highlight searched text in playlist
        var plname = plman.GetPlaylistName(plman.ActivePlaylist);
        var search = null;
        if (plname.substr(0, 8) == "Search [") {
            search = plname.substr(8, plname.length - 9).toLowerCase();
        }
        var search_ante_width = 0;
        var search_found_text_width = 0;
        var search_found_text = "";
        var search_full_column_text = "";
	
		columns.rating_w = 0;
		columns.mood_w = 0;
		
        for (var j = 0; j < g_toolbar.columns.length; j++) {
            if (g_toolbar.columns[j].w > 0) {
                cx = g_toolbar.columns[j].x + 6;
                cw = g_toolbar.columns[j].w - 12;
                switch (g_toolbar.columns[j].ref) {
                case "icon":
                    if (fb.IsPlaying) {
                        if (plman.PlayingPlaylist == plman.ActivePlaylist) {
                            g_list.nowplaying = plman.GetPlayingItemLocation();
                            if (this.track_index == g_list.nowplaying.PlaylistItemIndex) {
                                switch (g_toolbar.columns[j].align) {
                                case 0:
                                    var icon_x = cx - 1;
                                    break;
                                case 1:
                                    var icon_x = cx + Math.round((cw - images.playicon_off.Width) / 2) + 7;
                                    break;
                                case 2:
                                    var icon_x = cx + cw - images.playicon_off.Width + 7;
                                    break;
                                }
                                if (fb.isPaused) {
                                    gr.DrawImage(images.pauseicon, icon_x, this.y, images.pauseicon.Width, images.pauseicon.Height, 0, 0, images.pauseicon.Width, images.pauseicon.Height, 0, 255);
                                } else {
                                    if (g_seconds / 2 == Math.floor(g_seconds / 2)) {
                                        gr.DrawImage(images.playicon_off, icon_x, this.y, images.playicon_off.Width, images.playicon_off.Height, 0, 0, images.playicon_off.Width, images.playicon_off.Height, 0, 255);
                                    } else {
                                        gr.DrawImage(images.playicon_on, icon_x, this.y, images.playicon_on.Width, images.playicon_on.Height, 0, 0, images.playicon_on.Width, images.playicon_on.Height, 0, 255);
                                    }
                                }
                            }
                        }
                    }
                    break;
                case "index":
                    try {
                        gr.GdiDrawText(num(this.track_index + 1, g_list.count.toString().length) + '.', g_font, blendColors(this.text_colour, g_color_normal_bg, 0.5), cx, this.y, cw, this.h + cTrack.parity, g_toolbar.columns[j].DT_align | DT_CALCRECT | DT_VCENTER | DT_END_ELLIPSIS | DT_NOPREFIX);
                    } catch (e) {}
                    break;
                case "tracknumber":
                    //if (typeof (this.tracknumber) == "undefined" || g_toolbar.TF_updated) this.tracknumber = fields[j];
                    if (typeof (this.tracknumber) == "undefined" || g_toolbar.TF_updated) this.tracknumber = fb.TitleFormat(g_toolbar.columns[j].tf).EvalWithMetadb(this.metadb);
                    //if (typeof (this.tracknumber) == "undefined" || g_toolbar.TF_updated) this.tracknumber = g_item_cache.hit(this.metadb, g_toolbar.columns[j].tf);
                    try {
                        gr.GdiDrawText(this.tracknumber, g_font, this.text_colour, cx, this.y, cw, this.h + cTrack.parity, g_toolbar.columns[j].DT_align | DT_CALCRECT | DT_VCENTER | DT_END_ELLIPSIS | DT_NOPREFIX);
                    } catch (e) {}
                    break;
                case "title":
					//if(typeof(this.title) == "undefined" || g_toolbar.TF_updated) this.title = fields[j];
                    if(typeof(this.title) == "undefined" || g_toolbar.TF_updated) this.title = fb.TitleFormat(g_toolbar.columns[j].tf).EvalWithMetadb(this.metadb);
                    //if (typeof (this.title) == "undefined" || g_toolbar.TF_updated) this.title = g_item_cache.hit(this.metadb, g_toolbar.columns[j].tf);
                    var ref_w = gr.CalcTextWidth(this.title, g_font);
                    this.tooltip = (ref_w > cw);
                    // highlight search text found!!!
                    search_full_column_text = this.title;
                    if (properties.highlightsearch && search != null) {
                        search_pos = search_full_column_text.toLowerCase().indexOf(search);
                        if (search_pos != -1) {
                            search_ante_text = search_full_column_text.substr(0, search_pos);
                            search_ante_width = gr.CalcTextWidth(search_ante_text, g_font);
                            search_found_text = search_full_column_text.substr(search_pos, search.length);
                            search_found_text_width = gr.CalcTextWidth(search_found_text, g_font);
                            var search_available_width = (cw - search_ante_width < search_found_text_width) ? (cw - search_ante_width) : search_found_text_width;
                            if (search_available_width >= 6) {
                                gr.SetSmoothingMode(2);
                                gr.FillRoundRect(cx + search_ante_width - 2, this.y + 06, search_available_width + 2, this.h + cTrack.parity - 13, 2, 2, this.search_colour_bg);
                                gr.DrawRoundRect(cx + search_ante_width - 2, this.y + 06, search_available_width + 2, this.h + cTrack.parity - 13, 2, 2, 2.0, this.search_colour_bd);
                                gr.SetSmoothingMode(0);
                            }
                        }
                    }
                    try {
                        gr.GdiDrawText(this.title, g_font, this.text_colour, cx, this.y, cw, this.h + cTrack.parity, g_toolbar.columns[j].DT_align | DT_CALCRECT | DT_VCENTER | DT_END_ELLIPSIS | DT_NOPREFIX);
                    } catch (e) {}
                    break;
                case "date":
                    //if (typeof (this.date) == "undefined" || g_toolbar.TF_updated) this.date = fields[j];
                    if (typeof (this.date) == "undefined" || g_toolbar.TF_updated) this.date = fb.TitleFormat(g_toolbar.columns[j].tf).EvalWithMetadb(this.metadb);
                    //if (typeof (this.date) == "undefined" || g_toolbar.TF_updated) this.date = g_item_cache.hit(this.metadb, g_toolbar.columns[j].tf);
                    try {
                        gr.GdiDrawText(this.date, g_font, this.text_colour, cx, this.y, cw, this.h + cTrack.parity, g_toolbar.columns[j].DT_align | DT_CALCRECT | DT_VCENTER | DT_END_ELLIPSIS | DT_NOPREFIX);
                    } catch (e) {}
                    break;
                case "playcount":
                    //if (typeof (this.playcount) == "undefined" || g_toolbar.TF_updated) this.playcount = fields[j];
                    if (typeof (this.playcount) == "undefined" || g_toolbar.TF_updated) this.playcount = fb.TitleFormat(g_toolbar.columns[j].tf).EvalWithMetadb(this.metadb);
                    //if (typeof (this.playcount) == "undefined" || g_toolbar.TF_updated) this.playcount = g_item_cache.hit(this.metadb, g_toolbar.columns[j].tf);
                    gr.GdiDrawText(this.playcount, g_font, this.text_colour, cx, this.y, cw, this.h + cTrack.parity, g_toolbar.columns[j].DT_align | DT_CALCRECT | DT_VCENTER | DT_END_ELLIPSIS | DT_NOPREFIX);
                    break;
                case "bitrate":
                    //if (typeof (this.bitrate) == "undefined" || g_toolbar.TF_updated) this.bitrate = fields[j];
                    if (typeof (this.bitrate) == "undefined" || g_toolbar.TF_updated) this.bitrate = fb.TitleFormat(g_toolbar.columns[j].tf).EvalWithMetadb(this.metadb);
                    //if (typeof (this.bitrate) == "undefined" || g_toolbar.TF_updated) this.bitrate = g_item_cache.hit(this.metadb, g_toolbar.columns[j].tf);
                    if (fb.IsPlaying) {
                        if (plman.PlayingPlaylist == this.playlist) {
                            this.nowplaying = plman.GetPlayingItemLocation();
                            if (this.track_index != this.nowplaying.PlaylistItemIndex) {
                                var tmp_bitrate = this.bitrate;
                            } else {
                                var tmp_bitrate = this.playing_bitrate;
                            }
                        }
                    } else {
                        var tmp_bitrate = this.bitrate;
                    }
                    if (typeof (tmp_bitrate) == "undefined") tmp_bitrate = fb.TitleFormat(g_toolbar.columns[j].tf).EvalWithMetadb(this.metadb);
                    try {
                        gr.GdiDrawText(tmp_bitrate, g_font, this.text_colour, cx, this.y, cw, this.h + cTrack.parity, g_toolbar.columns[j].DT_align | DT_CALCRECT | DT_VCENTER | DT_END_ELLIPSIS | DT_NOPREFIX);
                    } catch (e) {}
                    break;
                case "artist":
                    //if (typeof (this.artist) == "undefined" || g_toolbar.TF_updated) this.artist = fields[j];
                    if (typeof (this.artist) == "undefined" || g_toolbar.TF_updated) this.artist = fb.TitleFormat(g_toolbar.columns[j].tf).EvalWithMetadb(this.metadb);
                    //if (typeof (this.artist) == "undefined" || g_toolbar.TF_updated) this.artist = g_item_cache.hit(this.metadb, g_toolbar.columns[j].tf);
                    // highlight search text found!!!
                    search_full_column_text = this.artist;
                    if (properties.highlightsearch && search != null) {
                        search_pos = search_full_column_text.toLowerCase().indexOf(search);
                        if (search_pos != -1) {
                            search_ante_text = search_full_column_text.substr(0, search_pos);
                            search_ante_width = gr.CalcTextWidth(search_ante_text, g_font);
                            search_found_text = search_full_column_text.substr(search_pos, search.length);
                            search_found_text_width = gr.CalcTextWidth(search_found_text, g_font);
                            var search_available_width = (cw - search_ante_width < search_found_text_width) ? (cw - search_ante_width) : search_found_text_width;
                            if (search_available_width >= 6) {
                                gr.SetSmoothingMode(2);
                                gr.FillRoundRect(cx + search_ante_width - 2, this.y + 06, search_available_width + 2, this.h + cTrack.parity - 13, 2, 2, this.search_colour_bg);
                                gr.DrawRoundRect(cx + search_ante_width - 2, this.y + 06, search_available_width + 2, this.h + cTrack.parity - 13, 2, 2, 2.0, this.search_colour_bd);
                                gr.SetSmoothingMode(0);
                            }
                        }
                    }
                    try {
                        gr.GdiDrawText(this.artist, g_font, this.text_colour, cx, this.y, cw, this.h + cTrack.parity, g_toolbar.columns[j].DT_align | DT_CALCRECT | DT_VCENTER | DT_END_ELLIPSIS | DT_NOPREFIX);
                    } catch (e) {}
                    break;
                case "album":
                    //if (typeof (this.album) == "undefined" || g_toolbar.TF_updated) this.album = fields[j];
                    if (typeof (this.album) == "undefined" || g_toolbar.TF_updated) this.album = fb.TitleFormat(g_toolbar.columns[j].tf).EvalWithMetadb(this.metadb);
                    //if (typeof (this.album) == "undefined" || g_toolbar.TF_updated) this.album = g_item_cache.hit(this.metadb, g_toolbar.columns[j].tf);
                    // highlight search text found!!!
                    search_full_column_text = this.album;
                    if (properties.highlightsearch && search != null) {
                        search_pos = search_full_column_text.toLowerCase().indexOf(search);
                        if (search_pos != -1) {
                            search_ante_text = search_full_column_text.substr(0, search_pos);
                            search_ante_width = gr.CalcTextWidth(search_ante_text, g_font);
                            search_found_text = search_full_column_text.substr(search_pos, search.length);
                            search_found_text_width = gr.CalcTextWidth(search_found_text, g_font);
                            var search_available_width = (cw - search_ante_width < search_found_text_width) ? (cw - search_ante_width) : search_found_text_width;
                            if (search_available_width >= 6) {
                                gr.SetSmoothingMode(2);
                                gr.FillRoundRect(cx + search_ante_width - 2, this.y + 06, search_available_width + 2, this.h + cTrack.parity - 13, 2, 2, this.search_colour_bg);
                                gr.DrawRoundRect(cx + search_ante_width - 2, this.y + 06, search_available_width + 2, this.h + cTrack.parity - 13, 2, 2, 2.0, this.search_colour_bd);
                                gr.SetSmoothingMode(0);
                            }
                        }
                    }
                    try {
                        gr.GdiDrawText(this.album, g_font, this.text_colour, cx, this.y, cw, this.h + cTrack.parity, g_toolbar.columns[j].DT_align | DT_CALCRECT | DT_VCENTER | DT_END_ELLIPSIS | DT_NOPREFIX);
                    } catch (e) {}
                    break;
                case "genre":
                    //if (typeof (this.genre) == "undefined" || g_toolbar.TF_updated) this.genre = fields[j];
                    if (typeof (this.genre) == "undefined" || g_toolbar.TF_updated) this.genre = fb.TitleFormat(g_toolbar.columns[j].tf).EvalWithMetadb(this.metadb);
                    //if (typeof (this.genre) == "undefined" || g_toolbar.TF_updated) this.genre = g_item_cache.hit(this.metadb, g_toolbar.columns[j].tf);
                    // highlight search text found!!!
                    search_full_column_text = this.genre;
                    if (properties.highlightsearch && search != null) {
                        search_pos = search_full_column_text.toLowerCase().indexOf(search);
                        if (search_pos != -1) {
                            search_ante_text = search_full_column_text.substr(0, search_pos);
                            search_ante_width = gr.CalcTextWidth(search_ante_text, g_font);
                            search_found_text = search_full_column_text.substr(search_pos, search.length);
                            search_found_text_width = gr.CalcTextWidth(search_found_text, g_font);
                            var search_available_width = (cw - search_ante_width < search_found_text_width) ? (cw - search_ante_width) : search_found_text_width;
                            if (search_available_width >= 6) {
                                gr.SetSmoothingMode(2);
                                gr.FillRoundRect(cx + search_ante_width - 2, this.y + 06, search_available_width + 2, this.h + cTrack.parity - 13, 2, 2, this.search_colour_bg);
                                gr.DrawRoundRect(cx + search_ante_width - 2, this.y + 06, search_available_width + 2, this.h + cTrack.parity - 13, 2, 2, 2.0, this.search_colour_bd);
                                gr.SetSmoothingMode(0);
                            }
                        }
                    }
                    try {
                        gr.GdiDrawText(this.genre, g_font, this.text_colour, cx, this.y, cw, this.h + cTrack.parity, g_toolbar.columns[j].DT_align | DT_CALCRECT | DT_VCENTER | DT_END_ELLIPSIS | DT_NOPREFIX);
                    } catch (e) {}
                    break;
                case "mood":
                    //if (typeof (this.mood) == "undefined" || g_toolbar.TF_updated) this.mood = fields[j];
                    if (typeof (this.mood) == "undefined" || g_toolbar.TF_updated) this.mood = fb.TitleFormat(g_toolbar.columns[j].tf).EvalWithMetadb(this.metadb);
                    //if (typeof (this.mood) == "undefined" || g_toolbar.TF_updated) this.mood = g_item_cache.hit(this.metadb, g_toolbar.columns[j].tf);
                    columns.mood = true;
                    // column width
                    if (g_font_guifx_found) {
                        columns.mood_w = gr.CalcTextWidth("v", g_font_mood) + 3;
                    } else {
                        columns.mood_w = gr.CalcTextWidth("?", g_font_mood) + 3;
                    };
                    // column x
                    switch (g_toolbar.columns[j].align) {
                    case 0:
                        columns.mood_x = cx - 2;
                        break;
                    case 1:
                        columns.mood_x = cx + Math.round((cw - columns.mood_w) / 2) + 2;
                        break;
                    case 2:
                        columns.mood_x = cx + cw - columns.mood_w + 6;
                        break;
                    }
                    if (this.tracktype < 2) {
                        //var m_color = (this.mood != 0 ? (this.state > 0 ? g_color_highlight : RGB(255, 80, 120)) : g_color_normal_txt & 0x16ffffff);
						var m_color = (this.mood != 0 ? RGB(255, 80, 120) :  g_color_normal_txt & 0x16ffffff);
                    } else {
                        var m_color = g_color_normal_txt & 0x16ffffff;
                    }
                    if (g_font_guifx_found) {
                        gr.SetTextRenderingHint(4);
						if(this.mood != 0) gr.DrawString("v", g_font_mood_outline, RGB(205, 30, 70), columns.mood_x-1, this.y, columns.mood_w+2, cTrack.height + cTrack.parity, lc_stringformat);
                        gr.DrawString("v", g_font_mood, m_color, columns.mood_x, this.y, columns.mood_w, cTrack.height + cTrack.parity, lc_stringformat);
						if(this.mood != 0) gr.DrawString("*", gdi.Font("Arial", 10, 0), RGBA(255,255,255,240), columns.mood_x + 01, this.y - 01, columns.mood_w, cTrack.height + cTrack.parity, lc_stringformat);
                    } else {
                        gr.SetTextRenderingHint(4);
                        gr.DrawString("?", g_font_mood, m_color, columns.mood_x, this.y, columns.mood_w, cTrack.height + cTrack.parity, lc_stringformat);
                    }
                    break;
                case "rating":
                    //if (typeof (this.rating) == "undefined" || g_toolbar.TF_updated) this.rating = fields[j];
                    if (typeof (this.rating) == "undefined" || g_toolbar.TF_updated) this.rating = fb.TitleFormat(g_toolbar.columns[j].tf).EvalWithMetadb(this.metadb);
                    //if (typeof (this.rating) == "undefined" || g_toolbar.TF_updated) this.rating = g_item_cache.hit(this.metadb, g_toolbar.columns[j].tf);
                    columns.rating = true;
                    // column width
                    if (g_font_guifx_found) {
                        columns.rating_w = gr.CalcTextWidth("bbbbb", g_font_rating);
                    } else {
                        columns.rating_w = gr.CalcTextWidth("*****", g_font_rating);
                    }
                    var one_star_w = Math.round(columns.rating_w / 5);
                    var total_stars_drawable = Math.floor(cw / one_star_w);
                    if (total_stars_drawable > 5) total_stars_drawable = 5;
                    // column x
                    switch (g_toolbar.columns[j].align) {
                    case 0:
                        columns.rating_x = cx - 2 + 3;
                        break;
                    case 1:
                        columns.rating_x = cx + 3 + Math.round((cw - 6 - one_star_w * total_stars_drawable) / 2) - 1;
                        break;
                    case 2:
                        columns.rating_x = cx + 3 + cw - 6 - one_star_w * total_stars_drawable;
                        break;
                    }
                    //var rating_text_colour = this.state > 0 ? g_color_selected_txt : RGB(160,160,160);
                    var rating_text_colour = this.state > 0 ? g_color_highlight : blendColors(g_color_normal_txt, g_color_normal_bg, 0.5);
                    if (g_font_guifx_found) {
                        gr.SetTextRenderingHint(5);
                        gr.DrawString(". ".repeat(total_stars_drawable), gdi.Font("lucida console", 12, 2), this.text_colour & 0x40ffffff, columns.rating_x + 03, this.y - 1 - 02, cw + 1, cTrack.height + cTrack.parity, lc_stringformat);
                        gr.DrawString("b".repeat(Math.round(this.rating > total_stars_drawable ? total_stars_drawable : this.rating)), g_font_rating, blendColors(this.text_colour, g_color_normal_bg, 0.4), columns.rating_x, this.y - 1, cw + 1, cTrack.height + cTrack.parity, lc_stringformat);
                        if (total_stars_drawable < 5) {
                            var drawn_star_w = gr.CalcTextWidth("b".repeat(total_stars_drawable), g_font_rating) - 1;
                            gr.DrawString("...", g_font, this.text_colour, columns.rating_x + drawn_star_w, this.y - 1, columns.rating_w + 1, cTrack.height + cTrack.parity, lc_stringformat);
                        }
                    } else {
                        gr.SetTextRenderingHint(3);
                        gr.DrawString("*".repeat(total_stars_drawable), g_font_rating, this.text_colour & 0x20ffffff, columns.rating_x, this.y + 4, cw + 1, cTrack.height + cTrack.parity, lc_stringformat);
                        gr.DrawString("*".repeat(Math.round(this.rating > total_stars_drawable ? total_stars_drawable : this.rating)), g_font_rating, blendColors(this.text_colour, g_color_normal_bg, 0.4), columns.rating_x, this.y + 4, cw + 1, cTrack.height + cTrack.parity, lc_stringformat);
                        if (total_stars_drawable < 5) {
                            var drawn_star_w = gr.CalcTextWidth("*".repeat(total_stars_drawable), g_font_rating) - 1;
                            gr.DrawString("...", g_font, this.text_colour, columns.rating_x + drawn_star_w, this.y + 4, cw + 1, cTrack.height + cTrack.parity, lc_stringformat);
                        }
                    };
                    break;
                case "duration":
                    //if (typeof (this.duration) == "undefined" || g_toolbar.TF_updated) this.duration = fields[j];
                    if (typeof (this.duration) == "undefined" || g_toolbar.TF_updated) this.duration = fb.TitleFormat(g_toolbar.columns[j].tf).EvalWithMetadb(this.metadb);
                    //if (typeof (this.duration) == "undefined" || g_toolbar.TF_updated) this.duration = g_item_cache.hit(this.metadb, g_toolbar.columns[j].tf);
                    if (fb.IsPlaying) {
                        if (plman.PlayingPlaylist == this.playlist) {
                            this.nowplaying = plman.GetPlayingItemLocation();
                            if (this.track_index != this.nowplaying.PlaylistItemIndex) {
                                var tmp_duration = this.duration;
                            } else {
                                var tmp_duration = this.playing_duration;
                            }
                        }
                    } else {
                        var tmp_duration = this.duration;
                    }
                    if (typeof (tmp_duration) == "undefined") tmp_duration = fb.TitleFormat(g_toolbar.columns[j].tf).EvalWithMetadb(this.metadb);
                    try {
                        gr.GdiDrawText(tmp_duration + ' ', g_font, this.text_colour, cx, this.y, cw, this.h + cTrack.parity, g_toolbar.columns[j].DT_align | DT_CALCRECT | DT_VCENTER | DT_END_ELLIPSIS | DT_NOPREFIX);
                    } catch (e) {}
                    break;
                }
            } else {
                switch (g_toolbar.columns[j].ref) {
                case "mood":
                    columns.mood = false;
                    break;
                case "rating":
                    columns.rating = false;
                    break;
                }
            }
        }
    }

    this.draw = function (gr, x, y, w, h) {
        this.x = x;
        this.y = y;
        this.w = w;
        this.h = h;
        switch (this.type) {
        case 0:
            // draw track item
            if (cover.column) {
                cover.w = g_toolbar.columns[0].w;
                cover.h = cover.w;
            } else {
                cover.w = 0;
                cover.h = 0;
            }
            if (this.empty_row_index == 0) {
				// draw stripes of the normal row background
				if (properties.oddevenrowshighlight) {
					var parity = ((this.track_index_in_group / 2) == Math.floor(this.track_index_in_group / 2) ? 1 : 0);
					if (parity == 0) {
						gr.FillSolidRect(this.x + cover.w, this.y, this.w - cover.w, this.h, RGBA(000, 000, 000, 5));
					} else {
						gr.FillSolidRect(this.x + cover.w, this.y, this.w - cover.w, this.h, RGBA(255, 255, 255, 5));
					}
				}
                if (plman.IsPlaylistItemSelected(g_list.playlist, this.track_index)) {
                    gr.FillSolidRect(this.x + cover.w, this.y + 1*0, this.w - cover.w, this.h - 1*0, g_color_selected_bg & 0x33ffffff);
                    gr.FillSolidRect(this.x + cover.w, this.y + 1*0, this.w - cover.w, 1, g_color_normal_bg & 0x30ffffff);
                    gr.FillSolidRect(this.x + cover.w, this.y + h - 1, this.w - cover.w, 1, g_color_normal_bg & 0x30ffffff);
                    if (g_list.focusedTrackId == this.track_index) {
                        this.state = 2;
                        this.text_colour = g_color_highlight;
                        this.search_colour_bg = RGBA(255, 255, 75, 255);
                        this.search_colour_bd = RGBA(0, 0, 0, 20);
                        gr.FillSolidRect(this.x + cover.w, this.y + 1*0, this.w - cover.w, this.h - 1*0, g_color_selected_bg & 0x20ffffff);
                    } else {
                        this.state = 1;
                        this.text_colour = g_color_selected_txt;
                        this.search_colour_bg = RGBA(255, 255, 75, 255);
                        this.search_colour_bd = RGBA(0, 0, 0, 20);
                    }
                } else {
                    // if row is focused, draw focused colors & style ELSE draw with normal colors
                    if (g_list.focusedTrackId == this.track_index) {
                        this.state = 2;
                        this.text_colour = g_color_highlight;
                        this.search_colour_bg = RGBA(255, 255, 75, 255);
                        this.search_colour_bd = RGBA(0, 0, 0, 20);
                        gr.FillSolidRect(this.x + cover.w, this.y + 1*0, this.w - cover.w, this.h - 1*0, g_color_selected_bg & 0x20ffffff);
                    } else {
                        this.state = 0;
                        this.text_colour = g_color_normal_txt;
                        this.search_colour_bg = RGBA(255, 255, 75, 255);
                        this.search_colour_bd = RGBA(0, 0, 0, 20);
                    }
                }
            } else {
                /*
				// draw stripes for the empty rows
				var parity = ((this.track_index_in_group / 2) == Math.floor(this.track_index_in_group / 2)? 1 : 0);
				if(parity == 0) {
					gr.FillSolidRect(this.x + cover.w, this.y, this.w - cover.w, this.h, RGBA(000,000,000,5));
				} else {
					gr.FillSolidRect(this.x + cover.w, this.y, this.w - cover.w, this.h, RGBA(255,255,255,5));
				}
				*/
                // if last empty track of the group, draw group length info
                //if(cGroup.extra_rows > 0 && this.track_index_in_group == g_list.groups[this.group_index].count + cGroup.extra_rows - 1) {
                if (cGroup.extra_rows > 0 && this.track_index_in_group == g_list.groups[this.group_index].count) {
                    gr.gdiDrawText("Total Group Length = " + TimeFromSeconds(Math.round(g_list.groups[this.group_index].total_time_length)), gdi.Font("Arial", 10, 0), g_color_normal_txt, this.x, this.y, this.w - 010, this.h, DT_RIGHT | DT_TOP | DT_VCENTER | DT_CALCRECT | DT_NOPREFIX | DT_SINGLELINE | DT_END_ELLIPSIS);
                }
            }

            // now playing track
            if (this.empty_row_index == 0) {
                if (fb.IsPlaying) {
                    if (plman.PlayingPlaylist == plman.ActivePlaylist) {
                        this.nowplaying = plman.GetPlayingItemLocation();
                        if (this.track_index == this.nowplaying.PlaylistItemIndex) {
                            g_list.nowplaying_y = this.y;
                            this.playing_duration = tf_playback_time_remaining.Eval(true);
                            this.playing_bitrate = tf_bitrate_playing.Eval(true);
                        }
                    }
                }
            }

            // if no group header draw a thin line on the top of the 1st track of the group
            if (!properties.showgroupheaders && this.track_index_in_group == 0) {
                gr.FillGradRect(this.x, this.y, this.w, 1, 0, g_color_normal_txt & 0x01ffffff, g_color_normal_txt & 0x12ffffff, 0.5);
            }

            // ===================
            // Draw Track Contents
            // ===================
            if (this.empty_row_index == 0) {
                this.drawRowContents(gr);
            }
			
            // ==============
            // Draw cover art
            // ==============
            if (cover.column) {
                if (this.row_index == 0 && this.track_index_in_group > 0 && this.track_index_in_group <= Math.ceil(cover.h / cTrack.height)) {
                    var cover_draw_delta = this.track_index_in_group * cTrack.height;
                } else {
                    var cover_draw_delta = 0;
                }
                if ((this.track_index_in_group == 0 || (this.row_index == 0 && cover_draw_delta > 0))) {
                    // cover bg
                    var cv_x = this.x + cover.margin;
                    var cv_y = (this.y - cover_draw_delta) + cover.margin;
                    var cv_w = cover.w - cover.margin * 2;
                    var cv_h = cover.h - cover.margin * 2;
                    /*
					if(!cover.keepaspectratio) {
						gr.FillSolidRect(cv_x+1, cv_y+1, cv_w-2, cv_h-2, g_color_normal_bg);
						gr.FillSolidRect(cv_x+1, cv_y+1, cv_w-2, cv_h-2, g_color_normal_txt & 0x15ffffff);
						gr.DrawRect(cv_x, cv_y, cv_w-1, cv_h-1, 1.0, g_color_normal_txt & 0x80ffffff);
					};
					*/
                    //
					this.cover_img = g_image_cache.hit(this.metadb);
                    //
                    if (this.cover_img) {
                        if (cover.keepaspectratio) {
                            // *** check aspect ratio *** //
                            if (this.cover_img.Height >= this.cover_img.Width) {
                                var ratio = this.cover_img.Width / this.cover_img.Height;
                                var pw = cv_w * ratio;
                                var ph = cv_h;
                                this.left = Math.floor((ph - pw) / 2);
                                this.top = 0;
                                cv_x += this.left;
                                cv_y += this.top;
                                cv_w = cv_w - this.left * 2 - 1;
                                cv_h = cv_h - this.top * 2 - 1;
                            } else {
                                var ratio = this.cover_img.Height / this.cover_img.Width;
                                var pw = cv_w;
                                var ph = cv_h * ratio;
                                this.top = Math.floor((pw - ph) / 2);
                                this.left = 0;
                                cv_x += this.left;
                                cv_y += this.top;
                                cv_w = cv_w - this.left * 2 - 1;
                                cv_h = cv_h - this.top * 2 - 1;
                            };
                            // *** check aspect ratio *** //
                        };

                        // Draw Cover Art (when available)
                        if (cover.w < cover.max_w) {
                            this.cover_img = FormatCover(this.cover_img, cv_w, cv_h, false, false);
                        }
                        if (cover.keepaspectratio) {
                            gr.SetSmoothingMode(2);
                            gr.DrawRect(cv_x + 1, cv_y + 1, cv_w - 1, cv_h - 1, 4.0, RGBA(0, 0, 0, 30));
                            gr.SetSmoothingMode(0);
                            gr.DrawImage(this.cover_img, cv_x, cv_y, cv_w, cv_h, 0, 0, this.cover_img.Width, this.cover_img.Height);
                            gr.DrawRect(cv_x, cv_y, cv_w, cv_h, 1.0, RGB(255, 255, 255));
                        } else {
                            gr.SetSmoothingMode(2);
                            gr.DrawRect(cv_x + 1, cv_y + 1, cv_w - 1, cv_h - 1, 4.0, RGBA(0, 0, 0, 30));
                            gr.SetSmoothingMode(0);
                            gr.DrawImage(this.cover_img, cv_x, cv_y, cv_w, cv_h, 0, 0, this.cover_img.Width, this.cover_img.Height);
                            gr.DrawRect(cv_x, cv_y, cv_w - 1, cv_h - 1, 1.0, RGB(255, 255, 255));
                        };
                    };
                };
            };

            // if dragging items, draw line at top of the hover items to show where dragged items will be inserted on mouse button up
            if (this.empty_row_index == 0) {
                if (dragndrop.drag_in && this.ishover) {
                    if (!plman.IsPlaylistItemSelected(g_list.playlist, this.track_index)) {
                        if (this.track_index > dragndrop.drag_id) {
                            gr.FillSolidRect(this.x + cover.w, this.y + this.h - 2.0, this.w - cover.w, 2.0, g_color_highlight);
                            dragndrop.drop_id = this.track_index;
                            //} else if(this.track_index < dragndrop.drag_id && this.track_index_in_group > 0) {
                        } else if (this.track_index < dragndrop.drag_id) {
                            gr.FillSolidRect(this.x + cover.w, this.y, this.w - cover.w, 2.0, g_color_highlight);
                            dragndrop.drop_id = this.track_index;
                        };
                    };
                };
            };
            break;
        case 1:
            // draw group item
            if (!cover.column || (cover.column && this.obj.collapsed)) {
                if (this.heightInRow > 1 && cover.show) {
                    cover.h = this.heightInRow * cTrack.height;
                    cover.w = cover.h;
                } else {
                    cover.h = 10;
                    cover.w = cover.h;
                }
            } else {
                cover.h = 10;
                cover.w = cover.h;
            }
            var groupDelta = this.groupRowDelta * cTrack.height;
            if (this.album == "-") this.album = (this.obj.count > 1 ? "Singles" : "Single");
            if (this.obj.collapsed) {
                gr.FillSolidRect(this.x, (this.y - groupDelta), this.w, 1, g_color_normal_txt & 0x20ffffff);
                gr.FillSolidRect(this.x, (this.y - groupDelta) - 1 + this.h, this.w, 1, g_color_normal_txt & 0x10ffffff);
                gr.FillGradRect(this.x, (this.y - groupDelta) + 1, this.w, this.h - 2, 45, g_color_normal_txt & 0x15ffffff, 0, 1.0);
            } else {
                gr.FillSolidRect(this.x, (this.y - groupDelta), this.w, 1, g_color_normal_txt & 0x20ffffff);
                gr.FillSolidRect(this.x, (this.y - groupDelta) - 1 + this.h, this.w, 1, g_color_normal_txt & 0x25ffffff);
                gr.FillGradRect(this.x, (this.y - groupDelta) + 1, this.w, this.h - 2, 45, g_color_normal_txt & 0x15ffffff, 0, 1.0);
            }
			// draw group text infos
			var date_width = gr.CalcTextWidth(this.date, g_font) + 020;
			var genre_width = gr.CalcTextWidth(this.genre, g_font) + 020;
			var txt_width = g_list.w - cScrollbar.width - cover.w;
            switch (heightInRow) {
            case 1:
                gr.gdiDrawText(this.albumartist, g_font, blendColors(g_color_normal_txt, g_color_normal_bg, 0.5), this.x + cover.w + 1, (this.y - groupDelta), txt_width - date_width, this.h, DT_LEFT | DT_VCENTER | DT_CALCRECT | DT_NOPREFIX | DT_SINGLELINE | DT_END_ELLIPSIS);
                gr.gdiDrawText(this.albumartist + "  /  " + this.album, g_font, g_color_normal_txt, this.x + cover.w, (this.y - groupDelta), txt_width - date_width, this.h, DT_LEFT | DT_VCENTER | DT_CALCRECT | DT_NOPREFIX | DT_SINGLELINE | DT_END_ELLIPSIS);
                gr.gdiDrawText(this.date + '   ', g_font, blendColors(g_color_normal_txt, g_color_normal_bg, 0.4), this.x + cover.w, (this.y - groupDelta), txt_width, this.h, DT_RIGHT | DT_VCENTER | DT_CALCRECT | DT_NOPREFIX | DT_SINGLELINE | DT_END_ELLIPSIS);
                break;
            case 2:
                gr.gdiDrawText(this.albumartist, g_font, blendColors(g_color_normal_txt, g_color_normal_bg, 0.5), this.x + cover.w + 1, (this.y - groupDelta) + 3, txt_width - date_width, cTrack.height, DT_LEFT | DT_VCENTER | DT_CALCRECT | DT_NOPREFIX | DT_SINGLELINE | DT_END_ELLIPSIS);
                gr.gdiDrawText(this.albumartist, g_font, g_color_normal_txt, this.x + cover.w, (this.y - groupDelta) + 3, txt_width - date_width, cTrack.height, DT_LEFT | DT_VCENTER | DT_CALCRECT | DT_NOPREFIX | DT_SINGLELINE | DT_END_ELLIPSIS);
                gr.gdiDrawText(this.album, g_font, g_color_normal_txt, this.x + cover.w, (this.y + cTrack.height - groupDelta) - 4, txt_width - genre_width, cTrack.height, DT_LEFT | DT_VCENTER | DT_CALCRECT | DT_NOPREFIX | DT_SINGLELINE | DT_END_ELLIPSIS);
                gr.gdiDrawText(this.date + '   ', g_font, blendColors(g_color_normal_txt, g_color_normal_bg, 0.8), this.x + cover.w + 1, (this.y - groupDelta) + 3, txt_width, cTrack.height, DT_RIGHT | DT_VCENTER | DT_CALCRECT | DT_NOPREFIX | DT_SINGLELINE | DT_END_ELLIPSIS);
                gr.gdiDrawText(this.date + '   ', g_font, blendColors(g_color_normal_txt, g_color_normal_bg, 0.4), this.x + cover.w, (this.y - groupDelta) + 3, txt_width, cTrack.height, DT_RIGHT | DT_VCENTER | DT_CALCRECT | DT_NOPREFIX | DT_SINGLELINE | DT_END_ELLIPSIS);
                gr.gdiDrawText(this.genre + '   ', g_font, blendColors(g_color_normal_txt, g_color_normal_bg, 0.6), this.x + cover.w, (this.y + cTrack.height - groupDelta) - 4, txt_width, cTrack.height, DT_RIGHT | DT_VCENTER | DT_CALCRECT | DT_NOPREFIX | DT_SINGLELINE | DT_END_ELLIPSIS);
                break;
            default:
                gr.gdiDrawText(this.albumartist, g_font, blendColors(g_color_normal_txt, g_color_normal_bg, 0.5), this.x + cover.w + 1, (this.y - groupDelta) + 3, txt_width - date_width, cTrack.height, DT_LEFT | DT_VCENTER | DT_CALCRECT | DT_NOPREFIX | DT_SINGLELINE | DT_END_ELLIPSIS);
                gr.gdiDrawText(this.albumartist, g_font, g_color_normal_txt, this.x + cover.w, (this.y - groupDelta) + 3, txt_width - date_width, cTrack.height, DT_LEFT | DT_VCENTER | DT_CALCRECT | DT_NOPREFIX | DT_SINGLELINE | DT_END_ELLIPSIS);
                gr.gdiDrawText(this.album, g_font, g_color_normal_txt, this.x + cover.w, (this.y + cTrack.height - groupDelta) - 4, txt_width - genre_width, cTrack.height, DT_LEFT | DT_VCENTER | DT_CALCRECT | DT_NOPREFIX | DT_SINGLELINE | DT_END_ELLIPSIS);
                gr.FillGradRect(this.x + cover.w, (this.y + cTrack.height * 2 - groupDelta) - 3, txt_width - 010, 1, 0, blendColors(g_color_highlight, g_color_normal_bg, 0.7), 0, 0.85);
                gr.gdiDrawText(this.obj.count + (this.obj.count > 1 ? " tracks - " : " track - ") + this.obj.total_group_duration_txt, g_font, blendColors(g_color_normal_txt, g_color_normal_bg, 0.4), this.x + cover.w, (this.y + cTrack.height * 2 - groupDelta) - 2, this.w - cover.w - 010, cTrack.height, DT_LEFT | DT_TOP | DT_VCENTER | DT_CALCRECT | DT_NOPREFIX | DT_SINGLELINE | DT_END_ELLIPSIS);
                gr.gdiDrawText(this.date + '   ', g_font, blendColors(g_color_normal_txt, g_color_normal_bg, 0.8), this.x + cover.w + 1, (this.y - groupDelta) + 3, txt_width, cTrack.height, DT_RIGHT | DT_VCENTER | DT_CALCRECT | DT_NOPREFIX | DT_SINGLELINE | DT_END_ELLIPSIS);
                gr.gdiDrawText(this.date + '   ', g_font, blendColors(g_color_normal_txt, g_color_normal_bg, 0.4), this.x + cover.w, (this.y - groupDelta) + 3, txt_width, cTrack.height, DT_RIGHT | DT_VCENTER | DT_CALCRECT | DT_NOPREFIX | DT_SINGLELINE | DT_END_ELLIPSIS);
                gr.gdiDrawText(this.genre + '   ', g_font, blendColors(g_color_normal_txt, g_color_normal_bg, 0.6), this.x + cover.w, (this.y + cTrack.height - groupDelta) - 4, txt_width, cTrack.height, DT_RIGHT | DT_VCENTER | DT_CALCRECT | DT_NOPREFIX | DT_SINGLELINE | DT_END_ELLIPSIS);
            }
            // highlight the now playing group header
            if (fb.IsPlaying) {
                if (plman.PlayingPlaylist == this.playlist) {
                    this.nowplaying = plman.GetPlayingItemLocation();
                    if (this.nowplaying.PlaylistItemIndex >= this.obj.start && this.nowplaying.PlaylistItemIndex < this.obj.start + this.obj.count) {
                        gr.FillSolidRect(this.x, (this.y - groupDelta), this.w, this.h, g_color_highlight & 0x33ffffff);
                        gr.FillSolidRect(this.x, (this.y - groupDelta), this.w, 1, RGBA(255, 255, 255, 30));
                    }
                }
            }
            // highlight group that contains a selected track
            for (var k = 0; k < this.obj.count; k++) {
                if (plman.IsPlaylistItemSelected(g_list.playlist, this.obj.start + k)) {
                    gr.FillSolidRect(this.x, (this.y - groupDelta), this.w, this.h, g_color_selected_bg & 0x33ffffff);
                    gr.FillSolidRect(this.x, (this.y - groupDelta), this.w, 1, RGBA(255, 255, 255, 30));
                    break;
                }
            }

            // ==============
            // Draw cover art
            // ==============
            if (!cover.column || (cover.column && this.obj.collapsed)) {
                if (this.heightInRow > 1 && cover.show) {
                    // cover bg
                    var cv_x = this.x + cover.margin;
                    var cv_y = (this.y - groupDelta) + cover.margin;
                    var cv_w = cover.w - cover.margin * 2;
                    var cv_h = cover.h - cover.margin * 2;
                    /*
					if(!cover.keepaspectratio) {
						gr.FillSolidRect(cv_x+1, cv_y+1, cv_w-2, cv_h-2, g_color_normal_bg);
						gr.FillSolidRect(cv_x+1, cv_y+1, cv_w-2, cv_h-2, g_color_normal_txt & 0x15ffffff);
						gr.DrawRect(cv_x, cv_y, cv_w-1, cv_h-1, 1.0, g_color_normal_txt & 0x80ffffff);
					};
					*/
                    //
                    this.cover_img = g_image_cache.hit(this.metadb);
                    //
                    if (this.cover_img) {
                        if (cover.keepaspectratio) {
                            // *** check aspect ratio *** //
                            if (this.cover_img.Height >= this.cover_img.Width) {
                                var ratio = this.cover_img.Width / this.cover_img.Height;
                                var pw = cv_w * ratio;
                                var ph = cv_h;
                                this.left = Math.floor((ph - pw) / 2);
                                this.top = 0;
                                cv_x += this.left;
                                cv_y += this.top;
                                cv_w = cv_w - this.left * 2 - 1;
                                cv_h = cv_h - this.top * 2 - 1;
                            } else {
                                var ratio = this.cover_img.Height / this.cover_img.Width;
                                var pw = cv_w;
                                var ph = cv_h * ratio;
                                this.top = Math.floor((pw - ph) / 2);
                                this.left = 0;
                                cv_x += this.left;
                                cv_y += this.top;
                                cv_w = cv_w - this.left * 2 - 1;
                                cv_h = cv_h - this.top * 2 - 1;
                            };
                            // *** check aspect ratio *** //
                        };

                        // Draw Cover Art (when available)
                        if (cover.column) {
                            if (cover.w < g_toolbar.columns[0].w) {
                                this.cover_img = FormatCover(this.cover_img, cv_w, cv_h, false, false);
                            }
                        } else {
                            if (cGroup.expanded_height > cGroup.collapsed_height) {
                                if (this.obj.collapsed) {
                                    this.cover_img = FormatCover(this.cover_img, cv_w, cv_h, false, false);
                                }
                            } else if (cGroup.expanded_height < cGroup.collapsed_height) {
                                if (!this.obj.collapsed) {
                                    this.cover_img = FormatCover(this.cover_img, cv_w, cv_h, false, false);
                                }
                            }
                        }
                        if (cover.keepaspectratio) {
                            gr.SetSmoothingMode(2);
                            gr.DrawRect(cv_x + 1, cv_y + 1, cv_w - 1, cv_h - 1, 4.0, RGBA(0, 0, 0, 30));
                            gr.SetSmoothingMode(0);
                            gr.DrawImage(this.cover_img, cv_x, cv_y, cv_w, cv_h, 0, 0, this.cover_img.Width, this.cover_img.Height);
                            gr.DrawRect(cv_x, cv_y, cv_w, cv_h, 1.0, RGB(255, 255, 255));
                        } else {
                            gr.SetSmoothingMode(2);
                            gr.DrawRect(cv_x + 1, cv_y + 1, cv_w - 1, cv_h - 1, 4.0, RGBA(0, 0, 0, 30));
                            gr.SetSmoothingMode(0);
                            gr.DrawImage(this.cover_img, cv_x, cv_y, cv_w, cv_h, 0, 0, this.cover_img.Width, this.cover_img.Height);
                            gr.DrawRect(cv_x, cv_y, cv_w - 1, cv_h - 1, 1.0, RGB(255, 255, 255));
                        };
                    };
                };
            };

            // if dragging items, draw line at top of the hover items to show where dragged items will be inserted on mouse button up
            if (dragndrop.drag_in && this.ishover && g_list.ishover) {
                if (!plman.IsPlaylistItemSelected(plman.ActivePlaylist, this.track_index)) {
                    if (this.track_index <= dragndrop.drag_id) {
                        gr.FillSolidRect(this.x, this.y, this.w, 2.0, g_color_highlight);
                        if (this.obj.collapsed) {
                            dragndrop.drop_id = this.track_index;
                        } else {
                            dragndrop.drop_id = this.track_index;
                        }
                    } else {
                        if (this.obj.collapsed) {
                            gr.FillSolidRect(this.x, this.y + this.h - 2.0, this.w, 2.0, g_color_highlight);
                            dragndrop.drop_id = this.track_index + this.obj.count - 1;
                        } else {
                            gr.FillSolidRect(this.x, this.y + this.h - 2.0, this.w, 2.0, g_color_highlight);
                            dragndrop.drop_id = this.track_index;
                        }
                    }
                }
            }
            break;
        }
    }

    this.check = function (event, x, y) {
        var groupDelta = this.groupRowDelta * cTrack.height;
        this.ishover = (x >= this.x && x < this.x + this.w && y >= this.y && y < this.y + this.h - groupDelta);

        var prev_rating_hover = this.rating_hover;
        var prev_l_rating = this.l_rating;
        var prev_mood_hover = this.mood_hover;
        var prev_l_mood = this.l_mood;
        this.rating_hover = (this.type == 0 && this.empty_row_index == 0 && x >= columns.rating_x && x <= columns.rating_x + columns.rating_w && y > this.y + 2 && y < this.y + this.h - 2);
        this.mood_hover = (this.type == 0 && this.empty_row_index == 0 && x >= columns.mood_x && x <= columns.mood_x + columns.mood_w - 3 && y > this.y + 2 && y < this.y + this.h - 2);

        switch (event) {
        case "down":
            if (this.ishover) {
                if (this.type == 1) { // group header
                    if (utils.IsKeyPressed(VK_SHIFT)) {
                        if (g_list.focusedTrackId != this.track_index) {
                            if (g_list.SHIFT_start_id != null) {
                                g_list.selectAtoB(g_list.SHIFT_start_id, this.track_index + this.obj.count - 1);
                            } else {
                                g_list.selectAtoB(g_list.focusedTrackId, this.track_index + this.obj.count - 1);
                            };
                        };
                    } else if (utils.IsKeyPressed(VK_CONTROL)) {
                        plman.SetPlaylistFocusItem(g_list.playlist, this.track_index);
                        g_list.selectGroupTracks(this.group_index, true);
                        g_list.SHIFT_start_id = null;
                    } else {
                        plman.SetPlaylistFocusItem(g_list.playlist, this.track_index);
                        plman.ClearPlaylistSelection(g_list.playlist);
                        if ((properties.autocollapse && !this.obj.collapsed) || !properties.autocollapse) {
                            g_list.selectGroupTracks(this.group_index, true);
                        }
                        g_list.SHIFT_start_id = null;
						g_list.metadblist_selection = plman.GetPlaylistSelectedItems(g_list.playlist);

                        if (g_list.metadblist_selection.Count >= 1) {
                            dragndrop.drag_out = true;
                            dragndrop.drag_id = this.track_index;
                            if (!isQueuePlaylistActive()) {
                                dragndrop.timerID = window.SetTimeout(function () {
                                    dragndrop.drag_in = true;
                                    dragndrop.timerID && window.ClearTimeout(dragndrop.timerID);
                                    dragndrop.timerID = false;
                                }, 250);
                            };
                        };

                    };
                    if (properties.autocollapse) {
                        if (this.obj.collapsed) {
                            g_list.updateGroupStatus(this.group_index);
                        }
                    }
                    g_list.metadblist_selection = plman.GetPlaylistSelectedItems(g_list.playlist);
                } else { // track
                    if (this.rating_hover) {
                        columns.rating_drag = true;
                    } else if (this.mood_hover) {
                        columns.mood_drag = true;
                    } else {
                        if (plman.IsPlaylistItemSelected(g_list.playlist, this.track_index)) {
                            if (this.ishover) {
                                if (g_list.metadblist_selection.Count >= 1) {
                                    dragndrop.drag_out = true;
                                    if (g_list.metadblist_selection.Count > 1) {
                                        // test if selection is contigus, if not, drag'n drop disable
                                        var first_item_selected_id = g_list.handleList.Find(g_list.metadblist_selection.item(0));
                                        var last_item_selected_id = g_list.handleList.Find(g_list.metadblist_selection.item(g_list.metadblist_selection.Count - 1));
                                        var contigus_count = (last_item_selected_id - first_item_selected_id) + 1;
                                    } else {
                                        var contigus_count = 0;
                                    };
                                    if (g_list.metadblist_selection.Count == 1 || g_list.metadblist_selection.Count == contigus_count) {
                                        dragndrop.drag_id = this.track_index;
                                        if (!isQueuePlaylistActive()) {
                                            dragndrop.timerID = window.SetTimeout(function () {
                                                dragndrop.drag_in = true;
                                                dragndrop.timerID && window.ClearTimeout(dragndrop.timerID);
                                                dragndrop.timerID = false;
                                            }, 250);
                                        };
                                    };
                                };
                                if (utils.IsKeyPressed(VK_SHIFT)) {
                                    if (g_list.focusedTrackId != this.track_index) {
                                        if (g_list.SHIFT_start_id != null) {
                                            g_list.selectAtoB(g_list.SHIFT_start_id, this.track_index);
                                        } else {
                                            g_list.selectAtoB(g_list.focusedTrackId, this.track_index);
                                        };
                                    };
                                } else if (utils.IsKeyPressed(VK_CONTROL)) {
                                    //if(plman.GetPlaylistFocusItemIndex(g_list.playlist) != this.track_index) {
                                    plman.SetPlaylistSelectionSingle(g_list.playlist, this.track_index, false);
                                    //};
                                } else if (g_list.metadblist_selection.Count == 1) {
                                    plman.SetPlaylistFocusItem(g_list.playlist, this.track_index);
                                    plman.ClearPlaylistSelection(g_list.playlist);
                                    plman.SetPlaylistSelectionSingle(g_list.playlist, this.track_index, true);
                                };
                            };
                        } else { // click on a not selected track
							if (utils.IsKeyPressed(VK_SHIFT)) {
								if (g_list.focusedTrackId != this.track_index) {
									if (g_list.SHIFT_start_id != null) {
										g_list.selectAtoB(g_list.SHIFT_start_id, this.track_index);
									} else {
										g_list.selectAtoB(g_list.focusedTrackId, this.track_index);
									};
								};
							} else if (utils.IsKeyPressed(VK_CONTROL)) {
								g_list.selX = x;
								g_list.selY = y;
								g_list.drawRectSel = true;
								g_list.selStartId = this.track_index;
								g_list.selStartOffset = g_list.offset;
								g_list.selEndOffset = g_list.offset;
								g_list.selDeltaRows = 0;
								g_list.selAffected.splice(0, g_list.selAffected.length);
								
								plman.SetPlaylistFocusItem(g_list.playlist, this.track_index);
								plman.SetPlaylistSelectionSingle(g_list.playlist, this.track_index, true);
								g_list.SHIFT_start_id = null;
							} else {
								g_list.selX = x;
								g_list.selY = y;
								g_list.drawRectSel = true;
								g_list.selStartId = this.track_index;
								g_list.selStartOffset = g_list.offset;
								g_list.selEndOffset = g_list.offset;
								g_list.selDeltaRows = 0;
								g_list.selAffected.splice(0, g_list.selAffected.length);
								
								plman.SetPlaylistFocusItem(g_list.playlist, this.track_index);
								plman.ClearPlaylistSelection(g_list.playlist);
								plman.SetPlaylistSelectionSingle(g_list.playlist, this.track_index, true);
								
								g_list.SHIFT_start_id = null;
							};
                        };
                        g_list.metadblist_selection = plman.GetPlaylistSelectedItems(g_list.playlist);
                    }
                }
            }
            break;
        case "dblclk":
            if (this.ishover) {
                if (this.type == 1) { // group header
                    if (properties.autocollapse) {
                        /*
						if(this.obj.collapsed) {
							g_list.updateGroupStatus(this.group_index);
						} else {
							g_list.updateGroupsOnCollapse(this.group_index);
						}
						*/
                    } else {
                        if (this.obj.collapsed) {
                            g_list.updateGroupsOnExpand(this.group_index);
                        } else {
                            g_list.updateGroupsOnCollapse(this.group_index);
                        }
                    }
                    g_list.setItems(false);
                    g_list.Repaint();
                } else { // track
                    plman.ExecutePlaylistDefaultAction(g_list.playlist, this.track_index);
                }
            }
            break;
        case "up":
            if (this.ishover) {
                if (this.rating_hover) {
                    // Rating
                    if (this.tracktype < 2) {
                        if (foo_playcount) {
                            // Rate to database statistics brought by foo_playcount.dll
                            if (this.l_rating != this.rating) {
                                if (this.metadb) {
                                    var bool = fb.RunContextCommandWithMetadb("Rating/" + ((this.l_rating == 0) ? "<not set>" : this.l_rating), this.metadb);
                                    this.rating = this.l_rating;
                                };
                            } else {
                                var bool = fb.RunContextCommandWithMetadb("Rating/<not set>", this.metadb);
                                this.rating = 0;
                            };
                        } else {
                            // Rate to file
                            if (this.l_rating != this.rating) {
                                if (this.metadb) {
                                    var bool = this.metadb.UpdateFileInfoSimple("RATING", this.l_rating);
                                    this.rating = this.l_rating;
                                };
                            } else {
                                var bool = this.metadb.UpdateFileInfoSimple("RATING", "");
                                this.rating = 0;
                            };
                        };
                    };
                } else if (this.mood_hover) {
                    // Mood
                    if (this.tracktype < 2) {
                        // tag to file
                        if (this.l_mood != this.mood) {
                            if (this.metadb) {
                                var bool = this.metadb.UpdateFileInfoSimple("MOOD", getTimestamp());
                                this.mood = this.l_mood;
                            };
                        } else {
                            var bool = this.metadb.UpdateFileInfoSimple("MOOD", "");
                            this.mood = 0;
                        };
                    };
                } else {
                    if (!g_list.drawRectSel && plman.IsPlaylistItemSelected(g_list.playlist, this.track_index)) {
                        if (!utils.IsKeyPressed(VK_SHIFT) && !utils.IsKeyPressed(VK_CONTROL)) {
                            if (!dragndrop.drag_in) {
                                if (this.type == 0) { // track
                                    plman.SetPlaylistFocusItem(g_list.playlist, this.track_index);
                                    plman.ClearPlaylistSelection(g_list.playlist);
                                    plman.SetPlaylistSelectionSingle(g_list.playlist, this.track_index, true);
                                };
                            };
                            dragndrop.timerID && window.ClearTimeout(dragndrop.timerID);
                            dragndrop.timerID = false;
                            dragndrop.drag_in = false;
                            dragndrop.drag_out = false;
                        };
                    };
                };
            };
            columns.rating_drag = false;
            columns.mood_drag = false;
            break;
        case "right":
            if (this.ishover) {
                if (this.type == 1) { // group header
                    if (!plman.IsPlaylistItemSelected(g_list.playlist, this.track_index)) {
                        plman.ClearPlaylistSelection(g_list.playlist);
                        plman.SetPlaylistFocusItem(g_list.playlist, this.track_index);
                        g_list.selectGroupTracks(this.group_index, true);
                        g_list.SHIFT_start_id = null;
                    }
                    g_list.context_menu(x, y, this.track_index, this.row_index);
                } else { // track
                    if (this.rating_hover) {

                    } else if (this.mood_hover) {

                    } else {
                        if (plman.IsPlaylistItemSelected(g_list.playlist, this.track_index)) {

                        } else {
                            plman.SetPlaylistFocusItem(g_list.playlist, this.track_index);
                            plman.ClearPlaylistSelection(g_list.playlist);
                            plman.SetPlaylistSelectionSingle(g_list.playlist, this.track_index, true);
                        };
                        g_list.context_menu(x, y, this.track_index, this.row_index);
                    }
                }
            }
            break;
		case "move":
            if(columns.rating && !columns.rating_drag) {
                if(this.rating_hover) {
                    this.l_rating = Math.floor((x - columns.rating_x) / (g_font_guifx_found?14:12)) + 1;
                    if(this.l_rating>5) this.l_rating = 5;
                } else {
                    this.l_rating = 0;
                };
            };
            if(columns.mood && !columns.mood_drag) {
                if(this.mood_hover) {
                    this.l_mood = 1;
                } else {
                    this.l_mood = 0;
                };
            }
			// update tooltip text
			if(this.tooltip && this.ishover) {
				g_tooltip_txt = this.title;
			}
			
			// update on mouse move to draw RECT Selection zone
			if (g_list.drawRectSel) {
							
				if(this.ishover) {
					if(this.type == 0) { // track
						g_list.selEndId = this.track_index;
					} else { // group header
						if(this.track_index > 0) {
							if(g_list.selStartId < g_list.selEndId) {
								if(this.track_index == this.track_index + 1) {
									g_list.selEndId = this.track_index - 0;
								} else {
									g_list.selEndId = this.track_index - 1;
								}
							} else if(g_list.selStartId > g_list.selEndId) {
								if(this.track_index == this.track_index + 1) {
									g_list.selEndId = this.track_index - 1;
								} else {
									g_list.selEndId = this.track_index - 0;
								}
							}
						}
					}
				}
				if(!cList.repaint_timer) {
					cList.repaint_timer = window.SetInterval(function() {
						if(mouse_y < g_list.y + cTrack.height * 0) {
							g_list.selEndId = g_list.selEndId > 0 ? g_list.items[0].track_index : 0;
							g_list.scrollItems(1, 1);
						} else if(mouse_y > g_list.y + g_list.h - cTrack.height * 0) {
							g_list.selEndId = g_list.selEndId < g_list.count - 1 ? g_list.items[g_list.items.length - 1].track_index : g_list.count - 1;
							g_list.scrollItems(-1, 1);
						}
						// set selection on items in the rect area drawn
						plman.SetPlaylistSelection(g_list.playlist, g_list.selAffected, false);
						g_list.selAffected.splice(0, g_list.selAffected.length);
						var deb = g_list.selStartId <= g_list.selEndId ? g_list.selStartId : g_list.selEndId;
						var fin = g_list.selStartId <= g_list.selEndId ? g_list.selEndId : g_list.selStartId;
						for(var i = deb; i <= fin ;i++) {
							g_list.selAffected.push(i);
						};
						plman.SetPlaylistSelection(g_list.playlist, g_list.selAffected, true);
						g_list.metadblist_selection = plman.GetPlaylistSelectedItems(g_list.playlist);
						plman.SetPlaylistFocusItem(g_list.playlist, g_list.selEndId);
						//
						g_list.selEndOffset = g_list.offset;
					}, 60);
				}
			}
			break;
        case "leave":

            break;
        }
    }
}

oList = function(playlist, group_key) {
	this.playlist = playlist;
	this.focusedTrackId = plman.GetPlaylistFocusItemIndex(this.playlist);
	this.artist_key = fb.TitleFormat("%artist%");
	this.group_key = group_key;
	this.handleList = plman.GetPlaylistItems(this.playlist);
	this.count = this.handleList.Count;
	this.artists = {};
	this.groups = Array();
	this.items = Array();
	this.scrollstep = 3;
	this.metadblist_selection = plman.GetPlaylistSelectedItems(this.playlist);
    this.SHIFT_start_id = null;
    this.SHIFT_count = 0;
	this.ishover = false;
	this.buttonclicked = false;
	this.selAffected = Array();
    
	this.getTotalRows = function() {
		var ct = 0;
		var cv = 0;
		for(var i = 0; i < this.groups.length; i++) {
			this.groups[i].totalPreviousRows += ct;
			this.groups[i].totalPreviousTracks += cv;
			if(this.groups[i].collapsed) {
				ct += cGroup.collapsed_height;
			} else {
				ct += this.groups[i].count + cGroup.expanded_height;
				ct += this.groups[i].rowsToAdd;
			}
			cv += this.groups[i].count;
			cv += this.groups[i].rowsToAdd;
		}
		return ct;
    }
    
    this.updateGroupsOnCollapse = function(group_id) {
		if(!this.groups[group_id].collapsed) {
			var delta = (this.groups[group_id].count + this.groups[group_id].rowsToAdd) + (cGroup.expanded_height - cGroup.collapsed_height); 
			for(var i = group_id + 1; i < this.groups.length; i++) {
				this.groups[i].totalPreviousRows -= delta;
			}
			this.totalRows -= delta;
			if(this.totalRows <= this.totalRowVisible) {
				this.offset = 0;
			} else {
				if(this.totalRows - this.offset < this.totalRowVisible) {
					this.offset = this.totalRows - this.totalRowVisible;
				}
			}
			this.groups[group_id].collapsed = true;
		}
	}
    
    this.updateGroupsOnExpand = function(group_id) {
		if(this.groups[group_id].collapsed) {
			var delta = (this.groups[group_id].count + this.groups[group_id].rowsToAdd) + (cGroup.expanded_height - cGroup.collapsed_height); 
			for(var i = group_id + 1; i < this.groups.length; i++) {
				this.groups[i].totalPreviousRows += delta;
			}
			this.totalRows += delta;
			this.groups[group_id].collapsed = false;
		}
	}
	
	this.updateGroupStatus = function(group_id) {
		// collapse previous group of focused track
		if(properties.autocollapse) {
			this.updateGroupsOnCollapse(g_group_id_focused);
		}
		// expand new group of the current focused track (new one)
		this.updateGroupsOnExpand(group_id);
		// update current group id of focused track
		g_group_id_focused = group_id;
	}
   
    this.init_groups = function() {
		var handle;
		var current;
		var artist_read;
		var artist_arr = [];
		var previous;
		var count = 0;
		var start = 0;
		var total_time_length = 0;
		var global_time = 0;

		//var d1 = new Date();
		//var t1 = d1.getSeconds()*1000 + d1.getMilliseconds();

		this.groups.splice(0, this.groups.length);
		//this.artists = {};
		for(var i = 0; i < this.count; i++) {
			handle = this.handleList.Item(i);
			current =  this.group_key.EvalWithMetadb(handle);
			
			// fill artist list array
			/*
			artist_read = this.artist_key.EvalWithMetadb(handle);
			if (this.artists[artist_read] != artist_read) {
				artist_arr.push({
					'name': artist_read
					,
					'value': artist_read
				});
				this.artists[artist_read] = artist_read;
			}
			*/
			
			if(i == 0) {
				if(this.count == 1) {
					count++;
					total_time_length += handle.Length;
					global_time += handle.Length;
					this.groups.push(new oGroup(this.groups.length, start, count, total_time_length, this.focusedTrackId));
				} else {
					previous = current;
				}
			} else {
				if(current != previous || i == this.count - 1) {
					if(current != previous) {
						if(i == this.count - 1) {
							this.groups.push(new oGroup(this.groups.length, start, count, total_time_length, this.focusedTrackId));
							start = i;
							count = 1;
							total_time_length = handle.Length;
							//global_time += handle.Length;
							this.groups.push(new oGroup(this.groups.length, start, count, total_time_length, this.focusedTrackId));
						} else {
							this.groups.push(new oGroup(this.groups.length, start, count, total_time_length, this.focusedTrackId));
						}
					} else {
						total_time_length += handle.Length;
						this.groups.push(new oGroup(this.groups.length, start, count + 1, total_time_length, this.focusedTrackId));
					}
					count = 0;
					total_time_length = 0;
					start = i;
					previous = current;
				}
			}
			count++;
			total_time_length += handle.Length;
			global_time += handle.Length;
		}
		// calc total rows for this total handles + groups
		this.totalRows = this.getTotalRows();
		
		// total seconds playlist for playlist header panel
		g_total_duration_text = formatPlaylistTotalDurationText(global_time);

		//var d2 = new Date();
		//var t2 = d2.getSeconds()*1000 + d2.getMilliseconds();
		//fb.trace("init groups delay = "+Math.round(t2 - t1)+" /handleList count="+this.count);
		
		// sort artists list array
		//artist_arr.sort(function(a, b) { return (a.name.localeCompare(b.name)); });
		/*
		var cnt = 0;
		for (var name in artist_arr) {
			fb.trace("artist = "+artist_arr[name].name);
			cnt++;
		} 
		fb.trace("total artists = "+cnt);
		*/
		
		//var d3 = new Date();
		//var t3 = d3.getSeconds()*1000 + d3.getMilliseconds();
		//fb.trace("init groups delay 2 = "+Math.round(t3 - t2));
    }
  
	this.sortObject = function(obj) {
		var arr = [];
		for (var prop in obj) {
			if (obj.hasOwnProperty(prop)) {
				arr.push({
					'name': prop,
					'value': obj[prop]
				});
			}
		}
		arr.sort(function(a, b) { return (a.name.localeCompare(b.name)); });
		return arr; // returns array
	}
  
    this.updateHandleList = function(playlist) {
		this.playlist = playlist;
		if(plman.PlaylistItemCount(this.playlist) > 0) {
			this.focusedTrackId = plman.GetPlaylistFocusItemIndex(this.playlist);
		} else {
			this.focusedTrackId = -1;
		}
		if(this.handleList) this.handleList.Dispose();
		this.handleList = plman.GetPlaylistItems(this.playlist);
		this.count = this.handleList.Count;
		this.init_groups();
		this.getStartOffsetFromFocusId();
    }
    
    this.setSize = function(x, y, w, h) {
		this.x = x;
		this.y = y;
		this.w = w;
		this.h = h;
		this.totalRowVisible = Math.floor(this.h / cTrack.height);
		this.totalRowToLoad = this.totalRowVisible + 1;
    }
	
	this.selectAtoB = function(start_id, end_id) {

		var affectedItems = Array();
		
		if(this.SHIFT_start_id == null) {
			this.SHIFT_start_id = start_id;
		};
		
		plman.ClearPlaylistSelection(this.playlist);
		
		var previous_focus_id = this.focusedTrackId;
		
		if(start_id < end_id) {
			var deb = start_id;
			var fin = end_id;
		} else {
			var deb = end_id;
			var fin = start_id;        
		};

		for(var i = deb; i <= fin ;i++) {
			affectedItems.push(i);
		};
		plman.SetPlaylistSelection(this.playlist, affectedItems, true);
		
		plman.SetPlaylistFocusItem(this.playlist, end_id);
		
		if(affectedItems.length > 1) {
			if(end_id > previous_focus_id) {
				var delta = end_id - previous_focus_id;
				this.SHIFT_count += delta;
			} else {
				var delta = previous_focus_id - end_id;
				this.SHIFT_count -= delta;
			};
		};
	}

	this.selectGroupTracks = function(gp_id, state) {
		var affectedItems = Array();
		var first_trk = this.groups[gp_id].start;
		var total_trks = this.groups[gp_id].count;
		for(var i = first_trk; i < first_trk + total_trks; i++) {
			affectedItems.push(i);
		}
		plman.SetPlaylistSelection(this.playlist, affectedItems, state);
	}
	
	this.showNowPlaying = function() {
		if(fb.IsPlaying) {
			if(plman.PlayingPlaylist != this.playlist) {
				plman.ActivePLaylist = plman.PlayingPlaylist;
				this.playlist = plman.ActivePLaylist;
				this.nowplaying = plman.GetPlayingItemLocation();
				// set focus on the now playing item
				plman.SetPlaylistFocusItem(this.playlist, this.nowplaying.PlaylistItemIndex);
			} else {
				this.nowplaying = plman.GetPlayingItemLocation();
				// set focus on the now playing item
				plman.SetPlaylistFocusItem(this.playlist, this.nowplaying.PlaylistItemIndex);
				this.setItems(!g_list.isFocusedItemVisible());
				this.Repaint();
			}
		}
	}
	
	this.showFocusedItem = function() {
		this.setItems(true);
		this.Repaint();
	}
    
    this.getStartOffsetFromFocusId = function() {
		var mid = Math.floor(this.totalRowToLoad / 2) - 1;
		if(plman.PlaylistItemCount(this.playlist) > 0) {
			this.focusedTrackId = plman.GetPlaylistFocusItemIndex(this.playlist);
		} else {
			this.focusedTrackId = -1;
		}
		if(this.focusedTrackId < 0) {
			this.offset = 0;
			return this.offset;
		}	
		
		this.focusedRowId = this.getRowId(this.focusedTrackId);
			
		if(this.totalRows > this.totalRowVisible) {
			if(this.focusedRowId <= mid) {
				this.offset = 0;
			} else {
				var d = this.totalRows - (this.focusedRowId + 1);
				if(d >= Math.floor(this.totalRowToLoad / 2)) {
					this.offset = this.focusedRowId - mid;
				} else {				
					this.offset = this.totalRows - this.totalRowVisible;
				}
			}
			if(this.offset < 0) this.offset = 0;
		} else {
			this.offset = 0;
		}
		return this.offset;
    }
    
    this.getGroupIdfromTrackId = function(valeur) {
		var mediane = 0; var deb = 0; var fin = this.groups.length - 1;
		while(deb <= fin){
			mediane = Math.floor((fin + deb)/2);
			if(valeur >= this.groups[mediane].start && valeur < this.groups[mediane].start + this.groups[mediane].count) {
				return mediane;
			} else if(valeur < this.groups[mediane].start) {
				fin = mediane - 1;
			} else {
				deb = mediane + 1;
			}
		}
		return -1;
    }
	
    this.getGroupIdFromRowId = function(valeur) {
		var mediane = 0; var deb = 0; var fin = this.groups.length - 1;
		while(deb <= fin){
			mediane = Math.floor((fin + deb)/2);
			grp_height = this.groups[mediane].collapsed ? cGroup.collapsed_height : cGroup.expanded_height;
			grp_size = this.groups[mediane].collapsed ? grp_height : grp_height + this.groups[mediane].count + this.groups[mediane].rowsToAdd;
			if(valeur >= this.groups[mediane].totalPreviousRows && valeur < this.groups[mediane].totalPreviousRows + grp_size) {
				return mediane;
			} else if(valeur < this.groups[mediane].totalPreviousRows) {
				fin = mediane - 1;
			} else {
				deb = mediane + 1;
			}
		}
		return -1;
    }
    
    this.getRowId = function(trackId) {
		var grp_id = this.getGroupIdfromTrackId(trackId);
		if(this.groups[grp_id].collapsed) { // track hidden in the collapsed group so return = -1 or we return the row id of the group it belongs to ?
			//var row_index = -1;
			var row_index = this.groups[grp_id].totalPreviousRows + 1;
		} else { // group expanded so we can return a valid row_id for the track searched
			var row_index = this.groups[grp_id].totalPreviousRows + cGroup.expanded_height + (trackId - this.groups[grp_id].start);
		}
		return row_index;
    }

    this.getTrackId = function(rowId) {
		this.s_group_id = this.getGroupIdFromRowId(rowId);
		if(this.s_group_id >= 0) {
			this.s_group_height = this.groups[this.s_group_id].collapsed ? cGroup.collapsed_height : cGroup.expanded_height;
			if(this.groups[this.s_group_id].collapsed) {
				var a = rowId - this.groups[this.s_group_id].totalPreviousRows;
				this.s_groupheader_line_id = a;
				this.s_track_id = this.groups[this.s_group_id].start;
			} else {
				var a = rowId - this.groups[this.s_group_id].totalPreviousRows;
				if(a < this.s_group_height) { // row is in the group header
					this.s_groupheader_line_id = a;
					this.s_track_id = this.groups[this.s_group_id].start;
				} else { // row is a track
					this.s_groupheader_line_id = -1;
					this.s_track_id = (a - this.s_group_height) + this.groups[this.s_group_id].start;
					var track_index_in_group = this.s_track_id - this.groups[this.s_group_id].start;
					if(track_index_in_group >= this.groups[this.s_group_id].count) { // track is a copy of the last track of the group to fill the group with minimum track count in group feature!
						this.s_delta = (track_index_in_group - this.groups[this.s_group_id].count) + 1;
						this.s_track_id -= this.s_delta;
					} else {
						this.s_delta = 0;
					}
				}
			}
			return this.s_track_id;
		} else {
			return 0;
		}
    }
	
	this.scrollItems = function(delta, scrollstep) {
		if(delta > 0) { // scroll up
			this.offset -= scrollstep;
			if(this.offset < 0) this.offset = 0;		
		} else { // scroll down
			this.offset += scrollstep;
			if(this.offset > this.totalRows - this.totalRowVisible) {
				this.offset = this.totalRows - this.totalRowVisible;
			}
		}
		this.setItems(false);
		g_scrollbar.setCursor(g_list.totalRowVisible, g_list.totalRows, g_list.offset);
		if(!g_list.drawRectSel) this.Repaint();
	}
	
	   
    this.setItems = function(forceFocus) {
		var track_index_in_group = 0;
		var row_index = 0;
		if(forceFocus) { // from focus item centered in panel
			if(this.totalRows > this.totalRowVisible) {			
				var i = this.getStartOffsetFromFocusId();
				if(this.totalRows - this.offset <= this.totalRowVisible) {
					var total_rows_to_draw = this.totalRows < this.totalRowVisible ? this.totalRows : this.totalRowVisible;
				} else {
					var total_rows_to_draw = this.totalRows < this.totalRowToLoad ? this.totalRows : this.totalRowToLoad;
				}
				this.items.splice(0, this.items.length);
				while(i < this.offset + total_rows_to_draw) {
					this.getTrackId(i);
					if(this.s_groupheader_line_id >= 0) { // group header
						this.items.push(new oItem(this.playlist, row_index, 1, this.handleList.Item(this.s_track_id), this.s_track_id, this.s_group_id, 0, this.s_group_height, this.s_groupheader_line_id, this.groups[this.s_group_id], 0));
						i += this.s_group_height - this.s_groupheader_line_id;
						row_index += this.s_group_height - this.s_groupheader_line_id;
					} else { // track row
						//row_index ++;
						track_index_in_group = this.s_track_id - this.groups[this.s_group_id].start + this.s_delta;
						this.items.push(new oItem(this.playlist, row_index, 0, this.handleList.Item(this.s_track_id), this.s_track_id, this.s_group_id, track_index_in_group, 1, 0, null, this.s_delta));
						i++;
						row_index++;
					}
				}
			} else {
				this.offset = 0;
				var i = 0;	// offset = 0	
				this.items.splice(0, this.items.length);
				while(i < this.totalRows) {
					this.getTrackId(i);
					if(this.s_groupheader_line_id >= 0) { // group header
						this.items.push(new oItem(this.playlist, row_index, 1, this.handleList.Item(this.s_track_id), this.s_track_id, this.s_group_id, 0, this.s_group_height, this.s_groupheader_line_id, this.groups[this.s_group_id], 0));
						i += this.s_group_height - this.s_groupheader_line_id;
						row_index += this.s_group_height - this.s_groupheader_line_id;
					} else { // track row
						track_index_in_group = this.s_track_id - this.groups[this.s_group_id].start + this.s_delta;
						this.items.push(new oItem(this.playlist, row_index, 0, this.handleList.Item(this.s_track_id), this.s_track_id, this.s_group_id, track_index_in_group, 1, 0, null, this.s_delta));
						i++;
						row_index++;
					}
				}
			}  
		} else { // fill items from current offset
			if(this.totalRows > this.totalRowVisible) {
				if(typeof(this.offset)=="undefined") {
					this.getStartOffsetFromFocusId();
					//fb.trace("... undefined");
				}
				var i = this.offset;			
				if(this.totalRows - this.offset <= this.totalRowVisible) {
					var total_rows_to_draw = this.totalRows < this.totalRowVisible ? this.totalRows : this.totalRowVisible;
				} else {
					var total_rows_to_draw = this.totalRows < this.totalRowToLoad ? this.totalRows : this.totalRowToLoad;
				}
				this.items.splice(0, this.items.length);
				while(i < this.offset + total_rows_to_draw) {
					this.getTrackId(i);
					if(this.s_groupheader_line_id >= 0) { // group header
						this.items.push(new oItem(this.playlist, row_index, 1, this.handleList.Item(this.s_track_id), this.s_track_id, this.s_group_id, 0, this.s_group_height, this.s_groupheader_line_id, this.groups[this.s_group_id], 0));
						i += this.s_group_height - this.s_groupheader_line_id;
						row_index += this.s_group_height - this.s_groupheader_line_id;
					} else { // track row
						track_index_in_group = this.s_track_id - this.groups[this.s_group_id].start + this.s_delta;
						this.items.push(new oItem(this.playlist, row_index, 0, this.handleList.Item(this.s_track_id), this.s_track_id, this.s_group_id, track_index_in_group, 1, 0, null, this.s_delta));
						i++;
						row_index++;
					}
				}
			} else {
				var i = 0;	// offset = 0	
				this.items.splice(0, this.items.length);
				while(i < this.totalRows) {
					this.getTrackId(i);
					if(this.s_groupheader_line_id >= 0) { // group header
						this.items.push(new oItem(this.playlist, row_index, 1, this.handleList.Item(this.s_track_id), this.s_track_id, this.s_group_id, 0, this.s_group_height, this.s_groupheader_line_id, this.groups[this.s_group_id], 0));
						i += this.s_group_height - this.s_groupheader_line_id;
						row_index += this.s_group_height - this.s_groupheader_line_id;
					} else { // track row
						track_index_in_group = this.s_track_id - this.groups[this.s_group_id].start + this.s_delta;
						this.items.push(new oItem(this.playlist, row_index, 0, this.handleList.Item(this.s_track_id), this.s_track_id, this.s_group_id, track_index_in_group, 1, 0, null, this.s_delta));
						i++;
						row_index++;
					}
				}
			}
		}
	}
		
	this.getOffsetFromCursorPos = function() {
		var r = (this.cursorPos / this.h);
		this.offset = Math.round(r * this.totalRows);
	}
	
	this.isFocusedItemVisible = function() {
		if(this.totalRows <= this.totalRowVisible) {
			return true;
		} else {
			// if on last item of the playlist, check if last row is focused // if not, avoid last row because it's not a visible row by default
			var gape = this.focusedTrackId == this.count - 1 ? 0 : 1;
			for(var i = 0; i < this.items.length - gape; i++) {
				//if((this.items[i].type == 0 && this.items[i].empty_row_index == 0) || (this.groups[this.items[i].group_index].collapsed && this.items[i].type == 1)) {
				if((this.items[i].type == 0 && this.items[i].empty_row_index == 0) || this.groups[this.items[i].group_index].collapsed) {
					if(this.groups[this.items[i].group_index].collapsed) {
						if(this.focusedTrackId >= this.groups[this.items[i].group_index].start && this.focusedTrackId < this.groups[this.items[i].group_index].start + this.groups[this.items[i].group_index].count) {
							return true;
						}
					} else if(this.focusedTrackId == this.items[i].track_index) {
						return true;
					}
				}
			}
		}
		return false;
	}
    
    this.draw = function(gr) {
		var item_h = 0;
		var row_top_y = this.y;
		var width = 0;
		// Draw items (tracks and group headers)
		for(var i = 0; i < this.items.length; i++) {
			item_h = this.items[i].heightInRow * cTrack.height;
			// test if scrollbar displayed or not for the items width to draw
			if(this.totalRows <= this.totalRowVisible || !properties.showscrollbar) {
				width = this.w;
			} else {
				width = this.w - cScrollbar.width;
			}
			this.items[i].draw(gr, this.x, row_top_y, width, item_h);
			row_top_y += item_h - (this.items[i].groupRowDelta * cTrack.height);
		}
		// reset boolean after a repaint done after a TF update in a column of the toolbar
		this.TF_updated = false;
		// redraw top thin line on top to fix a glitch on repaint g_liste on Toolbar area (bot)
		gr.FillSolidRect(this.x, this.y - 1, this.w + cScrollbar.width, 1, g_syscolor_button_bg);
		// Draw rect selection
		if (this.drawRectSel) {
			this.selDeltaRows = this.selEndOffset - this.selStartOffset;
			if (this.selX <= mouse_x) {
				if (this.selY - this.selDeltaRows*cTrack.height <= mouse_y) {
					gr.FillSolidRect(this.selX, (this.selY - this.selDeltaRows*cTrack.height), mouse_x - this.selX, mouse_y - (this.selY - this.selDeltaRows*cTrack.height), g_color_highlight & 0x16ffffff);
					gr.DrawRect(this.selX, (this.selY - this.selDeltaRows*cTrack.height), mouse_x - this.selX - 1, mouse_y - (this.selY - this.selDeltaRows*cTrack.height) - 1, 1.0, g_color_highlight & 0x48ffffff);
				} else {
					gr.FillSolidRect(this.selX, mouse_y, mouse_x - this.selX, this.selY - mouse_y - this.selDeltaRows*cTrack.height, g_color_highlight & 0x16ffffff);
					gr.DrawRect(this.selX, mouse_y, mouse_x - this.selX - 1, this.selY - mouse_y - this.selDeltaRows*cTrack.height - 1, 1.0, g_color_highlight & 0x48ffffff);
				}
			} else {
				if (this.selY - this.selDeltaRows*cTrack.height <= mouse_y) {
					gr.FillSolidRect(mouse_x, (this.selY - this.selDeltaRows*cTrack.height), this.selX - mouse_x, mouse_y - (this.selY - this.selDeltaRows*cTrack.height), g_color_highlight & 0x16ffffff);
					gr.DrawRect(mouse_x, (this.selY - this.selDeltaRows*cTrack.height), this.selX - mouse_x - 1, mouse_y - (this.selY - this.selDeltaRows*cTrack.height) - 1, 1.0, g_color_highlight & 0x48ffffff);
				} else {
					gr.FillSolidRect(mouse_x, mouse_y, this.selX - mouse_x, this.selY - mouse_y - this.selDeltaRows*cTrack.height, g_color_highlight & 0x16ffffff);
					gr.DrawRect(mouse_x, mouse_y, this.selX - mouse_x - 1, this.selY - mouse_y - this.selDeltaRows*cTrack.height - 1, 1.0, g_color_highlight & 0x48ffffff);
				}
			}
		
		}
    }
    
    this.Repaint = function() {
        window.RepaintRect(this.x, this.y, this.w, this.h);
    }
	
	this.check = function(event, x, y) {
		this.ishover = (x > this.x && x < this.x + this.w && y > this.y && y < this.y + this.h);
		switch(event) {
			case "up":
				for(var i = 0; i < this.items.length; i++) {
					this.items[i].check(event, x, y);
				}
				g_list.drawRectSel = false;
				// kill timer on rect area refresh for "drawRectSel"
				cList.repaint_timer && window.ClearInterval(cList.repaint_timer);
				cList.repaint_timer = false;
				break;
			default:
				for(var i = 0; i < this.items.length; i++) {
					this.items[i].check(event, x, y);
				}			
		}
	}
	
	this.incrementalSearch = function() {
		var count = 0;
		var albumartist;
		var chr;
		var gstart;
		var pid = -1;
		
		// exit if no search string in cache
		if(cList.search_string.length <= 0) return true;
		
		// 1st char of the search string
		var first_chr = cList.search_string.substring(0,1);  
		var len = cList.search_string.length;
		
		// which start point for the search
		if(this.count > 1000) {
			albumartist = tf_albumartist.EvalWithMetadb(this.handleList.Item(Math.floor(this.count / 2)));
			chr = albumartist.substring(0,1);
			if(first_chr.charCodeAt(first_chr) > chr.charCodeAt(chr)) {
				gstart = Math.floor(this.count / 2);
			} else {
				gstart = 0;
			}
		} else {
			gstart = 0;
		}

		var format_str = "";
		for(var i=gstart; i < this.count; i++) {
			albumartist = tf_albumartist.EvalWithMetadb(this.handleList.Item(i));
			format_str = albumartist.substring(0,len).toUpperCase();
			if(format_str == cList.search_string) {
				pid = i;
				break;
			}
		}
		
		if(pid >= 0) { // found!
			this.focusedTrackId = pid;
			plman.ClearPlaylistSelection(this.playlist);
			plman.SetPlaylistSelectionSingle(this.playlist, this.focusedTrackId, true);
			plman.SetPlaylistFocusItem(this.playlist, this.focusedTrackId);
			
			this.showFocusedItem();

			if (properties.autocollapse) {
				var grpId = g_list.getGroupIdfromTrackId(this.focusedTrackId);
				if(grpId >= 0 && this.groups[grpId].collapsed) {
					g_list.updateGroupStatus(grpId);
					g_list.setItems(false);
					var center_focus_item = g_list.isFocusedItemVisible();
				}
			}
			
		} else {
			this.inc_search_noresult = true;
			this.Repaint();
		}
		
		cList.clear_incsearch_timer && window.ClearInterval(cList.clear_incsearch_timer);
		cList.clear_incsearch_timer = window.SetInterval(function () {
			// reset incremental search string after 1 seconds without any key pressed
			cList.search_string = "";
			window.Repaint();
			cList.clear_incsearch_timer && window.ClearInterval(cList.clear_incsearch_timer);
			cList.clear_incsearch_timer = false;
			this.inc_search_noresult = false;
		}, 1000);
	}

	this.context_menu = function(x, y, id, row_id) {
		var _menu = window.CreatePopupMenu();
		var Context = fb.CreateContextMenuManager();
		var _child01 = window.CreatePopupMenu();
		var _child02 = window.CreatePopupMenu();
		
		this.metadblist_selection = plman.GetPlaylistSelectedItems(this.playlist);
		Context.InitContext(this.metadblist_selection);
		
		_menu.AppendMenuItem(MF_STRING, 1, "Settings...");
		_menu.AppendMenuSeparator();
		Context.BuildMenu(_menu, 2, -1);
	   
		_child01.AppendTo(_menu, MF_STRING, "Selection...");
		_child01.AppendMenuItem(fb.IsAutoPlaylist(this.playlist)?MF_DISABLED|MF_GRAYED:MF_STRING, 1000, "Remove");
		_child02.AppendTo(_child01, MF_STRING, "Send to...");
		_child02.AppendMenuItem(MF_STRING, 2000, "a New playlist...");
		if(plman.PlaylistCount>1) {
			_child02.AppendMenuItem(MF_SEPARATOR, 0, "");
		}
		var pl_count = plman.PlaylistCount;
		for(var i=0;i<pl_count;i++) {
			if(i!=this.playlist && !fb.IsAutoPlaylist(i)) {
				_child02.AppendMenuItem(MF_STRING, 2001+i, plman.GetPlaylistName(i));
			}
		}

		var ret = _menu.TrackPopupMenu(x, y);
		if(ret > 1 && ret < 800) {
			Context.ExecuteByID(ret - 2);
		} else if(ret<2) {
			switch (ret) {
			case 1:
				//properties.settingspanel = true;
				//window.Repaint();
				window.ShowProperties();
				break;
			}
		} else {
			switch (ret) {
			case 1000:
				plman.RemovePlaylistSelection(this.playlist, false);
				break;
			case 2000:
				fb.RunMainMenuCommand("File/New playlist");
				plman.InsertPlaylistItems(plman.PlaylistCount-1, 0, this.metadblist_selection, false);
				break;
			default:
				var insert_index = plman.PlaylistItemCount(ret-2001);
				plman.InsertPlaylistItems((ret-2001), insert_index, this.metadblist_selection, false);
			}
		}
		_child01.Dispose();
		_child02.Dispose();
		_menu.Dispose();
		return true;
	}
}
